SystemOrganization addCategory: 'OrbeonFormProcess'!

Exception subclass: #OrbeonBridgeException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

OrbeonBridgeException subclass: #BrokenVersionChainException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

OrbeonBridgeException subclass: #CanNotModifyPathDefinitionException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

OrbeonBridgeException subclass: #CategoryWithNoNameException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

OrbeonBridgeException subclass: #EvaluationNotBlockException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

OrbeonBridgeException subclass: #EvaluationNotBooleanException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

OrbeonBridgeException subclass: #InvalidFieldNameException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!InvalidFieldNameException commentStamp: '' prior: 0!
This class is usend since an OrbeonFormProcess can evaluate combined expression coming from more than one form.
Check 
OrbeonFormProcess>>doesNotUnderstand:

OrbeonFormProcess now check in all finished OrbeonFormInstances to look a proper field name.
This enable to evaluate expression coming from more than one form like:

[:proc | (proc type = 'building') and: [proc number = '789456']] value: anOrbeonFormProcess.

Where <type> and <number> are fields of different OrbeonFormInstaces. This is a great advantage but it has a down side, that is keyword message of OrbeonFormProcess can NOT be used as form field names. 

Because OrbeonFormProcess will answer the actual value of the message instead the value of the any form.

The list of invalid field names is:

(OrbeonFormProcess instVarNamed: 'methDicts') keys reject: [:e | e includes: $:]!

OrbeonBridgeException subclass: #NoExecuteTransitionException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

OrbeonBridgeException subclass: #NoProcessNameException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

OrbeonBridgeException subclass: #PathConditionEvaluationException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

OrbeonBridgeException subclass: #PathNodeNotExistException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

OrbeonObject subclass: #OrbeonBlockAnalysis
	instanceVariableNames: 'blockCode codeWarnings parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!OrbeonBlockAnalysis class methodsFor: 'other' stamp: 'BrunoBB 05/22/2015 06:45'!
example1

	^(super new blockCode: '[:form | MyClass resetAll. form class removeAll]')
		analyze
		codeWarnings.! !

!OrbeonBlockAnalysis class methodsFor: 'other' stamp: 'BrunoBB 05/22/2015 06:45'!
example2

	^(super new blockCode: '[:form | form age > 10 and:[form amount = 3 or:[form type = ''28'']]. Compiler compile: ''lajdflasj'']')
		analyze
		codeWarnings.! !

!OrbeonBlockAnalysis class methodsFor: 'other' stamp: 'BrunoBB 05/21/2015 06:40'!
for: blockCode

	^super new initialize
		blockCode: blockCode;
		yourself! !

!OrbeonBlockAnalysis methodsFor: 'other' stamp: 'BrunoBB 05/21/2015 06:48'!
addBlockWarning: aString

	^codeWarnings add: aString! !

!OrbeonBlockAnalysis methodsFor: 'other' stamp: 'BrunoBB 06/13/2015 16:17'!
analyze

	parser isBlock ifFalse: [^self addBlockWarning: 'Condition is NOT a Block'].

	self checkOneArgumentBlockRule; "check the block has only one argument"
		checkReceiverVariableRule; "check that receivers that are variable node are the block argument"
		checkReceiverVariableMessagesRule! !

!OrbeonBlockAnalysis methodsFor: 'Accessing' stamp: 'BrunoBB 05/21/2015 06:32'!
blockCode
	^blockCode! !

!OrbeonBlockAnalysis methodsFor: 'Updating' stamp: 'BrunoBB 06/13/2015 16:14'!
blockCode: newValue

	blockCode := newValue.
	parser := [RBParser parseExpression: blockCode] on: Error do: [:err | self addBlockWarning: err description].! !

!OrbeonBlockAnalysis methodsFor: 'other' stamp: 'BrunoBB 06/13/2015 16:12'!
checkOneArgumentBlockRule
	"Receiver's block must be a ONE argument block"

	(parser arguments size = 0) 
	ifTrue: [^self addBlockWarning: 'Block has no argument'].

	(parser arguments size > 1) 
	ifTrue: [^self addBlockWarning: 'Block has more than one argument'].! !

!OrbeonBlockAnalysis methodsFor: 'other' stamp: 'BrunoBB 06/13/2015 17:08'!
checkReceiverVariableMessagesRule
	"All messages sent to Block's argument MUST be NOT understand by <OrbeonFormProcess> and <OrbeonFormInstance>.
	Inside the block messages are sent only to fields of <OrbeonFormInstance> or <OrbeonFormProcess> and this messages are dispatched using #doesNotUnderstand:. 
	So inside the block message to the argument MUST fail "
	| atomicMessages argumentName notPerfomMessages perfomMessages |

	"<atomicMessages> MUST have the receiver equal to Block argument"
	atomicMessages := parser allChildren select: [:each | each isMessage and: [each receiver isVariable]].

	notPerfomMessages := atomicMessages reject: [:each | each selector = #perform:].
	perfomMessages := atomicMessages select: [:each | each selector = #perform:].

	(notPerfomMessages select: [:each | (OrbeonFormInstance canUnderstand: each selector) 
													or: [OrbeonFormProcess canUnderstand: each selector]]) 
		do: [:each | self addBlockWarning: 'Valid message [', each selector,'] is sent to Form or Process.'].

	"Check form #perform: with more that one argument, NOT allowed only a string with a field name is allowed for message #perform: "
	(perfomMessages select: [:each | each arguments size > 1]) do: [:each | self addBlockWarning: 'Perform message sent with more than one argument.'].

	"Check for suspicious string as argument of #perform: message, more than one string (subString: space) as argument of #perform: NOT allowed"
	(perfomMessages select: [:each | (each arguments size = 1) and: [each arguments last token isLiteralToken and: [(each arguments last value subStrings: ' ') size > 1]]]) do: [:each | self addBlockWarning: 'Suspicious string inside #perform: message']! !

!OrbeonBlockAnalysis methodsFor: 'other' stamp: 'BrunoBB 05/21/2015 07:37'!
checkReceiverVariableRule
	"All basic receivers (receiver isVariable) MUST send message only to Block argument.
	If a message is sent to a <variable receiver> and this <variable receiver> is not the block argument then it can be malicious code or an error"
	| atomicMessages argumentName |

	"<atomicMessages> MUST have the receiver equal to Block argument"
	atomicMessages := parser allChildren select: [:each | each isMessage and: [each receiver isVariable]].

	argumentName := parser arguments last name.

	(atomicMessages select: [:each | each receiver name ~= argumentName]) 
	do: [:each | self addBlockWarning: 'Message is sent to object [', each receiver name, '] that is NOT the argument of the Block.' ]! !

!OrbeonBlockAnalysis methodsFor: 'Accessing' stamp: 'BrunoBB 05/21/2015 06:32'!
codeWarnings
	^codeWarnings! !

!OrbeonBlockAnalysis methodsFor: 'Updating' stamp: 'BrunoBB 05/21/2015 06:32'!
codeWarnings: newValue
	codeWarnings := newValue! !

!OrbeonBlockAnalysis methodsFor: 'other' stamp: 'BrunoBB 05/21/2015 06:34'!
hasWarinings

	^codeWarnings notEmpty! !

!OrbeonBlockAnalysis methodsFor: 'other' stamp: 'BrunoBB 05/21/2015 06:33'!
initialize

	super initialize.
	
	codeWarnings := OrderedCollection new.! !

!OrbeonBlockAnalysis methodsFor: 'Accessing' stamp: 'BrunoBB 05/21/2015 06:41'!
parser
	^parser! !

!OrbeonBlockAnalysis methodsFor: 'Updating' stamp: 'BrunoBB 05/21/2015 06:41'!
parser: newValue
	parser := newValue! !

OrbeonObject subclass: #OrbeonEvaluationResult
	instanceVariableNames: 'result exception'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!OrbeonEvaluationResult class methodsFor: 'other' stamp: 'BrunoBB 03/14/2015 16:12'!
exception: anException

	^super new initialize
		exception: anException;
		result: false;
		yourself! !

!OrbeonEvaluationResult class methodsFor: 'other' stamp: 'BrunoBB 03/14/2015 16:12'!
result: aBoolean

	^super new initialize
		result: aBoolean;
		yourself! !

!OrbeonEvaluationResult methodsFor: 'Accessing' stamp: 'BrunoBB 03/13/2015 15:58'!
exception

   "Return the value of the instance variable 'exception'."
   ^exception! !

!OrbeonEvaluationResult methodsFor: 'Updating' stamp: 'BrunoBB 03/14/2015 16:17'!
exception: newValue
   "Modify the value of the instance variable 'exception'."

	exception := newValue.
	result := false.! !

!OrbeonEvaluationResult methodsFor: 'other' stamp: 'BrunoBB 03/14/2015 16:28'!
hasException

	^exception notNil! !

!OrbeonEvaluationResult methodsFor: 'other' stamp: 'BrunoBB 03/14/2015 16:36'!
hasNoException

	^exception isNil! !

!OrbeonEvaluationResult methodsFor: 'Accessing' stamp: 'BrunoBB 03/13/2015 15:58'!
result

   "Return the value of the instance variable 'result'."
   ^result! !

!OrbeonEvaluationResult methodsFor: 'Updating' stamp: 'BrunoBB 03/13/2015 15:58'!
result: newValue

   "Modify the value of the instance variable 'result'."
   result := newValue! !

!OrbeonEvaluationResult methodsFor: 'other' stamp: 'BrunoBB 03/14/2015 16:37'!
resultNotBoolean

	^(result isKindOf: Boolean) not! !

OrbeonObject subclass: #OrbeonFailedEvaluation
	instanceVariableNames: 'object exception objectCollection condition timeStamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

OrbeonFailedEvaluation class
	instanceVariableNames: 'Cache'!

!OrbeonFailedEvaluation class methodsFor: 'other' stamp: 'BrunoBB 03/14/2015 16:43'!
cache

	Cache ifNil: [Cache := OrderedCollection new].

	^Cache! !

!OrbeonFailedEvaluation class methodsFor: 'other' stamp: 'BrunoBB 03/14/2015 16:43'!
initializeCache

	Cache := OrderedCollection new! !

!OrbeonFailedEvaluation class methodsFor: 'other' stamp: 'BrunoBB 03/14/2015 16:43'!
object: anObject exception: anException collection: aCollection

	^(self object: anObject exception: anException)
		collection: aCollection;
		yourself! !

!OrbeonFailedEvaluation class methodsFor: 'other' stamp: 'BrunoBB 03/14/2015 16:46'!
object: anObject exception: anException condition: aString

	^super new initialize
		object: anObject;
		exception: anException;
		condition: aString;
		yourself! !

!OrbeonFailedEvaluation methodsFor: 'Accessing' stamp: 'BrunoBB 03/14/2015 16:43'!
condition

   "Return the value of the instance variable 'condition'."
   ^condition! !

!OrbeonFailedEvaluation methodsFor: 'Updating' stamp: 'BrunoBB 03/14/2015 16:43'!
condition: newValue

   "Modify the value of the instance variable 'condition'."
   condition := newValue! !

!OrbeonFailedEvaluation methodsFor: 'Accessing' stamp: 'BrunoBB 03/14/2015 16:43'!
exception

   "Return the value of the instance variable 'exception'."
   ^exception! !

!OrbeonFailedEvaluation methodsFor: 'Updating' stamp: 'BrunoBB 03/14/2015 16:43'!
exception: newValue

   "Modify the value of the instance variable 'exception'."
   exception := newValue! !

!OrbeonFailedEvaluation methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 14:05'!
initialize

	super initialize.

	timeStamp := TimeStamp now.! !

!OrbeonFailedEvaluation methodsFor: 'Accessing' stamp: 'BrunoBB 03/14/2015 16:43'!
object

   "Return the value of the instance variable 'object'."
   ^object! !

!OrbeonFailedEvaluation methodsFor: 'Updating' stamp: 'BrunoBB 03/14/2015 16:43'!
object: newValue

   "Modify the value of the instance variable 'object'."
   object := newValue! !

!OrbeonFailedEvaluation methodsFor: 'Accessing' stamp: 'BrunoBB 03/14/2015 16:43'!
objectCollection

   "Return the value of the instance variable 'objectCollection'."
   ^objectCollection! !

!OrbeonFailedEvaluation methodsFor: 'Updating' stamp: 'BrunoBB 03/14/2015 16:43'!
objectCollection: newValue

   "Modify the value of the instance variable 'objectCollection'."
   objectCollection := newValue! !

!OrbeonFailedEvaluation methodsFor: 'Accessing' stamp: 'BrunoBB 04/28/2015 05:38'!
timeStamp
	^timeStamp! !

!OrbeonFailedEvaluation methodsFor: 'Updating' stamp: 'BrunoBB 04/28/2015 05:38'!
timeStamp: newValue
	timeStamp := newValue! !

OrbeonObject subclass: #OrbeonFormPathCondition
	instanceVariableNames: 'condition conditions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

OrbeonFormPathCondition subclass: #OFNodeCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

OFNodeCondition subclass: #OFNodeEndCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

OFNodeCondition subclass: #OFNodeStartCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

OrbeonFormPathCondition subclass: #OFRuntimeCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

OrbeonFormPathCondition subclass: #OFTransitionCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

OFTransitionCondition subclass: #OFTransitionCreationCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!OrbeonFormPathCondition class methodsFor: 'other' stamp: 'BrunoBB 09/14/2014 15:26'!
fromString: aString

	^super new initialize
		condition: aString;
		yourself! !

!OrbeonFormPathCondition methodsFor: 'Accessing' stamp: 'BrunoBB 09/14/2014 15:11'!
condition

   "Return the value of the instance variable 'condition'."
   ^condition! !

!OrbeonFormPathCondition methodsFor: 'Updating' stamp: 'BrunoBB 09/14/2014 15:11'!
condition: newValue

   "Modify the value of the instance variable 'condition'."
   condition := newValue! !

!OrbeonFormPathCondition methodsFor: 'other' stamp: 'BrunoBB 09/14/2014 11:32'!
conditionIsEmpty

	^condition isNil or:[condition isEmpty]! !

!OrbeonFormPathCondition methodsFor: 'Accessing' stamp: 'BrunoBB 09/14/2014 15:11'!
conditions

   "Return the value of the instance variable 'conditions'."
   ^conditions! !

!OrbeonFormPathCondition methodsFor: 'Updating' stamp: 'BrunoBB 09/14/2014 15:11'!
conditions: newValue

   "Modify the value of the instance variable 'conditions'."
   conditions := newValue! !

!OrbeonFormPathCondition methodsFor: 'Accessing' stamp: 'BrunoBB 03/14/2015 16:48'!
conditionString

   "Return the value of the instance variable 'condition'."
   ^condition! !

!OrbeonFormPathCondition methodsFor: 'other' stamp: 'BrunoBB 03/14/2015 06:54'!
evaluateIn: anObject
	"The receiver evaluates the condition <condition> in the context of the object <anObject>.
	If the evaluation throw an exception the answer <false>"
	| evaluation blockClosure blockEvaluation |

	evaluation := OrbeonEvaluationResult new.
	[	blockClosure := self evaluate: condition.
		blockEvaluation := blockClosure value: anObject.
		evaluation result: blockEvaluation] on: Error do:[:err | evaluation exception: err].

	"evaluation does not raised anException but the result is NOT a boolean value"
	(evaluation hasNoException and: [evaluation resultNotBoolean]) 
	ifTrue: [evaluation exception: EvaluationNotBooleanException new].
	"the variable <blockClosure> MUST BE a BlockClosure because the <condition> could be a valid Smalltalk expression"
	blockClosure isBlock
	ifFalse: [evaluation exception: EvaluationNotBlockException new].

	^evaluation! !

!OrbeonFormPathCondition methodsFor: 'other' stamp: 'BrunoBB 04/28/2015 06:30'!
evaluateIn: anOrbeonFormProcess form: anOrbeonFormInstance
	"The receiver evaluates the condition <condition> in the context of the object <anOrbeonFormInstance> and then <anOrbeonFormProcess>.
	1- Evaluate the block with <anOrbeonFormInstance> in most cases is simple evaluation (all evaluation fields are in <anOrbeonFormInstance>).
	2- If an error arise then evaluate in the context of the process <anOrbeonFormProcess> a distributed evaluation (fields are distributed in different forms of the process <anOrbeonFormProcess>).
	3- If the two evaluations throw an exception then answer <false>"
	| evaluation blockClosure blockEvaluation |

	evaluation := OrbeonEvaluationResult new.
	[	blockClosure := self evaluate: condition.
		blockEvaluation := blockClosure value: anOrbeonFormInstance. "we evalute if is a simple statement <anOrbeonFormInstance>"
		evaluation result: blockEvaluation] 
	on: Error do:[:errFirst | 
		[blockEvaluation := blockClosure value: anOrbeonFormProcess. "distributed statement <anOrbeonFormProcess>"
		evaluation result: blockEvaluation] on: Error do: [:errorSecond | evaluation exception: errorSecond]].

	"evaluation does not raised anException but the result is NOT a boolean value"
	(evaluation hasNoException and: [evaluation resultNotBoolean]) 
	ifTrue: [evaluation exception: EvaluationNotBooleanException new].
	"the variable <blockClosure> MUST BE a BlockClosure because the <condition> could be a valid Smalltalk expression but NOT a block"
	blockClosure isBlock
	ifFalse: [evaluation exception: EvaluationNotBlockException new].

	^evaluation! !

!OrbeonFormPathCondition methodsFor: 'other' stamp: 'BrunoBB 09/14/2014 15:11'!
initialize

	super initialize.

	conditions := OrderedCollection new.
	condition := ''

"Condition:
	'[:orbeonInst | orbeonInst loanAmount > 500]'
"

"Evaluation:
(self evaluate: condition) value: anOrbeonFormInstance.

(self evaluate: '[:orbeonInst | orbeonInst loanAmount > 500]') value: anOrbeonFormInstance.
"! !

!OrbeonFormPathCondition methodsFor: 'other' stamp: 'BrunoBB 09/28/2014 15:16'!
isEmpty

	^self conditionIsEmpty! !

!OrbeonFormPathCondition methodsFor: 'other' stamp: 'BrunoBB 12/28/2014 12:08'!
notEmpty

	^self conditionIsEmpty not! !

OrbeonObject subclass: #OrbeonFormPathDefinition
	instanceVariableNames: 'transitions processDefinition startNode endNode startNodes endNodes startSubProcessNodes endSubProcessNodes gatewayNodes formsLoopTypes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!OrbeonFormPathDefinition commentStamp: 'BrunoBB 01/23/2015 05:16' prior: 0!
This class define the configuration of a path in an OrbeonFormProcessDefinition. Each OrbeonFormProcessDefinition has it's OrbeonFormPathDefinition.

transitions 				- transitions of the receiver from one node to another.
nodes 						- nodes of the path, two per each transition (start, end)
processDefinition		- the process definition that own's this path
startNode 				- the start node of the path
endNode					- the end node of the path!

!OrbeonFormPathDefinition class methodsFor: 'other' stamp: 'BrunoBB 01/27/2015 04:45'!
on: anOrbeonFormProcessDefinition

	^super new 
		processDefinition: anOrbeonFormProcessDefinition; 
		yourself! !

!OrbeonFormPathDefinition methodsFor: 'execution path' stamp: 'BrunoBB 01/27/2015 04:45'!
addEndNode: anOrbeonFormPathNode
	"Add a node <anOrbeonFormPathNode> to the receiver. 
	Each node has one OrbeonFormDefinition. If the form definition of the node is nil --> is an end or start node"

	^endNodes at: anOrbeonFormPathNode formDefinition put: anOrbeonFormPathNode! !

!OrbeonFormPathDefinition methodsFor: 'execution path' stamp: 'BrunoBB 04/08/2015 05:58'!
addEndSubProcessNode: anOrbeonSubProcessNode
	"Add a node <anOrbeonFormPathNode> to the receiver. 
	Each node has one OrbeonFormDefinition. If the form definition of the node is nil --> is an end or start node"

	^endSubProcessNodes at: anOrbeonSubProcessNode nodeName put: anOrbeonSubProcessNode! !

!OrbeonFormPathDefinition methodsFor: 'execution path' stamp: 'BrunoBB 04/08/2015 05:58'!
addGatewayNode: aProcessGatewayNode
	"Add a node <anOrbeonFormPathNode> to the receiver. 
	Each node has one OrbeonFormDefinition. If the form definition of the node is nil --> is an end or start node"

	^gatewayNodes at: aProcessGatewayNode nodeName put: aProcessGatewayNode! !

!OrbeonFormPathDefinition methodsFor: 'other' stamp: 'BrunoBB 06/16/2015 07:40'!
addLoopType: loopType toFormNamed: aString

	^formsLoopTypes at: aString put: loopType! !

!OrbeonFormPathDefinition methodsFor: 'execution path' stamp: 'BrunoBB 01/27/2015 04:45'!
addStartNode: anOrbeonFormPathNode
	"Add a node <anOrbeonFormPathNode> to the receiver. 
	Each node has one OrbeonFormDefinition. If the form definition of the node is nil --> is an end or start node"

	^startNodes at: anOrbeonFormPathNode formDefinition put: anOrbeonFormPathNode! !

!OrbeonFormPathDefinition methodsFor: 'execution path' stamp: 'BrunoBB 04/08/2015 05:59'!
addStartSubProcessNode: anOrbeonSubProcessNode
	"Add a node <anOrbeonFormPathNode> to the receiver. 
	Each node has one OrbeonFormDefinition. If the form definition of the node is nil --> is an end or start node"

	^startSubProcessNodes at: anOrbeonSubProcessNode nodeName put: anOrbeonSubProcessNode! !

!OrbeonFormPathDefinition methodsFor: 'other' stamp: 'BrunoBB 01/27/2015 04:45'!
addToPath: anOrbeonFormTransitionDefinition
	"Adds to the receiver the transition <anOrbeonFormTransitionDefinition>"

	anOrbeonFormTransitionDefinition pathDefinition: self.
	^transitions add: anOrbeonFormTransitionDefinition! !

!OrbeonFormPathDefinition methodsFor: 'other' stamp: 'BrunoBB 01/27/2015 04:45'!
applicationDefinitions

	^processDefinition applicationDefinitions! !

!OrbeonFormPathDefinition methodsFor: 'other' stamp: 'BrunoBB 09/25/2015 12:02'!
canCreateProcess: anOrbeonFormUser
	"Answer whether or not the argument <anOrbeonFormUser> can create a process.
	To create a process the user must have a grant in the out transitions of the start node."

	startNode ifNil: [^false].
	^startNode outTransitions anySatisfy: [:each | each isGrantedRole: anOrbeonFormUser]! !

!OrbeonFormPathDefinition methodsFor: 'other' stamp: 'BrunoBB 01/27/2015 04:45'!
canEndProcess: anOrbeonFormUser
	"Answer whether or not the argument <anOrbeonFormUser> can create a process.
	To create a process the user must have a grant in the out transitions of the start node."

	^endNode inTransitions anySatisfy: [:each | each isGrantedRole: anOrbeonFormUser]! !

!OrbeonFormPathDefinition methodsFor: 'other' stamp: 'BrunoBB 01/27/2015 04:45'!
canModifyPathDefinition

	^processDefinition canModifyPathDefinition! !

!OrbeonFormPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 01/27/2015 04:45'!
endNode

   "Return the value of the instance variable 'endNode'."
   ^endNode! !

!OrbeonFormPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 01/27/2015 04:45'!
endNode: newValue

   "Modify the value of the instance variable 'endNode'."
   endNode := newValue! !

!OrbeonFormPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 01/27/2015 04:45'!
endNodes

   "Return the value of the instance variable 'endNodes'."
   ^endNodes! !

!OrbeonFormPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 01/27/2015 04:45'!
endNodes: newValue

   "Modify the value of the instance variable 'endNodes'."
   endNodes := newValue! !

!OrbeonFormPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 01/27/2015 04:48'!
endSubProcessNodes

   "Return the value of the instance variable 'endSubProcessNodes'."
   ^endSubProcessNodes! !

!OrbeonFormPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 01/27/2015 04:48'!
endSubProcessNodes: newValue

   "Modify the value of the instance variable 'endSubProcessNodes'."
   endSubProcessNodes := newValue! !

!OrbeonFormPathDefinition methodsFor: 'execution path' stamp: 'BrunoBB 01/27/2015 04:45'!
endTransitions
	"The receiver answer a collection of transitions which it's -end node- is the END of the path"

	^transitions select: [:each | each isEndTransition]! !

!OrbeonFormPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 06/15/2015 16:27'!
formsLoopTypes
	^formsLoopTypes! !

!OrbeonFormPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 06/15/2015 16:27'!
formsLoopTypes: newValue
	formsLoopTypes := newValue! !

!OrbeonFormPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 04/08/2015 05:51'!
gatewayNodes
	^gatewayNodes! !

!OrbeonFormPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 04/08/2015 05:51'!
gatewayNodes: newValue
	gatewayNodes := newValue! !

!OrbeonFormPathDefinition methodsFor: 'other' stamp: 'BrunoBB 01/27/2015 04:45'!
getAllNodes

	^startNodes asOrderedCollection, endNodes asOrderedCollection! !

!OrbeonFormPathDefinition methodsFor: 'execution path' stamp: 'BrunoBB 04/08/2015 06:09'!
getEndNodeFor: anOrbeonFormDefinition in: anOrbeonFormTransitionDefinition node: anOrbeonPathNode
	"Answer <anOrbeonFormPathNode> which wrap the form definition <anOrbeonFormDefinition> if none answer nil.
	1- If the form definition is nil (END of the path) then answer a -nil- Node.
	2- If not, if the form definition already exist answer that node.
	3- If the denition does not exist then create a NODE to wrap the <anOrbeonFormDefinition> of <anOrbeonFormTransitionDefinition>"

	(anOrbeonFormDefinition isNil and: [anOrbeonPathNode isSubProcessNode not and:[anOrbeonPathNode isGatewayNode not]]) "subProcess has NO FormDefinition"
		ifTrue: [^self getNilEndNodeIn: anOrbeonFormTransitionDefinition node: anOrbeonPathNode]. "a -nil- node for the Start node"

	anOrbeonPathNode isGatewayNode 
	ifTrue: [(gatewayNodes includesKey: anOrbeonPathNode nodeName) ifFalse: [self addGatewayNode: anOrbeonPathNode].
		^gatewayNodes at: anOrbeonPathNode nodeName].

	anOrbeonPathNode isSubProcessNode "is a normal node ?"
	ifFalse: [(endNodes includesKey: anOrbeonFormDefinition) "if the node does not exist create a Node for <anOrbeonFormDefinition>"
				ifFalse: [self addEndNode: (anOrbeonPathNode formDefinition: anOrbeonFormDefinition)].
				^endNodes at: anOrbeonFormDefinition ifAbsent: [^PathNodeNotExistException signal]]. "answer the node"

	(endSubProcessNodes includesKey: anOrbeonPathNode nodeName)
	ifFalse: [self addEndSubProcessNode: anOrbeonPathNode].

	^endSubProcessNodes at: anOrbeonPathNode nodeName! !

!OrbeonFormPathDefinition methodsFor: 'execution path' stamp: 'BrunoBB 02/01/2015 11:12'!
getNextTransitionsOf: anOrbeonFormTransitionDef
	"Answer a collection of possible next transitions after <anOrbeonFormTransitionDef> transition definition.
	Any transition where the start form definition is equal to anOrbeonFormTransitionDef end form definition.
	anOrbeonFormTransitionDef (endForm) == any Start.
	(form 1 >> [send]) --> (form 2 >> [new])"

	^transitions select: [:each | anOrbeonFormTransitionDef endNode sameAs: each startNode]! !

!OrbeonFormPathDefinition methodsFor: 'execution path' stamp: 'BrunoBB 01/27/2015 04:45'!
getNilEndNodeIn: anOrbeonFormTransitionDefinition node: anOrbeonPathNode
	"Answer <anOrbeonFormPathNode> which wrap the form definition <anOrbeonFormDefinition>"

	endNode ifNotNil: [^endNode].

	endNode := anOrbeonPathNode formDefinition: nil.

	^endNode! !

!OrbeonFormPathDefinition methodsFor: 'execution path' stamp: 'BrunoBB 01/27/2015 04:45'!
getNilStartNodeIn: anOrbeonFormTransitionDefinition node: anOrbeonPathNode
	"Answer <anOrbeonFormPathNode> which wrap the form definition <anOrbeonFormDefinition>"

	startNode ifNotNil: [^startNode].

	startNode := anOrbeonPathNode formDefinition: nil.

	^startNode! !

!OrbeonFormPathDefinition methodsFor: 'execution path' stamp: 'BrunoBB 04/08/2015 06:09'!
getStartNodeFor: anOrbeonFormDefinition in: anOrbeonFormTransitionDefinition node: anOrbeonPathNode
	"Answer <anOrbeonFormPathNode> which wrap the form definition <anOrbeonFormDefinition>
	1- If the form definition is nil (Start of the path) then answer a -nil- Node.
	2- If not if the form definition already exist answer that node.
	3- If the denition does not exist then create a NODE to wrap the <anOrbeonFormDefinition> of <anOrbeonFormTransitionDefinition>"

	(anOrbeonFormDefinition isNil and: [anOrbeonPathNode isSubProcessNode not and:[anOrbeonPathNode isGatewayNode not]]) "subProcess has NO FormDefinition"
		ifTrue: [^self getNilStartNodeIn: anOrbeonFormTransitionDefinition node: anOrbeonPathNode]. "a -nil- node for the Start node"

	anOrbeonPathNode isGatewayNode 
	ifTrue: [(gatewayNodes includesKey: anOrbeonPathNode nodeName) ifFalse: [self addGatewayNode: anOrbeonPathNode].
		^gatewayNodes at: anOrbeonPathNode nodeName].

	anOrbeonPathNode isSubProcessNode "is a normal node ?"
	ifFalse: [(startNodes includesKey: anOrbeonFormDefinition) "if the node does not exist create a Node for <anOrbeonFormDefinition>"
				ifFalse: [self addStartNode: (anOrbeonPathNode formDefinition: anOrbeonFormDefinition)].
				^startNodes at: anOrbeonFormDefinition ifAbsent: [^PathNodeNotExistException signal]]. "answer the node"

	(startSubProcessNodes includesKey: anOrbeonPathNode nodeName)
	ifFalse: [self addStartSubProcessNode: anOrbeonPathNode].

	^startSubProcessNodes at: anOrbeonPathNode nodeName! !

!OrbeonFormPathDefinition methodsFor: 'other' stamp: 'BrunoBB 06/12/2015 11:08'!
getTransitionsNames
	"Answer a collection of names of transitions that have an associated form definition "

	^((transitions select: [:each | each endNodeFormDefinitionNotNil]) collect: [:each | each endFormName]) asSortedCollection! !

!OrbeonFormPathDefinition methodsFor: 'other' stamp: 'BrunoBB 01/27/2015 04:45'!
getTransitionWith: endFormName ifNone: noneBlock

	^transitions detect: [:each | each endFormName = endFormName] ifNone: noneBlock! !

!OrbeonFormPathDefinition methodsFor: 'other' stamp: 'BrunoBB 01/27/2015 04:45'!
hasProcessFor: appName form: formName

	^startNode outTransitions anySatisfy: [:each | 
					(each endNode formDefinition app = appName) 
					and: [each endNode formDefinition form = formName]]! !

!OrbeonFormPathDefinition methodsFor: 'other' stamp: 'BrunoBB 06/15/2015 16:30'!
initialize

	super initialize.

	transitions := OrderedCollection new.
	startNodes := Dictionary new.
	endNodes := Dictionary new.
	startSubProcessNodes := Dictionary new.
	endSubProcessNodes := Dictionary new.
	gatewayNodes := Dictionary new.
	formsLoopTypes := Dictionary new.! !

!OrbeonFormPathDefinition methodsFor: 'other' stamp: 'BrunoBB 06/16/2015 14:30'!
isMultiInstanceFormNamed: aString

	^(formsLoopTypes includesKey: aString) and:[(formsLoopTypes at: aString) = 'MultiInstance']! !

!OrbeonFormPathDefinition methodsFor: 'other' stamp: 'BrunoBB 06/16/2015 15:05'!
isReusableFormNamed: aString

	^(self isMultiInstanceFormNamed: aString) not! !

!OrbeonFormPathDefinition methodsFor: 'other' stamp: 'BrunoBB 01/27/2015 04:45'!
printNodes
	| stream |

	stream := PrintStream on: String new.

	((Array with: startNode), self getAllNodes asArray, (Array with: endNode)) do: [:each | 
		stream nextPutAll: each printNode;
					nextPutAll: String lf].

	^stream contents! !

!OrbeonFormPathDefinition methodsFor: 'other' stamp: 'BrunoBB 01/27/2015 04:45'!
printTransitions
	| stream |

	stream := PrintStream on: String new.

	transitions do: [:each | 
		stream nextPutAll: each printTransition;
					nextPutAll: String lf].

	^stream contents! !

!OrbeonFormPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 01/27/2015 04:45'!
processDefinition

   "Return the value of the instance variable 'processDefinition'."
   ^processDefinition! !

!OrbeonFormPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 01/27/2015 04:45'!
processDefinition: newValue

   "Modify the value of the instance variable 'processDefinition'."
   processDefinition := newValue! !

!OrbeonFormPathDefinition methodsFor: 'other' stamp: 'BrunoBB 01/27/2015 04:45'!
removeFromPath: anOrbeonFormTransitionDefinition

	anOrbeonFormTransitionDefinition pathDefinition: nil.
	^transitions remove: anOrbeonFormTransitionDefinition! !

!OrbeonFormPathDefinition methodsFor: 'execution path' stamp: 'BrunoBB 01/27/2015 04:45'!
rootTransitions
	"The initial transitions of the receiver"

	^transitions select: [:each | each startNode isStart]! !

!OrbeonFormPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 01/27/2015 04:45'!
startNode

   "Return the value of the instance variable 'startNode'."
   ^startNode! !

!OrbeonFormPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 01/27/2015 04:45'!
startNode: newValue

   "Modify the value of the instance variable 'startNode'."
   startNode := newValue! !

!OrbeonFormPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 01/27/2015 04:45'!
startNodes

   "Return the value of the instance variable 'startNodes'."
   ^startNodes! !

!OrbeonFormPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 01/27/2015 04:45'!
startNodes: newValue

   "Modify the value of the instance variable 'startNodes'."
   startNodes := newValue! !

!OrbeonFormPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 01/27/2015 04:48'!
startSubProcessNodes

   "Return the value of the instance variable 'startSubProcessNodes'."
   ^startSubProcessNodes! !

!OrbeonFormPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 01/27/2015 04:48'!
startSubProcessNodes: newValue

   "Modify the value of the instance variable 'startSubProcessNodes'."
   startSubProcessNodes := newValue! !

!OrbeonFormPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 01/27/2015 04:45'!
transitions

   "Return the value of the instance variable 'transitions'."
   ^transitions! !

!OrbeonFormPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 01/27/2015 04:45'!
transitions: newValue

   "Modify the value of the instance variable 'transitions'."
   transitions := newValue! !

OrbeonObject subclass: #OrbeonFormProcess
	instanceVariableNames: 'definition processId name formUser orbeonFormInstances runningTransitions executedTransitions finished createdTime assignments creatorUser cancelledAssignments parentProcess subProcesses pendingTransitions runningGateways executedGateways postExecution'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!OrbeonFormProcess commentStamp: 'BrunoBB 08/26/2014 16:19' prior: 0!
This class is a concrete instance of a real form process. It execute transitions from one form to another until the end of the path is reached.

definition 						- the definition of the receiver (includes the transitions from one form definition to another)
processId 						- the id of the receiver
name								- the name of the receiver
formUser 							- the user that created the receiver
orbeonFormInstances 	- a collection of OrbeonFormInstance that represent the completed forms 
runningTransitions 			- current running transitions
executedTransitions		- transitions that already has been completed
finished 							- a boolean to mark the receiver as finished
createdTime 					- time stamp of the creation time
assignments					- assignment (took by an user)
creatorUser						- user that created the receiver
cancelledAssignments 	- assigments that user took and then released 
parentProcess 				- process creator (used only with subprocess) if there is not subprocess then is nil
subProcesses 					- a collection of receiver's subprocesses
pendingTransitions			- a dictionary to map pending transtions with subprocesses. When a subprocess finish we relate the finished subprocess with a pending transition in this dictionary.
runningGateways 			- current gateways waiting to be processed
executedGateways			- processed gateways!

!OrbeonFormProcess class methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
definition: anOrbeonFormProcessDefinition

	^super new initialize
		definition: anOrbeonFormProcessDefinition;
		yourself! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
addAssignment: anOrbeonProcessAssignment

	anOrbeonProcessAssignment formProcess: self.
	^assignments add: anOrbeonProcessAssignment! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 06/14/2015 16:42'!
addGateway: aProcessGateway

	^runningGateways at: aProcessGateway gatewayName put: aProcessGateway! !

!OrbeonFormProcess methodsFor: 'run' stamp: 'BrunoBB 01/28/2015 04:45'!
addSubProcess: anOrbeonFormProcess

	anOrbeonFormProcess parentProcess: self.

	^subProcesses add: anOrbeonFormProcess! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
application

	^definition orbeonApplication! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
applicationName

	^definition applicationName! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
assignedUserNames
	| userNames |

	assignments isEmpty ifTrue: [^''].
	userNames := ''.
	assignments do: [:each | userNames := userNames, each assignedUserNames].

	^userNames! !

!OrbeonFormProcess methodsFor: 'Accessing' stamp: 'BrunoBB 01/28/2015 04:45'!
assignments

   "Return the value of the instance variable 'assignments'."
   ^assignments! !

!OrbeonFormProcess methodsFor: 'Updating' stamp: 'BrunoBB 01/28/2015 04:45'!
assignments: newValue

   "Modify the value of the instance variable 'assignments'."
   assignments := newValue! !

!OrbeonFormProcess methodsFor: 'Accessing' stamp: 'BrunoBB 01/28/2015 04:45'!
cancelledAssignments

   "Return the value of the instance variable 'cancelledAssignments'."
   ^cancelledAssignments! !

!OrbeonFormProcess methodsFor: 'Updating' stamp: 'BrunoBB 01/28/2015 04:45'!
cancelledAssignments: newValue

   "Modify the value of the instance variable 'cancelledAssignments'."
   cancelledAssignments := newValue! !

!OrbeonFormProcess methodsFor: 'xpdl output' stamp: 'BrunoBB 05/15/2015 11:59'!
changeColorOfGatewaysOf: transitionsNodes in: xmlDocument

	transitionsNodes do: [:eachNode | | nodeId trNode |
		nodeId := eachNode attributeAt: 'To'.
		trNode := ((xmlDocument allElementsNamed: 'Activity') select: [:each | (each findElementNamed: 'Route') notNil])
							detect: [:each | (each attributeAt: 'Id') = nodeId] ifNone: [nil].
		trNode notNil
		ifTrue: [(trNode findElementNamed: 'NodeGraphicsInfo') attributeAt: 'FillColor' put: '-1872887'.].
	]! !

!OrbeonFormProcess methodsFor: 'xpdl output' stamp: 'BrunoBB 05/15/2015 11:30'!
changeColorOfTransitionsReaching: nodesCollection in: xmlDocument
	| transitionNodes |

	transitionNodes := OrderedCollection new.
	nodesCollection do: [:eachNode | | nodeId trNode |
		nodeId := eachNode attributeAt: 'Id'.
		trNode := (xmlDocument allElementsNamed: 'Transition') detect: [:each | (each attributeAt: 'To') = nodeId] ifNone: [nil].
		trNode notNil
		ifTrue: [(trNode findElementNamed: 'ConnectorGraphicsInfo') attributeAt: 'BorderColor' put: '-1872887'.
			transitionNodes add: trNode].

		trNode := (xmlDocument allElementsNamed: 'Transition') detect: [:each | (each attributeAt: 'From') = nodeId] ifNone: [nil].
		trNode notNil
		ifTrue: [(trNode findElementNamed: 'ConnectorGraphicsInfo') attributeAt: 'BorderColor' put: '-1872887'.
			transitionNodes add: trNode].
	].

	^transitionNodes! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
checkIfStillAvailableFor: anOrbeonFormUser
	"Answer whether or not the receiver is still available for <anOrbeonFormUser>.
	This is used when 2 users try to -take- an assignment on a Process Instance.
	Only one has to be allowed to do that."

	^(definition class getFreeTransitionsFor: anOrbeonFormUser) includesKey: self! !

!OrbeonFormProcess methodsFor: 'Accessing' stamp: 'BrunoBB 01/28/2015 04:45'!
createdTime

   "Return the value of the instance variable 'createdTime'."
   ^createdTime! !

!OrbeonFormProcess methodsFor: 'Updating' stamp: 'BrunoBB 01/28/2015 04:45'!
createdTime: newValue

   "Modify the value of the instance variable 'createdTime'."
   createdTime := newValue! !

!OrbeonFormProcess methodsFor: 'gateway processing' stamp: 'BrunoBB 04/14/2015 04:50'!
createGatewayInstanceFor: gatewayDefinition
	"The receiver creates and stores a concrete instance of gateway (subclass of ProcessGateway) based on the node definition <gatewayDefinition> (subclass of ProcessGatewayNode)"
	| newGateway |

	newGateway := gatewayDefinition instanceClass definition: gatewayDefinition.
	self addGateway: newGateway.
	^newGateway! !

!OrbeonFormProcess methodsFor: 'Updating' stamp: 'BrunoBB 01/28/2015 04:45'!
creatorName

	creatorUser ifNil: [^''].

	^creatorUser username! !

!OrbeonFormProcess methodsFor: 'Accessing' stamp: 'BrunoBB 01/28/2015 04:45'!
creatorUser

   "Return the value of the instance variable 'creatorUser'."
   ^creatorUser! !

!OrbeonFormProcess methodsFor: 'Updating' stamp: 'BrunoBB 01/28/2015 04:45'!
creatorUser: newValue

   "Modify the value of the instance variable 'creatorUser'."
   creatorUser := newValue! !

!OrbeonFormProcess methodsFor: 'run' stamp: 'BrunoBB 01/28/2015 04:45'!
currentAssignedRoles
	"Answer a collection (anOrbeonProcessRole) with the current assigned rols to the receiver "
	| currentAssignedRoles |

	currentAssignedRoles := OrderedCollection new.
	assignments do: [:eachAssign | 
		eachAssign orbeonFormUsers do: [:eachUser | currentAssignedRoles addAll: eachUser roles]].

	^currentAssignedRoles! !

!OrbeonFormProcess methodsFor: 'Accessing' stamp: 'BrunoBB 01/28/2015 04:45'!
definition

   "Return the value of the instance variable 'definition'."
   ^definition! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
definition: anOrbeonFormProcessDefinition

	definition := anOrbeonFormProcessDefinition! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 06/15/2015 16:01'!
doesNotUnderstand: aMessageDescriptor
	"The receiver overide this method in order to respond to messages that are equal in name to any of it's field name"

	self getFinishedForms 
		detect: [:each | each hasFieldNamed: aMessageDescriptor selector] 
		ifNone: [^super doesNotUnderstand: aMessageDescriptor].

	^self getValueOfProcessField: aMessageDescriptor selector asString! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
endTransitions

	^self pathDefinition endTransitions! !

!OrbeonFormProcess methodsFor: 'Accessing' stamp: 'BrunoBB 04/08/2015 17:14'!
executedGateways
	^executedGateways! !

!OrbeonFormProcess methodsFor: 'Updating' stamp: 'BrunoBB 04/08/2015 17:14'!
executedGateways: newValue
	executedGateways := newValue! !

!OrbeonFormProcess methodsFor: 'Accessing' stamp: 'BrunoBB 01/28/2015 04:45'!
executedTransitions

   "Return the value of the instance variable 'executedTransitions'."
   ^executedTransitions! !

!OrbeonFormProcess methodsFor: 'Updating' stamp: 'BrunoBB 01/28/2015 04:45'!
executedTransitions: newValue

   "Modify the value of the instance variable 'executedTransitions'."
   executedTransitions := newValue! !

!OrbeonFormProcess methodsFor: 'run' stamp: 'BrunoBB 07/05/2015 16:08'!
finalize
	"Finalize the receiver if has parent processo resume it's parent execution "

	finished := true.
	self hasParentProcess ifTrue: [parentProcess resumeParentProcessExecutionFrom: self].! !

!OrbeonFormProcess methodsFor: 'run' stamp: 'BrunoBB 07/21/2015 05:14'!
finalizeTransition: anOrbeonFormTransition
	"The transition of the receiver <anOrbeonFormTransition> is done then this method is called.
	1- Remove the transition from current running transitions.
	2- Add the transition to collection of executed transitions"

	runningTransitions remove: anOrbeonFormTransition.
	executedTransitions add: anOrbeonFormTransition.! !

!OrbeonFormProcess methodsFor: 'Accessing' stamp: 'BrunoBB 01/28/2015 04:45'!
finished

   "Return the value of the instance variable 'finished'."
   ^finished! !

!OrbeonFormProcess methodsFor: 'Updating' stamp: 'BrunoBB 01/28/2015 04:45'!
finished: newValue

   "Modify the value of the instance variable 'finished'."
   finished := newValue! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 02/02/2015 05:45'!
formProcess

	^self! !

!OrbeonFormProcess methodsFor: 'Accessing' stamp: 'BrunoBB 01/28/2015 04:45'!
formUser

   "Return the value of the instance variable 'formUser'."
   ^formUser! !

!OrbeonFormProcess methodsFor: 'Updating' stamp: 'BrunoBB 01/28/2015 04:45'!
formUser: newValue

   "Modify the value of the instance variable 'formUser'."
   formUser := newValue! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
formUserName

	formUser ifNil: [^'N/A'].

	^formUser username! !

!OrbeonFormProcess methodsFor: 'run' stamp: 'BrunoBB 05/14/2015 06:43'!
generateNextSubProcessesFor: newSubProcessTransitions from: anOrbeonFormTransition
	"The receiver create new OrbeonFormProcess from the finalized transition <anOrbeonFormTransition>.
	New subprocesses will be created using the collection <newSubProcessTransitions> where each transition generate a subprocess "
	| newProcesses |

	newProcesses := OrderedCollection new.
	newSubProcessTransitions do: [:eachTrDef | | newProcess newSubProcTransition |
		newProcess := eachTrDef endNode processDefinition createProcess: nil.
		newSubProcTransition := eachTrDef createSubProcessTransition: self from: anOrbeonFormTransition.
		newSubProcTransition subProcess: newProcess.
		runningTransitions add: newSubProcTransition.
		self addSubProcess: newProcess.
		pendingTransitions at: newProcess put: newSubProcTransition. "register the transition that started the subprocess"
		newProcess startProcessRoots. "we start the process here creating the transitions roots"
		newProcesses add: newProcess.
		].

	^newProcesses! !

!OrbeonFormProcess methodsFor: 'run' stamp: 'BrunoBB 07/05/2015 16:08'!
generateNextTransitionsFrom: anOrbeonFormTransition
	"The receiver fetch the possibles next transitions to transition definition <anOrbeonFormTransition> and create the concrete transitions.
	1- Ask the path definition for next transitions.
	2- Create a concrete transtition for each definition in 1, and add it as running transitions."
	| nextTransitions newTransitions nextSubProcessTransitions |

	"next transitions definitions -a collection-"
	nextTransitions := self pathDefinition getNextTransitionsOf: anOrbeonFormTransition definition. 
	"check creation conditions -start conditions- in the finished transtions <anOrbeonFormTransition>"
	nextTransitions := nextTransitions select: [:eachTrDef | eachTrDef checkCreationRuleFor: anOrbeonFormTransition in: self].

	"rejecting transitions definitions that start subprocesses, <nextTransitions> will only hold regular transitions "
	newTransitions := nextTransitions reject: [:eachTrDef | eachTrDef endNodeIsSubProcess].
	"collecting transitions definitions that start sub processes "
	nextSubProcessTransitions := nextTransitions select: [:eachTrDef | eachTrDef endNodeIsSubProcess].
	"create concrete transtions from <anOrbeonFormTransition>"
	newTransitions := self processNextTransitions: nextTransitions from: anOrbeonFormTransition.
	"create concrete subprocess from <anOrbeonFormTransition>"
	self generateNextSubProcessesFor: nextSubProcessTransitions from: anOrbeonFormTransition.

	runningTransitions isEmpty ifTrue: [self finalize].

	^newTransitions! !

!OrbeonFormProcess methodsFor: 'xpdl output' stamp: 'BrunoBB 10/12/2015 16:53'!
generateProcessMap
	"The receiver generate an XML String which is a XPLD file.
	This file must be imported as XPDL in Bizagi and it shows the execution path of the receiver.
	Map executed transitions with XML nodes"
	| xmlDocument executedNodes transitionsNodes |

	xmlDocument := XMLDOMParser parse: definition xmlString.

	executedNodes := OrderedCollection new.
	(executedTransitions select: [:each | each isFormTransition and:[each isEndTransition not]]) do: [:eachTr | | node |
		node := (xmlDocument allElementsNamed: 'Activity') detect: [:each | (each attributeAt: 'Name') = eachTr formDefinition form].
		executedNodes add: node.
		(node findElementNamed: 'NodeGraphicsInfo') attributeAt: 'FillColor' put: '-1872887'.].

	transitionsNodes := self changeColorOfTransitionsReaching: executedNodes in: xmlDocument.

	self changeColorOfGatewaysOf: transitionsNodes in: xmlDocument.

	^xmlDocument! !

!OrbeonFormProcess methodsFor: 'xpdl output' stamp: 'BrunoBB 05/15/2015 08:06'!
generateProcessMapTo: pathFile

	^(FileStream write: pathFile)
			nextPutAll: self generateProcessMap prettyPrinted;
			flush;
			close! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
getAllTransitions

		^executedTransitions, runningTransitions! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 04/22/2015 06:17'!
getExecutedForms
	"Answer a collection of executed OrbeonFormInstance "

	^self getExecutedFormsTransitions select: [:each | each orbeonFormInstance notNil] thenCollect: []! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 04/22/2015 06:11'!
getExecutedFormsTransitions
	"Answer a collection of executed transitions that has a OrbeonFormInstance as end task"

	^executedTransitions select: [:each | each isFormTransition]! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 06/12/2015 07:37'!
getFieldsForFormName: formName
	| fieldNames |

	fieldNames := (executedTransitions detect: [:each | each definition endFormName = formName] ifNone: [^#()])
		orbeonFormInstance fields keys asOrderedCollection.

	fieldNames addFirst: '-'.

	^(fieldNames copyWithoutAll: #('oop' 'gstoken' 's' 'k'))  asSortedCollection! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
getFieldTypeOf: fieldName in: formName

	^(self getTransitionsWithForms detect: [:each | each definition endFormName = formName] ifNone: [^''])
		orbeonFormInstance typeOf: fieldName! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 04/22/2015 06:21'!
getFinishedForms
	"Answer a collection of OrbeonFormInstance that has been finished (sent)"

	^self getExecutedFormsTransitions 
		select: [:each | each orbeonFormInstance notNil] "incoming gateway transitions"
		thenCollect: [:each | each orbeonFormInstance]! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 03/14/2015 08:17'!
getLastExecutedTransition
	| lastTransition |

	self hasExecutedTransitions ifFalse: [^NoExecuteTransitionException signal: 'The Process has No executed transitions'].

	"This transition has no form because is the end transition"
	(executedTransitions size > 1) ifFalse: [executedTransitions last].

	lastTransition := (executedTransitions last: 2) first.

	lastTransition isSubprocessTransition ifTrue: [^lastTransition subProcessGetLastExecutedTransition].

	^lastTransition! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
getMissingRoleAssignmentAsCollection
	"Answer a Dictionary where the key is the name of the form to fill and the value is a collection rol's names.
	These rols has not been covered by the current assignments, so the process can NOT go further.
	The user that want to take transitions should look this dictionary to take assignments"
	| currentAssignedRoles missingRoles |

	missingRoles := OrderedCollection new.
	currentAssignedRoles := self currentAssignedRoles. "all roles involved in the process with assignments in the receiver"
	runningTransitions do: [:eachTrans | | grantedRoles |
		grantedRoles := OrderedCollection new.
		eachTrans grantedRols do: [:role | 
			((currentAssignedRoles includes: role) not and: [eachTrans checkRuleFor: role]) 
			ifTrue: [missingRoles add: role]].].

	^missingRoles! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
getTransitionsOfUserNamed:  aString

	^self getAllTransitions select: [:each | each getUserName = aString]! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
getTransitionsWithForms

	^executedTransitions, (runningTransitions select: [:each | each hasForm])! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 06/15/2015 15:00'!
getValueOfProcessField: fieldName
	"Answer the first value of a field named <fieldName> in the receiver <executedTransitions>.
	The search is performed only in transitions that have anOrbeonFormInstance <isFormTransition>.

	The difference with the <OrbeonFormTransition> method <getValueOfProcessField:> is that this search in all transitions the other only search in the transition parent chain (see implementors of this method)"

	(executedTransitions reverse select: [:each | each isFormTransition]) 
		do: [:each | (each getValueOfFormField: fieldName) ifNotNil: [:value | ^value]].

	^nil

	"#reverse is used because the process can be recursive (can be more than one field value for a given field name) --> we check for the lastest executed transitions"! !

!OrbeonFormProcess methodsFor: 'run' stamp: 'BrunoBB 06/16/2015 15:59'!
hasAlreadyBeenExecuted: anOrbeonFormTransitionDefinition

	^executedTransitions anySatisfy: [:each | each definition endNodeFormDefinition == anOrbeonFormTransitionDefinition endNodeFormDefinition]! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
hasCurrentFormNamed: formTypeName

	^runningTransitions anySatisfy: [:each | each definition endFormName = formTypeName]! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 03/14/2015 07:34'!
hasExecutedTransitions

	^executedTransitions notEmpty! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
hasFormDefinitionNamed: formTypeName

	^self getTransitionsWithForms anySatisfy: [:each | each definition endFormName = formTypeName]! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
hasFormDefinitionNamed: formTypeName withFieldName: fieldName initValue: initValue endValue: endValue

	^(self getTransitionsWithForms select: [:each | each definition endFormName = formTypeName] 
		thenCollect: [:each | each orbeonFormInstance])

			anySatisfy: [:each | | fieldValue initCastedValue endCastedValue |
				fieldValue := each fieldValueAt: fieldName.
				initCastedValue := fieldValue class value: initValue.
				endCastedValue := fieldValue class value: endValue.
				(initCastedValue value isNil or:[endValue value isNil or:[fieldValue value isNil]])
				ifTrue: [false]
				ifFalse: [(initCastedValue value <= fieldValue value) and: [fieldValue value <= endCastedValue value]]]! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
hasFormDefinitionNamed: formTypeName withFieldName: fieldName withValue: fieldValue

	^(self getTransitionsWithForms select: [:each | each definition endFormName = formTypeName] 
		thenCollect: [:each | each orbeonFormInstance])

			anySatisfy: [:each | (each valueAt: fieldName) = fieldValue]! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 06/14/2015 16:42'!
hasGatewayInstanceFor: aProcessGatewayNode
	"Answer whether or not the receiver has created a gateway instance for defintion <aProcessGatewayNode>.
	When a gateway has more than one incoming transition then the gateway MUST be created only once (with the first incoming transition)"

	^runningGateways includesKey: aProcessGatewayNode nodeName! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
hasParentProcess

	^parentProcess notNil! !

!OrbeonFormProcess methodsFor: 'Accessing' stamp: 'BrunoBB 01/28/2015 04:45'!
hasRunningTransitions

   ^runningTransitions notEmpty! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 02/02/2015 05:42'!
hasSubprocesses

	^subProcesses notEmpty! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
idOfProcessDefintion

	^definition processId! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
includesAssignment: anOrbeonProcessAssignment

	^assignments includes: anOrbeonProcessAssignment! !

!OrbeonFormProcess methodsFor: 'gateway processing' stamp: 'BrunoBB 05/06/2015 06:30'!
incomingTransition: anOrbeonTransition onComplexGateway: aComplexGateway
	"The receiver process the incoming transition <anOrbeonTransition> to the complex gateway <aComplexGateway>"

	"we have have to synchronize incoming transitions ? (default <false>)"
	aComplexGateway waitAllIncomingTransitions ifFalse: [^self generateNextTransitionsFrom: anOrbeonTransition].! !

!OrbeonFormProcess methodsFor: 'gateway processing' stamp: 'BrunoBB 05/04/2015 08:01'!
incomingTransition: anOrbeonTransition onExclusiveGateway: anExclusiveGateway
	"The receiver process the incoming transition <anOrbeonTransition> to the exclusive gateway <anExclusiveGateway>"

	"if the gateway has outgoing transitions then is done no other transition will be granted to pass through"
	anExclusiveGateway hasOutgoingTransitions ifTrue: [^self].

	"we have have to synchronize incoming transitions ? (default <false>)"
	anExclusiveGateway waitAllIncomingTransitions ifFalse: [^self generateNextTransitionsFrom: anOrbeonTransition].! !

!OrbeonFormProcess methodsFor: 'gateway processing' stamp: 'BrunoBB 04/15/2015 06:30'!
incomingTransition: anOrbeonTransition onInclusiveGateway: anInclusiveGateway
	"The receiver process the incoming transition <anOrbeonTransition> to the inclusive gateway <anInclusiveGateway>"

	"we have have to synchronize incoming transitions ? (default <true>)"
	anInclusiveGateway waitAllIncomingTransitions ifFalse: [^self generateNextTransitionsFrom: anOrbeonTransition].

	anInclusiveGateway incomingTransitionsAreDone " an InclusiveGateway it synchronizes all the paths that arrive"
	ifTrue: [^self generateNextTransitionsFrom: anOrbeonTransition]! !

!OrbeonFormProcess methodsFor: 'gateway processing' stamp: 'BrunoBB 04/20/2015 05:22'!
incomingTransition: anOrbeonTransition onParallelGateway: aParallelGateway
	"The receiver process the incoming transition <anOrbeonTransition> to the parallel gateway <aParallelGateway>"

	"we have have to synchronize incoming transitions ? (default <true>)"
	aParallelGateway waitAllIncomingTransitions ifFalse: [^self generateNextTransitionsFrom: anOrbeonTransition].

	aParallelGateway incomingTransitionsAreDone " a ParallelGateway it synchronize all transitions that arrive"
	ifTrue: [^self generateNextTransitionsFrom: anOrbeonTransition].

"	aParallelGateway incomingTransitionsAreDone 
	ifTrue: [aParallelGateway incomingTransitions do: [:each | self generateNextTransitionsFrom: each]]"! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
indexOfTransition: anOrbeonFormTransition
	"Answer the index of the receiver transition <anOrbeonFormTransition>"

	(executedTransitions includes: anOrbeonFormTransition) 
	ifTrue: [^(executedTransitions indexOf: anOrbeonFormTransition)].

	(runningTransitions includes: anOrbeonFormTransition) 
	ifTrue: [^(executedTransitions size) + (runningTransitions indexOf: anOrbeonFormTransition)].

	^0! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 14:05'!
initialize

	super initialize.

	processId := Lag1MwcRandom new integer.
	orbeonFormInstances := Dictionary new.
	runningTransitions := OrderedCollection new.
	executedTransitions := OrderedCollection new.
	createdTime := TimeStamp now.
	finished := false.
	assignments := OrderedCollection new.
	cancelledAssignments := OrderedCollection new.
	subProcesses := OrderedCollection new.
	pendingTransitions := Dictionary new. "used for subprocess execution"
	runningGateways := Dictionary new.
	executedGateways := Dictionary new.! !

!OrbeonFormProcess methodsFor: 'run' stamp: 'BrunoBB 05/14/2015 16:27'!
isInCorruptedState
	"Answer whether or not the receiver is in -corrupted state-. Somehow the receiver has NO more transitions to run (finished = true) but is NOT in an EndTransition (has more transitions to run)"

	^(finished and: [self isInEndTransition not]) 
		or: [runningTransitions isEmpty and: [self isInEndTransition not]]! !

!OrbeonFormProcess methodsFor: 'run' stamp: 'BrunoBB 03/19/2015 05:56'!
isInEndTransition
	"Answer whether or not the receiver is in the LAST transition"

	^runningTransitions isEmpty
	ifTrue: [executedTransitions anySatisfy: [:each | each definition isEndTransition]]
	ifFalse: [runningTransitions anySatisfy: [:each | each definition isEndTransition]].! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 06/18/2015 12:53'!
isMultiInstanceFormNamed: aString

	^definition isMultiInstanceFormNamed: aString! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 06/16/2015 15:06'!
isReusableFormNamed: aString

	^definition isReusableFormNamed: aString! !

!OrbeonFormProcess methodsFor: 'Accessing' stamp: 'BrunoBB 01/28/2015 04:45'!
name

   "Return the value of the instance variable 'name'."
   ^name! !

!OrbeonFormProcess methodsFor: 'Updating' stamp: 'BrunoBB 01/28/2015 04:45'!
name: newValue

   "Modify the value of the instance variable 'name'."
   name := newValue! !

!OrbeonFormProcess methodsFor: 'Accessing' stamp: 'BrunoBB 01/28/2015 04:45'!
orbeonFormInstances

   "Return the value of the instance variable 'orbeonFormInstances'."
   ^orbeonFormInstances! !

!OrbeonFormProcess methodsFor: 'Updating' stamp: 'BrunoBB 01/28/2015 04:45'!
orbeonFormInstances: newValue

   "Modify the value of the instance variable 'orbeonFormInstances'."
   orbeonFormInstances := newValue! !

!OrbeonFormProcess methodsFor: 'gateway processing' stamp: 'BrunoBB 05/06/2015 06:32'!
outgoingTransition: anOrbeonTransition onComplexGateway: aComplexGateway
	"The receiver process the outgoing transition <anOrbeonTransition> to the complex gateway <aComplexGateway>"

	anOrbeonTransition isFormTransition ifTrue: [runningTransitions add: anOrbeonTransition].
	aComplexGateway addOutgoingTransition: anOrbeonTransition.! !

!OrbeonFormProcess methodsFor: 'gateway processing' stamp: 'BrunoBB 05/04/2015 16:48'!
outgoingTransition: anOrbeonTransition onExclusiveGateway: anExclusiveGateway
	"The receiver process the outgoing transition <anOrbeonTransition> to the exclusive gateway <anExclusiveGateway>"

	anExclusiveGateway hasOutgoingTransitions
	ifFalse: [anOrbeonTransition isFormTransition ifTrue: [runningTransitions add: anOrbeonTransition].
				anExclusiveGateway addOutgoingTransition: anOrbeonTransition]! !

!OrbeonFormProcess methodsFor: 'gateway processing' stamp: 'BrunoBB 05/04/2015 16:21'!
outgoingTransition: anOrbeonTransition onInclusiveGateway: anInclusiveGateway
	"The receiver process the outgoing transition <anOrbeonTransition> to the inclusive gateway <anInclusiveGateway>"

	anOrbeonTransition isFormTransition ifTrue: [runningTransitions add: anOrbeonTransition]! !

!OrbeonFormProcess methodsFor: 'gateway processing' stamp: 'BrunoBB 05/03/2015 18:16'!
outgoingTransition: anOrbeonTransition onParallelGateway: aParallelGateway
	"The receiver process the outgoing transition <anOrbeonTransition> to the parallel gateway <aParallelGateway>"

	anOrbeonTransition isFormTransition ifTrue: [runningTransitions add: anOrbeonTransition]! !

!OrbeonFormProcess methodsFor: 'Accessing' stamp: 'BrunoBB 01/28/2015 04:45'!
parentProcess

   "Return the value of the instance variable 'parentProcess'."
   ^parentProcess! !

!OrbeonFormProcess methodsFor: 'Updating' stamp: 'BrunoBB 01/28/2015 04:45'!
parentProcess: newValue

   "Modify the value of the instance variable 'parentProcess'."
   parentProcess := newValue! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
pathDefinition

	^definition pathDefinition! !

!OrbeonFormProcess methodsFor: 'Accessing' stamp: 'BrunoBB 01/28/2015 04:45'!
pendingTransitions

   "Return the value of the instance variable 'pendingTransitions'."
   ^pendingTransitions! !

!OrbeonFormProcess methodsFor: 'Updating' stamp: 'BrunoBB 01/28/2015 04:45'!
pendingTransitions: newValue

   "Modify the value of the instance variable 'pendingTransitions'."
   pendingTransitions := newValue! !

!OrbeonFormProcess methodsFor: 'Accessing' stamp: 'BrunoBB 06/30/2015 13:18'!
postExecution
	^postExecution! !

!OrbeonFormProcess methodsFor: 'Updating' stamp: 'BrunoBB 06/30/2015 13:18'!
postExecution: newValue
	postExecution := newValue! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
printCurrentRols
	| currentRols |

	currentRols := ''.
	runningTransitions do: [:each | currentRols := currentRols, each getGrantedRolsNames].

	^currentRols! !

!OrbeonFormProcess methodsFor: 'Accessing' stamp: 'BrunoBB 05/31/2015 15:50'!
printProcessState

	^finished ifTrue: ['Finished'] ifFalse: ['Running'].! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 06/04/2015 12:04'!
printRunningTransitions
	| stringRunning |

	stringRunning := ''.
	runningTransitions isEmpty ifTrue: [^''].

	runningTransitions do: [:each | stringRunning := stringRunning, each endFormName, ' | '].

	^stringRunning allButLast: 3! !

!OrbeonFormProcess methodsFor: 'gateway processing' stamp: 'BrunoBB 06/15/2015 07:49'!
processGatewayIncomingTransition: anOrbeonTransition evaluatingNext: nextTransitions
	"Process the finalized transition <anOrbeonTransition> evaluating as possible next transitions <nextTransitions>.
	<anOrbeonTransition> is activating a gateway (the transition is entering at the gateway)."

	nextTransitions do: [:trDefintion | | newTransition gateway |
		newTransition := "(trDefintion endNodeIsGateway not and:[trDefintion endNodeIsSubProcess not and:[trDefintion isEndTransition not]]) "
			trDefintion endNodeIsGateway
			ifFalse: [trDefintion createFormTransitionIn: self from: anOrbeonTransition]
			ifTrue: [trDefintion createGatewayTransitionIn: self from: anOrbeonTransition].

		anOrbeonTransition triggeredGateway " is the gateway that was 'triggered' by <anOrbeonTransition>"
					process: self;
					processOutgoingTransition: newTransition. "the gateway process the outgoing transition"

		trDefintion endNodeIsGateway 
		ifTrue:[gateway := (self hasGatewayInstanceFor: trDefintion endNode) "the gateway has been created by a previous incoming transition ?"
								ifTrue: [runningGateways at: trDefintion endNode nodeName] 
								ifFalse: [self createGatewayInstanceFor: trDefintion endNode].
				newTransition setParentGateway: anOrbeonTransition.
				gateway process: self;
					processIncomingTransition: newTransition].
	].

	self removeFromRunningGateways: anOrbeonTransition triggeredGateway. "the gateway instance is done is not running anymore"! !

!OrbeonFormProcess methodsFor: 'Accessing' stamp: 'BrunoBB 01/28/2015 04:45'!
processId

   "Return the value of the instance variable 'processId'."
   ^processId! !

!OrbeonFormProcess methodsFor: 'Updating' stamp: 'BrunoBB 01/28/2015 04:45'!
processId: newValue

   "Modify the value of the instance variable 'processId'."
   processId := newValue! !

!OrbeonFormProcess methodsFor: 'gateway processing' stamp: 'BrunoBB 06/14/2015 16:32'!
processNextGatewayInstances: nextTransitions from: anOrbeonTransition
	"Create a concrete Gateway for each transition definition in collection <nextTransitions> that was started from the finished transition <anOrbeonTransition>.
	Each TransitionDefinition in <nextTransitions> collection its end node is a Gateway"
	| incomingTransitionsToGate |

	incomingTransitionsToGate := nextTransitions collect: [:trDefintion | trDefintion createGatewayTransitionIn: self from: anOrbeonTransition].
	executedTransitions addAll: incomingTransitionsToGate.
"aTransition isGatewayBridge"
	incomingTransitionsToGate do: [:inTransition | | gatewayDefinition newGateway | 
		gatewayDefinition := inTransition definition endNode. "the <endNode> of the transition is the Gateway !!!!!!"
		newGateway := (self hasGatewayInstanceFor: gatewayDefinition) "the gateway has been created by a previous incoming transition ?"
								ifTrue: [runningGateways at: gatewayDefinition nodeName] 
								ifFalse: [self createGatewayInstanceFor: gatewayDefinition].
		newGateway process: self;
			processIncomingTransition: inTransition.]. "<inTransition> triggerOobject: <newGateway>"! !

!OrbeonFormProcess methodsFor: 'run' stamp: 'BrunoBB 06/14/2015 13:56'!
processNextTransitions: nextTransitions from: anOrbeonFormTransition
	"Create concrete transtions for each transition definition <OrbeonFormTransitionDefinition> in collection <nextTransitions> starting from finished transition <anOrbeonFormTransition> (parent transition).
	1. Create the concrete transitions.
	2- Update the two collections <runningTransitions> and <executedTransitions>"
	| formTransitions |

	^anOrbeonFormTransition endNodeIsGateway
	ifTrue: [self processGatewayIncomingTransition: anOrbeonFormTransition 
						evaluatingNext: nextTransitions.]
	ifFalse: [self processNextGatewayInstances: (nextTransitions select: [:each | each endNodeIsGateway]) from: anOrbeonFormTransition.
				self processNextTransitionsWithForm: (nextTransitions reject: [:each | each endNodeIsGateway]) 
						from: anOrbeonFormTransition].! !

!OrbeonFormProcess methodsFor: 'run' stamp: 'BrunoBB 10/10/2015 12:36'!
processNextTransitionsWithForm: nextTransitions from: parentOrbeonFormTransition
	"The receiver iterate over the collection of <OrbeonFormTransitionDefinition><nextTransitions> and create the concrete instances of <OrbeonFormTransition>.
	All concrete transition are started from <parentOrbeonFormTransition>"
	| formTransitions |

	formTransitions := nextTransitions collect: [:trDefintion | trDefintion createFormTransitionIn: self from: parentOrbeonFormTransition].

	runningTransitions addAll: (formTransitions reject: [:each | each isEndTransition]). "<formTransitions> new running transitions"
	executedTransitions addAll: (formTransitions select: [:each | each isEndTransition]).

	^formTransitions! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
removeAssignment: anOrbeonProcessAssignment

	"anOrbeonProcessAssignment formProcess: nil."
	assignments remove: anOrbeonProcessAssignment ifAbsent: [].
	cancelledAssignments add: anOrbeonProcessAssignment.! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/29/2015 09:53'!
removeAssignments

	assignments do: [:each | each removeUsers].
	orbeonFormInstances := Dictionary new.
	assignments := OrderedCollection new.! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
removeFromDefinitionDictionary

	^definition removeInstanceId: processId! !

!OrbeonFormProcess methodsFor: 'gateway processing' stamp: 'BrunoBB 06/15/2015 07:55'!
removeFromRunningGateways: aProcessGateway
	"The receiver remove the gateway <aProcessGateway> from the <runningGateways> dictionary and add it to <executedGateways> dictionary.
	The gateway <aProcessGateway> has process all outgoing transitions"

	runningGateways removeKey: aProcessGateway gatewayName ifAbsent: [].

	(executedGateways includesKey: aProcessGateway gatewayName) 
	ifFalse: [executedGateways at: aProcessGateway gatewayName put: OrderedCollection new].

	(executedGateways at: aProcessGateway gatewayName) add: aProcessGateway! !

!OrbeonFormProcess methodsFor: 'run' stamp: 'BrunoBB 07/05/2015 16:03'!
resumeParentProcessExecutionFrom: childFormProcess
	"The receiver resume it's execution after the -child- sub process <childOrbeonFormProcess> has finished "
	| subProcessTransition |

	"we get the transition that started the sub process <childOrbeonFormProcess> "
	subProcessTransition := pendingTransitions at: childFormProcess. 
	subProcessTransition finalize.

	^self generateNextTransitionsFrom: subProcessTransition! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
rootTransitions

	^self pathDefinition rootTransitions! !

!OrbeonFormProcess methodsFor: 'Accessing' stamp: 'BrunoBB 04/08/2015 17:14'!
runningGateways
	^runningGateways! !

!OrbeonFormProcess methodsFor: 'Updating' stamp: 'BrunoBB 04/08/2015 17:14'!
runningGateways: newValue
	runningGateways := newValue! !

!OrbeonFormProcess methodsFor: 'Accessing' stamp: 'BrunoBB 01/28/2015 04:45'!
runningTransitions

   "Return the value of the instance variable 'runningTransitions'."
   ^runningTransitions! !

!OrbeonFormProcess methodsFor: 'Updating' stamp: 'BrunoBB 01/28/2015 04:45'!
runningTransitions: newValue

   "Modify the value of the instance variable 'runningTransitions'."
   runningTransitions := newValue! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 04:45'!
selectRunningTransitionFor: anOrbeonFormInstance

	^runningTransitions detect: [:each | each endNodeFormDefinition == anOrbeonFormInstance definition] ifNone: []! !

!OrbeonFormProcess methodsFor: 'run' stamp: 'BrunoBB 06/18/2015 12:46'!
setTransitionWithExecutedForm: anOrbeonFormTransition
	| reusableTransitionForm |

	reusableTransitionForm := executedTransitions detect: [:each | each definition endNodeFormDefinition == anOrbeonFormTransition definition endNodeFormDefinition] ifNone: [^self].

	anOrbeonFormTransition orbeonFormInstance: reusableTransitionForm orbeonFormInstance! !

!OrbeonFormProcess methodsFor: 'run' stamp: 'BrunoBB 05/14/2015 06:20'!
startProcessRoots
	"For each root transition definition (startTransition = nil) create a corresponding concrete transition "

	^runningTransitions addAll: (self rootTransitions collect: [:each | each createFormTransitionIn: self from: nil]) asOrderedCollection! !

!OrbeonFormProcess methodsFor: 'Accessing' stamp: 'BrunoBB 01/28/2015 04:45'!
subProcesses

   "Return the value of the instance variable 'subProcesses'."
   ^subProcesses! !

!OrbeonFormProcess methodsFor: 'Updating' stamp: 'BrunoBB 01/28/2015 04:45'!
subProcesses: newValue

   "Modify the value of the instance variable 'subProcesses'."
   subProcesses := newValue! !

!OrbeonFormProcess methodsFor: 'other' stamp: 'BrunoBB 06/12/2015 15:22'!
version

	^definition version! !

OrbeonObject subclass: #OrbeonFormProcessDefinition
	instanceVariableNames: 'processId name orbeonFormPathDefinition formProcessInstances formRols orbeonApplication version parentProcess subProcesses originalName xmlString formFieldInstances'
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!OrbeonFormProcessDefinition commentStamp: 'BrunoBB 08/13/2014 09:37' prior: 0!
This class is a concrete definition of an Orbeon Form.

processId 							- id of the receiver
name 									- name of the receiver
orbeonFormPathDefinition	- path of the receiver (transitions)
formProcessInstances 		- concrete instance process of the receiver
formRols 								- grants rols of the receiver
orbeonApplication 				- application that belongs the receiver
isSingleRole							- whether the receiver is single rol or not
isSurvey								- whether the receiver is a survey or not!

!OrbeonFormProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 03/14/2015 16:34'!
cache

	Cache ifNil: [Cache := Dictionary new].

	^Cache! !

!OrbeonFormProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 10/19/2015 18:00'!
formWithServicesExample
	^'<xh:html xmlns:xh="http://www.w3.org/1999/xhtml" xmlns:xf="http://www.w3.org/2002/xforms"
         xmlns:xs="http://www.w3.org/2001/XMLSchema"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xmlns:ev="http://www.w3.org/2001/xml-events"
         xmlns:xi="http://www.w3.org/2001/XInclude"
         xmlns:xxi="http://orbeon.org/oxf/xml/xinclude"
         xmlns:xxf="http://orbeon.org/oxf/xml/xforms"
         xmlns:exf="http://www.exforms.org/exf/1-0"
         xmlns:fr="http://orbeon.org/oxf/xml/form-runner"
         xmlns:saxon="http://saxon.sf.net/"
         xmlns:sql="http://orbeon.org/oxf/xml/sql"
         xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/"
         xmlns:fb="http://orbeon.org/oxf/xml/form-builder">
   <xh:head>
        <xh:meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
        <xh:title>formulario-completo</xh:title>      
        <xf:model id="fr-form-model" xxf:expose-xpath-types="true">        
         <!!-- Main instance -->         
         <xf:instance id="fr-form-instance" xxf:exclude-result-prefixes="#all">            
                <form>               
                    <section-internalData>                             
                        <s/>                  
                        <k/>                  
                        <gstoken/>                 
                        <oop/>                
                    </section-internalData>
                    <section-12>
                        <username/>
                        <rol/>
                    </section-12>
                    <datos-socio>
                        <datos-socio-iteration>
                            <nombre/>
                            <apellido/>
                            <telefono/>
                            <numero-socio/>
                        </datos-socio-iteration>
                    </datos-socio>               
                </form>          
            </xf:instance>       
            <!!-- Bindings -->
         <xf:bind id="fr-form-binds" ref="instance(''fr-form-instance'')">
                <xf:bind id="section-internalData-bind" name="section-internalData"
                         ref="section-internalData">
                    <xf:bind id="s-bind" name="s" ref="s" xxf:default="xxf:get-request-parameter(''s'')"
                             calculate="xxf:get-request-parameter(''s'')"/>
                    <xf:bind id="k-bind" ref="k" name="k" xxf:default="xxf:get-request-parameter(''k'')"
                             calculate="xxf:get-request-parameter(''k'')"/>
                    <xf:bind id="gstoken-bind" ref="gstoken" name="gstoken"
                             xxf:default="xxf:get-request-parameter(''token'')"
                             calculate="xxf:get-request-parameter(''token'')"/>
                    <xf:bind id="oop-bind" ref="oop" name="oop"
                             xxf:default="xxf:get-request-parameter(''oop'')"
                             calculate="xxf:get-request-parameter(''oop'')"/>
                </xf:bind>
                <xf:bind id="datos-socio-bind" ref="datos-socio" name="datos-socio">
                    <xf:bind id="datos-socio-iteration-bind" ref="datos-socio-iteration"
                             name="datos-socio-iteration">
                        <xf:bind id="nombre-bind" ref="nombre" name="nombre"/>
                        <xf:bind id="apellido-bind" ref="apellido" name="apellido"/>
                        <xf:bind id="telefono-bind" ref="telefono" name="telefono"/>
                        <xf:bind id="numero-socio-bind" ref="numero-socio" name="numero-socio"/>
                    </xf:bind>
                </xf:bind>
                <xf:bind id="section-12-bind" ref="section-12" name="section-12">
                    <xf:bind id="username-bind" ref="username" name="username"/>
                    <xf:bind id="rol-bind" ref="rol" name="rol"/>
                </xf:bind>
            </xf:bind>
            <!!-- Metadata -->        
         <xf:instance xxf:readonly="true" id="fr-form-metadata" xxf:exclude-result-prefixes="#all">
                <metadata>
                    <application-name>bull</application-name>
                    <form-name>formulario-completo</form-name>              
                    <title xml:lang="en">formulario-completo</title>
                    <description xml:lang="en"/>
                </metadata>
            </xf:instance>
            <!!-- Attachments -->
         <xf:instance id="fr-form-attachments" xxf:exclude-result-prefixes="#all">
                <attachments>
                    <css mediatype="text/css" filename="" size=""/>
                    <pdf mediatype="application/pdf" filename="" size=""/>
                </attachments>
            </xf:instance>
            <!!-- All form resources -->
         <!!-- Dont make readonly by default in case a service modifies the resources -->
         <xf:instance id="fr-form-resources" xxf:readonly="false" xxf:exclude-result-prefixes="#all">
                <resources>
                    <resource xml:lang="en">
                        <username>
                            <label>Username</label>
                            <hint/>
                        </username>
                        <rol>
                            <label>Rol</label>
                            <hint/>
                        </rol>
                        <nombre>
                            <label>Nombre</label>
                            <hint/>
                        </nombre>
                        <apellido>
                            <label>Apellido</label>
                            <hint/>
                        </apellido>
                        <telefono>
                            <label>Telefono</label>
                            <hint/>
                        </telefono>
                        <numero-socio>
                            <label>Nro, Socio</label>
                            <hint/>
                        </numero-socio>
                        <section-internalData>
                            <label>Internal Data</label>
                        </section-internalData>
                        <section-12>
                            <label>User Data</label>
                            <help/>
                        </section-12>
                        <datos-socio>
                            <label>Datos Socio</label>
                            <help/>
                        </datos-socio>
                        <s>
                            <label>S</label>
                            <hint/>                    
                        </s>
                        <k>
                            <label>K</label>
                            <hint/>
                        </k>
                        <gstoken>
                            <label>UUID</label>
                            <hint/>
                        </gstoken>
                        <oop>
                            <label>OOP</label>
                            <hint/>                    
                        </oop>                 
                    </resource>              
                </resources>           
            </xf:instance>       
            <!!-- Utility instances for services -->         
         <xf:instance id="fr-service-request-instance" xxf:exclude-result-prefixes="#all">            
                <request/>            
            </xf:instance>       
            <xf:instance id="fr-service-response-instance" xxf:exclude-result-prefixes="#all">                     
                <response/>           
            </xf:instance>         
            <xf:instance id="securityService-instance" class="fr-service"
                         xxf:exclude-result-prefixes="#all">           
                <body xmlns:secure="java:org.orbeon.oxf.util.SecureUtils"
                      xmlns:frf="java:org.orbeon.oxf.fr.FormRunner"
                      xmlns:p="http://www.orbeon.com/oxf/pipeline"
                      xmlns:fbf="java:org.orbeon.oxf.fb.FormBuilder">&lt;request&gt;&lt;token/&gt;&lt;/request&gt;</body>          
            </xf:instance>
            <xf:instance xxf:readonly="true" id="datos-socio-template">
                <datos-socio-iteration>
                    <nombre/>
                    <apellido/>
                    <telefono/>
                    <numero-socio/>
                </datos-socio-iteration>
            </xf:instance>       
            <xf:submission id="securityService-submission" class="fr-service"
                           ref="instance(''fr-service-request-instance'')"
                           resource="http://192.168.56.128:8888/orbeon-api/securityToken?token={xf:instance(''fr-form-instance'')/section-internalData/gstoken}"
                           method="get"
                           serialization="application/xml"
                           mediatype="application/xml"
                           replace="instance"
                           instance="fr-service-response-instance"/>         
            <xf:action id="setDatos-binding">           
            <!!-- React to event... on control... -->           
            <xf:action ev:event="xforms-ready" ev:observer="fr-form-model" if="$fr-mode=''new''">              
               <!!-- Service to call -->              
               <xf:send submission="securityService-submission"/>             
                </xf:action>          
                <!!-- Request actions -->           
            <xf:action ev:event="xforms-submit" ev:observer="securityService-submission">                
               <!!-- Get reference to initial request -->               
               <xf:var name="request-instance-name" value="''securityService-instance''" as="xs:string"/>               
                    <!!-- Copy over to read-write request instance -->               
               <xf:insert ref="instance(''fr-service-request-instance'')"
                               origin="saxon:parse(instance($request-instance-name))"/>               
                    <!!--<xf:insert ref="instance(''fr-service-request-instance'')" origin="instance($request-instance-name)"/>-->
               <!!-- Set values if needed -->            
               <xf:action context="instance(''fr-service-request-instance'')">                
                        <xf:action class="fr-set-service-value-action">
                            <xf:var name="control-name" value="''gstoken''"/>
                            <xf:var name="path" value="/request/token"/>
                        </xf:action>                 
                        <!!-- Setvalue actions will be here -->                  
               </xf:action>               
                </xf:action>           
                <!!-- Response actions -->    
            <xf:action ev:event="xforms-submit-done" ev:observer="securityService-submission"
                           context="instance(''fr-service-response-instance'')">             
                    <xf:action class="fr-set-control-value-action">
                        <xf:var name="control-name" value="''username''"/>
                        <xf:var name="control-value" value="/result/username"/>
                    </xf:action>
                    <xf:action class="fr-set-control-value-action">
                        <xf:var name="control-name" value="''rol''"/>
                        <xf:var name="control-value" value="/result/rol"/>
                    </xf:action>            
                    <!!-- Response actions will be here -->             
            </xf:action>          
            </xf:action>
        </xf:model>   
   </xh:head>
   <xh:body>
        <fr:view>      
            <fr:body xmlns:xbl="http://www.w3.org/ns/xbl"
                     xmlns:oxf="http://www.orbeon.com/oxf/processors"
                     xmlns:p="http://www.orbeon.com/oxf/pipeline">  
                <fr:section id="section-internalData-control" bind="section-internalData-bind">
                    <xf:label ref="$form-resources/section-internalData/label"/>
                    <fr:grid>
                        <xh:tr>
                            <xh:td>
                                <xf:input id="s-control" bind="s-bind">
                                    <xf:label ref="$form-resources/s/label"/>
                                    <xf:hint ref="$form-resources/s/hint"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                            <xh:td>
                                <xf:input id="k-control" bind="k-bind">
                                    <xf:label ref="$form-resources/k/label"/>                          
                                    <xf:hint ref="$form-resources/k/hint"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                        </xh:tr>
                        <xh:tr>
                            <xh:td>
                                <xf:input id="gstoken-control" bind="gstoken-bind">
                                    <xf:label ref="$form-resources/gstoken/label"/>
                                    <xf:hint ref="$form-resources/gstoken/hint"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                            <xh:td>
                                <xf:input id="oop-control" bind="oop-bind">
                                    <xf:label ref="$form-resources/oop/label"/>
                                    <xf:hint ref="$form-resources/oop/hint"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                        </xh:tr>
                    </fr:grid>
                </fr:section>
                <fr:section id="section-12-control" bind="section-12-bind">
                    <xf:label ref="$form-resources/section-12/label"/>
                    <fr:grid>
                        <xh:tr>
                            <xh:td>
                                <xf:input id="username-control" bind="username-bind">
                                    <xf:label ref="$form-resources/username/label"/>
                                    <xf:hint ref="$form-resources/username/hint"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                            <xh:td>
                                <xf:input id="rol-control" bind="rol-bind">
                                    <xf:label ref="$form-resources/rol/label"/>
                                    <xf:hint ref="$form-resources/rol/hint"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                        </xh:tr>
                    </fr:grid>
                </fr:section>
                <fr:section id="datos-socio-control" bind="datos-socio-bind" repeat="true" min="1"
                            template="instance(''datos-socio-template'')">
                    <xf:label ref="$form-resources/datos-socio/label"/>
                    <fr:grid>
                        <xh:tr>
                            <xh:td>
                                <xf:input id="nombre-control" bind="nombre-bind" class="fr-summary">
                                    <xf:label ref="$form-resources/nombre/label"/>
                                    <xf:hint ref="$form-resources/nombre/hint"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                        </xh:tr>
                        <xh:tr>
                            <xh:td>
                                <xf:input id="apellido-control" bind="apellido-bind" class="fr-summary fr-search">
                                    <xf:label ref="$form-resources/apellido/label"/>
                                    <xf:hint ref="$form-resources/apellido/hint"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                        </xh:tr>
                        <xh:tr>
                            <xh:td>
                                <xf:input id="telefono-control" bind="telefono-bind" class="fr-search">
                                    <xf:label ref="$form-resources/telefono/label"/>
                                    <xf:hint ref="$form-resources/telefono/hint"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                        </xh:tr>
                        <xh:tr>
                            <xh:td>
                                <xf:input id="numero-socio-control" bind="numero-socio-bind" class="fr-summary fr-search">
                                    <xf:label ref="$form-resources/numero-socio/label"/>
                                    <xf:hint ref="$form-resources/numero-socio/hint"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                        </xh:tr>
                    </fr:grid>
                </fr:section>
            </fr:body>
        </fr:view>
   </xh:body>
</xh:html>'! !

!OrbeonFormProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
getAllLatestVersionIn: appName

	^(self cache at: appName ifAbsent: [^nil]) collect: [:each | each last]! !

!OrbeonFormProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
getAllLatestVersions
	| allLatestDefinitions |

	allLatestDefinitions := OrderedCollection new.
	self cache do: [:eachDict | 
			eachDict do: [:eachCol | 
				eachCol notEmpty ifTrue: [allLatestDefinitions add: eachCol last]]].

	^allLatestDefinitions! !

!OrbeonFormProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 09/28/2015 12:47'!
getAllProcessInstancesOf: processNamed in: appName
	"Answer a collection of <OrbeonFormProcess> with all processes instances of process named <processNamed> in application <appName>.
	Includes instances of all process versions"
	| definitions instances |

	instances := OrderedCollection new.
	definitions := self getProcessesNamed: processNamed in: appName. "get all process versions of <processNamed> in <appName>"

	definitions ifNil: [^#()].

	definitions do: [:each | instances addAll: each formProcessInstances asOrderedCollection].

	^instances! !

!OrbeonFormProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
getAllVersions
	| allDefinitions |

	allDefinitions := OrderedCollection new.
	self cache do: [:eachDict | 
			eachDict do: [:eachCol | allDefinitions addAll: eachCol]].

	^allDefinitions! !

!OrbeonFormProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
getAllVersionsIn: appName
	| all |

	all := OrderedCollection new.
	(self cache at: appName ifAbsent: [^all]) do: [:each | all addAll: each].

	^all! !

!OrbeonFormProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 09/28/2015 13:59'!
getAssignmentsIn: appName processName: processNamed formName: formNamed fieldName: fieldNamed withValue: fieldValue
	"The receiver answer a collection of <OrbeonProcessAssignment> in application named <appName>  for process type <processNamed> where the field named <fieldNamed> is equal to <fieldValue>"
	| procDefinition |

	procDefinition := self getProcessNamed: processNamed in: appName.
	procDefinition ifNil: [^#()].

	^procDefinition getFieldsNamed: fieldNamed withValue: fieldValue in: formNamed! !

!OrbeonFormProcessDefinition class methodsFor: 'free transitions' stamp: 'BrunoBB 10/18/2015 16:18'!
getFreeTransitionsFor: anOrbeonFormUser
	"Answer aDictionary where keys are ProcessInstances and values are collections of missing rols for that process."
	| processInstances processesWithMissingAssignment |

	processesWithMissingAssignment := Dictionary new.
	processInstances := OrderedCollection new.
	self getAllLatestVersions do: [:each | processInstances addAll: each formProcessInstances asArray].

	processInstances do: [:eachProc | | missingRoles |
		missingRoles := eachProc getMissingRoleAssignmentAsCollection. "get missings roles of each process"
		(anOrbeonFormUser includesAnyRoleOf: missingRoles) "the current user includes the missing rol ?"
		ifTrue: [processesWithMissingAssignment at: eachProc put: missingRoles]]. 

	^processesWithMissingAssignment! !

!OrbeonFormProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 03/12/2015 15:40'!
getLatestVersionOf: processName in: appName
	| versionCollection |

	versionCollection := ((self cache at: appName ifAbsent: [^nil]) at: processName ifAbsent: [^nil]).

	versionCollection isEmpty ifTrue: [^nil].

	^versionCollection last! !

!OrbeonFormProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 09/28/2015 12:40'!
getProcessesDefinitionOf: appName using: formName
	"The receiver answer a collection of <OrbeonFormProcessDefinition> in application <named ppName> where the process definition use the form named <formName> "
	| definitions |

	definitions := OrderedCollection new.
	(self getAllVersionsIn: appName) do: [:eachDefinition | 
		(eachDefinition hasFormType: formName) ifTrue: [definitions add: eachDefinition]].

	^definitions! !

!OrbeonFormProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 09/28/2015 12:42'!
getProcessesNamed: aString in: appName

	^((self cache at: appName ifAbsent: [^nil])
			at: aString ifAbsent: [^nil])! !

!OrbeonFormProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
getProcessInstance: processNro ifNone: aBlock
	| proc |

	self cache do: [:eachDict | 
		eachDict do: [:eachCollection | 
			eachCollection do: [:eachDef | 
				proc := eachDef getProcessInstance: processNro ifNone: [].
				proc ifNotNil: [^proc]]]].

	^aBlock value! !

!OrbeonFormProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
getProcessInstancesOf: applicationNamed
	| applicationDict processes |

	"cache is Dictionary where the key is the application name and the value is the OrbeonApplication"
	applicationDict := self cache at: applicationNamed ifAbsent: [^OrderedCollection new].

	processes := OrderedCollection new.

	applicationDict do: [:eachDictionary | 
		"eachDictionary key is the Processes Definition name and value is a collection of version definitions "
			eachDictionary do: [:eachDef | processes addAll: eachDef formProcessInstances asOrderedCollection]].

	^processes! !

!OrbeonFormProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
getProcessInstancesOf: applicationNamed ofFormNamed: formName
	| applicationDict definitions processes |

	"cache is Dictionary where the key is the application name and the value is the OrbeonApplication"
	applicationDict := self cache at: applicationNamed ifAbsent: [^OrderedCollection new].

	"each key of <applicationDict> is a Collection (of versions) of OrbeonFormProcessDefinition "
	definitions := self getProcessesDefinitionOf: applicationNamed using: formName.

	processes := OrderedCollection new.

	definitions do: [:eachDefinition | processes addAll: eachDefinition formProcessInstances asOrderedCollection].

	^processes! !

!OrbeonFormProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
getProcessNamed: aString in: appName

	^((self cache at: appName ifAbsent: [^nil])
			at: aString ifAbsent: [^nil]) last! !

!OrbeonFormProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
getProcesssDefinitionFor: appName form: formName

	^(self cache at: appName ifAbsent: [nil])
		detect: [:eachProcCollection | eachProcCollection last hasProcessFor: appName form: formName] 
		ifNone: [nil]! !

!OrbeonFormProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
initializeCache

	Cache := Dictionary new! !

!OrbeonFormProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 10/19/2015 17:57'!
removeProcessDefinitions

	self removeProcessInstances.

	self getAllVersions do: [:each | each removeFromCache. "-this remove the process definition from cache-"].

	self cache keys do: [:each | self cache at: each put: Dictionary new].! !

!OrbeonFormProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 10/19/2015 17:55'!
removeProcessInstances

	OrbeonFormRole cache do: [:usrDictionary | usrDictionary do: [:each | each unregisterAll]].

	OrbeonFormUser cache do:[:each | each untakeAll].

	self getAllVersions do: [:each | 
		each removeProcessInstances].! !

!OrbeonFormProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
transformCache
	| newCache |

	newCache := Dictionary new.
	self cache do: [:each | 
		newCache 
			at: each orbeonApplication app 
			put: (Dictionary new at: each name put: (OrderedCollection with: each); yourself)].

	^newCache! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 06/16/2015 07:40'!
addLoopType: loopType toFormNamed: aString

	^orbeonFormPathDefinition addLoopType: loopType toFormNamed: aString! !

!OrbeonFormProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 03/14/2015 14:42'!
addSubProcess: anOrbeonFormProcessDefinition
	"Add the subprocess <anOrbeonFormProcessDefinition> to the receiver"

	anOrbeonFormProcessDefinition parentProcess: self.

	^subProcesses add: anOrbeonFormProcessDefinition! !

!OrbeonFormProcessDefinition methodsFor: 'field values' stamp: 'BrunoBB 09/13/2015 17:47'!
addTo: formNamed fieldValue: aFormFieldValue
	"The receiver add to Orbeon form named <formNamed> the field value <aFormFieldValue>.
	The receiver holds a Dictionary with all form's name. Each form's name Dictionary is a Dictionary of fields's name. The value at a given field's name is anUnorderedCollection.
	(formName)>>(fieldName)>>(anUnorderedCollection)"
	| fieldsDictionary fieldCollection |

	fieldsDictionary := (formFieldInstances includesKey: formNamed) 
		ifTrue: [formFieldInstances at: formNamed]
		ifFalse: [formFieldInstances at: formNamed put: Dictionary new].

	fieldCollection := (fieldsDictionary includesKey: aFormFieldValue name)
		ifTrue: [fieldsDictionary at: aFormFieldValue name]
		ifFalse: [| indexedCollection |
			indexedCollection := RcIdentityBag new.
			fieldsDictionary at: aFormFieldValue name put: indexedCollection.
			indexedCollection add: aFormFieldValue.
			"indexes can NOT be created on empty collections so we add the element first"
			self createFieldIndexFor: aFormFieldValue in: formNamed on: indexedCollection.
			^aFormFieldValue].

	^fieldCollection add: aFormFieldValue! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 03/14/2015 14:43'!
addToCache
	"Add the receiver to the global cache for this class"
	| appDefinitions defVersions |

	(name isNil or:[name isEmpty]) ifTrue: [^NoProcessNameException signal: 'ProcessDefinition MUST have a name'].
	orbeonApplication ifNil: [^NoOrbeonAppException signal: 'ProcessDefinition MUST have anOrbeonApplication'].

	appDefinitions := (self class cache includesKey: orbeonApplication app)
			ifTrue: [self class cache at: orbeonApplication app]
			ifFalse: [self class cache at: orbeonApplication app put: Dictionary new].

	defVersions := (appDefinitions includesKey: name) 
			ifTrue: [appDefinitions at: name] 
			ifFalse: [appDefinitions at: name put: OrderedCollection new].

	defVersions isEmpty 
	ifFalse: [(version = (defVersions last version + 1)) 
		ifFalse: [^BrokenVersionChainException signal: 'The new version [', version printString, '] broke the previous version chain [', defVersions last version printString, ']. Version should be [', (defVersions last version + 1) printString, ']']].

	defVersions add: self.! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
addTransition: anOrbeonFormTransitionDefinition
	"Add a transition <anOrbeonFormTransitionDefinition> to the path of the receiver "

	self canModifyPathDefinition ifFalse: [^CanNotModifyPathDefinitionException signal].

	^orbeonFormPathDefinition addToPath: anOrbeonFormTransitionDefinition! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
applicationDefinitions

	^orbeonApplication getLastDefinitions! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
applicationName

	orbeonApplication ifNil: [^'N/A'].

	^orbeonApplication app! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
canCreateProcess: anOrbeonFormUser
	"Create a new instance of the receiver. This new object (process) is a Smalltalk instance of SingleRoleFormProcess or MultipleRoleFormProcess"

	^orbeonFormPathDefinition canCreateProcess: anOrbeonFormUser! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
canEndProcess: anOrbeonFormUser
	"Create a new instance of the receiver. This new object (process) is a Smalltalk instance of SingleRoleFormProcess or MultipleRoleFormProcess"

	^orbeonFormPathDefinition canEndProcess: anOrbeonFormUser! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
canModifyPathDefinition

	^formProcessInstances isEmpty

	"Only Definitions with NO processes instances can modify it's PathDefinition. Otherwise is other Version of the Definition.

	Once a Process Definition has one instance the entire meta-model framework has started to work in that conditions (PDef,TrDef, Pr, Tr). If we want to modify for some reason a running process you should:
	1- Create another Definition.
	2- Migrate the current Process Instance to the new definition.
	This process could be complicated...NOT totally automatically !!!!!! (depending on the PathDefinition of both ProcessDefinition)"! !

!OrbeonFormProcessDefinition methodsFor: 'clone' stamp: 'BrunoBB 05/18/2015 15:02'!
clone
	| newDefinition |

	newDefinition := self class new.
	self clonePathDefinitionForNewVersion: newDefinition.
	^newDefinition
		name: name;
		version: version + 1;
		formRols: formRols copy;
		orbeonApplication: orbeonApplication;
		yourself! !

!OrbeonFormProcessDefinition methodsFor: 'clone' stamp: 'BrunoBB 01/16/2015 11:06'!
clonePathDefinitionForNewVersion: newDefinition

	newDefinition orbeonFormPathDefinition
		transitions: (self cloneTransitionsForNewVersion: newDefinition);
		yourself.

	^newDefinition! !

!OrbeonFormProcessDefinition methodsFor: 'clone' stamp: 'BrunoBB 01/23/2015 05:11'!
cloneStartEndNodeIn: newDefinition
	| pathDefinition startNode endNode |

	pathDefinition := newDefinition orbeonFormPathDefinition.
	startNode := OrbeonStartNode for: newDefinition.
	startNode formDefinition: orbeonFormPathDefinition startNode formDefinition;
		startConditions: orbeonFormPathDefinition startNode startConditions copy;
		endConditions: orbeonFormPathDefinition startNode endConditions copy;
		yourself.
	endNode := OrbeonEndNode for: newDefinition.
	endNode formDefinition: orbeonFormPathDefinition endNode formDefinition;
		startConditions: orbeonFormPathDefinition endNode startConditions copy;
		endConditions: orbeonFormPathDefinition endNode endConditions copy;
		yourself.

	pathDefinition startNode: startNode; endNode: endNode.! !

!OrbeonFormProcessDefinition methodsFor: 'clone' stamp: 'BrunoBB 04/06/2015 11:21'!
cloneTransition: anProcessTransitionDefinition in: anOrbeonFormProcessDefinition
	| pathDefinition clonedTransition |

	pathDefinition := anOrbeonFormProcessDefinition orbeonFormPathDefinition.
	clonedTransition := OrbeonFormTransitionDefinition new 						
				pathDefinition: pathDefinition; 
				initializeStartAndEndNodes;
				startNodeWith: anProcessTransitionDefinition startNodeFormDefinition;
				endNodeWith: anProcessTransitionDefinition endNodeFormDefinition;
				allowRollback: anProcessTransitionDefinition allowRollback;
				rollbackRols: anProcessTransitionDefinition rollbackRols copy;
				startConditions: anProcessTransitionDefinition startConditions;
				endConditions: anProcessTransitionDefinition endConditions;
				rolsRuntimeConditions: anProcessTransitionDefinition rolsRuntimeConditions copy;
				expectedResult: anProcessTransitionDefinition expectedResult copy;
				previousFields: anProcessTransitionDefinition previousFields copy;
				yourself.
	anProcessTransitionDefinition grantedRols do: [:each | clonedTransition grant: each].
	anOrbeonFormProcessDefinition addTransition: clonedTransition.

	^clonedTransition! !

!OrbeonFormProcessDefinition methodsFor: 'clone' stamp: 'BrunoBB 01/16/2015 11:06'!
cloneTransitionsForNewVersion: newDefinition
	| pathDefinition |

	pathDefinition := newDefinition orbeonFormPathDefinition.
	self cloneStartEndNodeIn: newDefinition.

	^self transitions collect: [:each | self cloneTransition: each in: newDefinition]! !

!OrbeonFormProcessDefinition methodsFor: 'field values' stamp: 'BrunoBB 09/13/2015 17:45'!
createFieldIndexFor: aFormFieldValue in: formNamed on: indexedCollection
	"Create a collection (RcIdentityBag) that hold indexes for the field values of <aFormFieldValue> in the form <formNamed>"
	| transition formDefinition |

	transition := self getTransitionWith: formNamed ifNone: [^NoOrbeonFormException signal: 'No such form definition ', formNamed].

	transition endNodeFormDefinitionNotNil ifFalse: [^NoOrbeonFormException signal: 'No such form definition ', formNamed].

	formDefinition := transition endNodeFormDefinition.

	^formDefinition createFieldIndexFor: aFormFieldValue on: indexedCollection! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
createProcess: anOrbeonFormUser
	"Create a new instance of the receiver. This new object (process) is a Smalltalk instance of SingleRoleFormProcess or MultipleRoleFormProcess"
	| newProcess |

	newProcess := (OrbeonFormProcess definition: self) name: name; yourself. "a single or multi role Form Process"
	newProcess creatorUser: anOrbeonFormUser.

	formProcessInstances at: newProcess processId put: newProcess.

	^newProcess! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/27/2015 04:47'!
endSubProcessNodes

	^orbeonFormPathDefinition endSubProcessNodes! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
endTransitions
	"The receiver answer a collection of transitions which it's -end node- is the END of the path"

	^orbeonFormPathDefinition endTransitions! !

!OrbeonFormProcessDefinition methodsFor: 'field values' stamp: 'BrunoBB 07/07/2015 13:51'!
formFieldInstances
	^formFieldInstances! !

!OrbeonFormProcessDefinition methodsFor: 'field values' stamp: 'BrunoBB 07/07/2015 13:51'!
formFieldInstances: newValue
	formFieldInstances := newValue! !

!OrbeonFormProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 01/16/2015 11:06'!
formProcessInstances

   "Return the value of the instance variable 'formProcessInstances'."
   ^formProcessInstances! !

!OrbeonFormProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 01/16/2015 11:06'!
formProcessInstances: newValue

   "Modify the value of the instance variable 'formProcessInstances'."
   formProcessInstances := newValue! !

!OrbeonFormProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 01/16/2015 11:06'!
formRols

   "Return the value of the instance variable 'formRols'."
   ^formRols! !

!OrbeonFormProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 01/16/2015 11:06'!
formRols: newValue

   "Modify the value of the instance variable 'formRols'."
   formRols := newValue! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 07/17/2015 13:26'!
getFieldsDictionaryFor: formName

	^formFieldInstances at: formName ifAbsent: [Dictionary new]! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 09/28/2015 15:39'!
getFieldsNamed: fieldNamed withValue: fieldValue in: formNamed
	"The receiver answer a collection of <OrbeonProcessAssignment>s with field named <fieldNamed> with value <fieldValue> in form <formNamed>"
	| formDictionary fieldRcUnCollection |

	formDictionary := formFieldInstances at: formNamed ifAbsent: [^#()].
	fieldRcUnCollection := formDictionary at: fieldNamed ifAbsent: [^#()].

	"^fieldRcUnCollection select:[:each | each value = fieldValue] thenCollect: [:each | each getAssignment]"

	^(GsQuery fromString: ('each.value  = ', fieldValue printString) on: fieldRcUnCollection) queryResult 
		collect: [:each | each getAssignment]! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
getProcessInstance: processNro ifNone: aBlock

	^formProcessInstances at: processNro ifAbsent: aBlock! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 03/14/2015 14:47'!
getTransitionsNames
	"Answer the names of the end forms of each receiver's transition"

	^orbeonFormPathDefinition getTransitionsNames! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 03/14/2015 14:48'!
getTransitionWith: endFormName ifNone: noneBlock
	"Answer the transition definition with end form name <endFormName> if none evaluates the block <noneBlock>"

	^orbeonFormPathDefinition getTransitionWith: endFormName ifNone: noneBlock! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 07/06/2015 13:59'!
getTypeOf: fieldNamed in: formName ifNone: aBlock
	| transition formDefinition |

	transition := self getTransitionWith: formName ifNone: [^aBlock value].

	formDefinition := transition endNode formDefinition.

	^formDefinition typeOf: fieldNamed! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
hasConcreteInstances

	^formProcessInstances notEmpty! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
hasFinishedProcesses
	"Answer whether or not the receiver has a concrete instance <anOrbeonFormProcess> in a finished state "

	^formProcessInstances anySatisfy: [:each | each finished]! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 03/14/2015 14:50'!
hasFormType: stringFormName
	"Answer whether or not the receiver has form named (or of type) <stringFormName>"

	^(self getTransitionWith: stringFormName ifNone: [nil]) notNil! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
hasProcessFor: appName form: formName

	^orbeonFormPathDefinition hasProcessFor: appName form: formName! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
hasReadAccess: anOrbeonFormUser

	^self transitions anySatisfy: [:each | each isGrantedRole: anOrbeonFormUser]! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/29/2015 15:19'!
hasSubprocesses

	^subProcesses notEmpty! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 07/07/2015 13:52'!
initialize

	super initialize.

	processId := Lag1MwcRandom new integer.
	formRols := Dictionary new.
	orbeonFormPathDefinition := OrbeonFormPathDefinition on: self.
	formProcessInstances := Dictionary new.
	version := 1.
	subProcesses := OrderedCollection new.
	formFieldInstances := Dictionary new.! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 06/16/2015 14:37'!
isMultiInstanceFormNamed: aString

	^orbeonFormPathDefinition isMultiInstanceFormNamed: aString! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 06/16/2015 15:05'!
isReusableFormNamed: aString

	^orbeonFormPathDefinition isReusableFormNamed: aString! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
migrateFrom: oldObject

	super migrateFrom: oldObject.

	version := 1.! !

!OrbeonFormProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 01/16/2015 11:06'!
name

   "Return the value of the instance variable 'name'."
   ^name! !

!OrbeonFormProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 01/16/2015 11:06'!
name: newValue

   "Modify the value of the instance variable 'name'."
   name := newValue! !

!OrbeonFormProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 01/16/2015 11:06'!
orbeonApplication

   "Return the value of the instance variable 'orbeonApplication'."
   ^orbeonApplication! !

!OrbeonFormProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 01/16/2015 11:06'!
orbeonApplication: newValue

   "Modify the value of the instance variable 'orbeonApplication'."
   orbeonApplication := newValue! !

!OrbeonFormProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 01/16/2015 11:06'!
orbeonFormPathDefinition

   "Return the value of the instance variable 'orbeonFormPathDefinition'."
   ^orbeonFormPathDefinition! !

!OrbeonFormProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 01/16/2015 11:06'!
orbeonFormPathDefinition: newValue

   "Modify the value of the instance variable 'orbeonFormPathDefinition'."
   orbeonFormPathDefinition := newValue! !

!OrbeonFormProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 05/15/2015 06:00'!
originalName
	^originalName! !

!OrbeonFormProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 05/15/2015 06:00'!
originalName: newValue
	originalName := newValue! !

!OrbeonFormProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 01/16/2015 11:17'!
parentProcess

   "Return the value of the instance variable 'parentProcess'."
   ^parentProcess! !

!OrbeonFormProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 01/16/2015 11:17'!
parentProcess: newValue

   "Modify the value of the instance variable 'parentProcess'."
   parentProcess := newValue! !

!OrbeonFormProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 06/05/2015 16:04'!
parentProcessName

	parentProcess ifNil: [^'None'].

	^parentProcess name! !

!OrbeonFormProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 01/27/2015 08:50'!
pathDefinition

   "Return the value of the instance variable 'orbeonFormPathDefinition'."
   ^orbeonFormPathDefinition! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
printNodes

	^orbeonFormPathDefinition printNodes! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
printTransitions

	^orbeonFormPathDefinition printTransitions! !

!OrbeonFormProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 01/16/2015 11:06'!
processId

   "Return the value of the instance variable 'processId'."
   ^processId! !

!OrbeonFormProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 01/16/2015 11:06'!
processId: newValue

   "Modify the value of the instance variable 'processId'."
   processId := newValue! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
register: anOrbeonFormRole
	"The receiver object register the role <anOrbeonFormRole>.
	And the receiver is registered in <anOrbeonFormRole> as a possible form process definition"

	formRols at: anOrbeonFormRole name put: anOrbeonFormRole.

	anOrbeonFormRole register: self.

	^anOrbeonFormRole! !

!OrbeonFormProcessDefinition methodsFor: 'field values' stamp: 'BrunoBB 07/13/2015 14:38'!
removeFrom: formNamed fieldValue: aFormFieldValue
	"The receiver remove from Orbeon form named <formNamed> the field value <aFormFieldValue>.
	The receiver holds a Dictionary with all form's name. Each form's name Dictionary is a Dictionary of fields's name. The value at a given field's name is anUnorderedCollection.
	(formName)>>(fieldName)>>(anUnorderedCollection)"
	| fieldsDictionary fieldCollection |

	fieldsDictionary := (formFieldInstances includesKey: formNamed) 
		ifTrue: [formFieldInstances at: formNamed]
		ifFalse: [^nil].

	fieldCollection := (fieldsDictionary includesKey: aFormFieldValue name)
		ifTrue: [fieldsDictionary at: aFormFieldValue name]
		ifFalse: [^nil].

	^fieldCollection remove: aFormFieldValue ifAbsent: [nil]! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
removeFromCache
	| appDefinitions defVersions |

	orbeonApplication ifNil: [^NoOrbeonAppException signal: 'ProcessDefinition MUST have anOrbeonApplication'].

	appDefinitions := (self class cache includesKey: orbeonApplication app)
			ifTrue: [self class cache at: orbeonApplication app]
			ifFalse: [^NoSuchObjectInCacheException signal: 'No such Orbeon Application'].

	defVersions := (appDefinitions includesKey: name) 
			ifTrue: [appDefinitions at: name] 
			ifFalse: [^NoSuchObjectInCacheException signal: 'No such Process Definition'].

	^defVersions remove: self ifAbsent: [NoSuchObjectInCacheException signal: 'No Process Definition with such version']! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
removeInstanceId: id

	^formProcessInstances removeKey: id ifAbsent: []! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/29/2015 09:53'!
removeProcessInstances

	formProcessInstances do: [:each | each removeAssignments].
	formProcessInstances := Dictionary new.! !

!OrbeonFormProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 01/16/2015 11:20'!
removeSubProcess: anOrbeonFormProcessDefinition

	anOrbeonFormProcessDefinition parentProcess: nil.

	^subProcesses remove: anOrbeonFormProcessDefinition ifAbsent: [nil]! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
removeTransition: anOrbeonFormTransitionDefinition

	self canModifyPathDefinition ifFalse: [^CanNotModifyPathDefinitionException signal].

	^orbeonFormPathDefinition removeFromPath: anOrbeonFormTransitionDefinition! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
rootTransitions
	"The initial transitions of the receiver"

	^orbeonFormPathDefinition rootTransitions! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
setName: aString

	name := aString.! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/27/2015 09:50'!
startSubProcessNodes

	^orbeonFormPathDefinition startSubProcessNodes! !

!OrbeonFormProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 01/16/2015 11:17'!
subProcesses

   "Return the value of the instance variable 'subProcesses'."
   ^subProcesses! !

!OrbeonFormProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 01/16/2015 11:17'!
subProcesses: newValue

   "Modify the value of the instance variable 'subProcesses'."
   subProcesses := newValue! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/24/2015 14:26'!
subProcessesNodes

	^orbeonFormPathDefinition subProcesses! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
transitions

	^orbeonFormPathDefinition transitions! !

!OrbeonFormProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:06'!
unregister: anOrbeonFormRole

	formRols removeKey: anOrbeonFormRole name.

	anOrbeonFormRole unregister: self.

	^anOrbeonFormRole! !

!OrbeonFormProcessDefinition methodsFor: 'field values' stamp: 'BrunoBB 09/28/2015 12:34'!
updateFieldsOfForm: anOrbeonFormInstance
	"The receiver update the dictionary <formFieldInstances> for each field value in the form <anOrbeonFormInstance>"

	anOrbeonFormInstance fieldValuesDo: [:fieldValueHolder | 
		anOrbeonFormInstance fieldsAreProcessed "is the first time that fields are going to be processed ? (enter in -false- block only once)"
		ifFalse: [fieldValueHolder currentValues do: [:each | self addTo: anOrbeonFormInstance form fieldValue: each]]
		ifTrue: [
			fieldValueHolder hasElementsToAdd 
			ifTrue: [fieldValueHolder fieldsToAddDo: [:fieldValue |
				self addTo: anOrbeonFormInstance form fieldValue: fieldValue]].

			fieldValueHolder hasElementsToRemove 
			ifTrue: [fieldValueHolder fieldsToRemoveDo: [:fieldValue |
				self removeFrom: anOrbeonFormInstance form fieldValue: fieldValue]].
		].
	].
	anOrbeonFormInstance fieldsAreProcessed: true.! !

!OrbeonFormProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 01/16/2015 11:06'!
version

   "Return the value of the instance variable 'version'."
   ^version! !

!OrbeonFormProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 01/16/2015 11:06'!
version: newValue

   "Modify the value of the instance variable 'version'."
   version := newValue! !

!OrbeonFormProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 05/15/2015 06:00'!
xmlString
	^xmlString! !

!OrbeonFormProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 05/15/2015 06:00'!
xmlString: newValue
	xmlString := newValue! !

OrbeonObject subclass: #OrbeonFormTransitionDefinition
	instanceVariableNames: 'grantedRols pathDefinition allowRollback rollbackRols startConditions endConditions rolsRuntimeConditions startNode endNode expectedResult previousFields acceptInvalidForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!OrbeonFormTransitionDefinition commentStamp: 'BrunoBB 09/13/2014 14:11' prior: 0!
This class is a definition of a transition between one Orbeon Form and another.

startFormDefinition 		- initial form of the transition an OrbeonFormDefinition
endFormDefinition 		- destination form of the transition an OrbeonFormDefinition
grantedRols					- granted rols of the receiver
pathDefinition 				- path that own's the receiver
allowRollback 				- whether or not the receiver allow a rollback operation
rollbackRols 				- rols granted to perform a rollback operation
startConditions			- conditions to start the receiver
endConditions				- conditions to finish the receiver
rolsRuntimeConditions - runtime conditions that must be fullfilled by <grantedRols> in order to be granted. If it's empty then <grantedRols> it give the permission. A condition could be form:
							(self evaluate: '[:orbeonInst | orbeonInst loanAmount > 500]') value: self.
							(self evaluate: '[:orbeonInst | orbeonInst loanAmount > 1500]') value: self
							(self evaluate: '[:orbeonInst | orbeonInst loanAmount > 15000]') value: self!

!OrbeonFormTransitionDefinition class methodsFor: 'other' stamp: 'BrunoBB 12/26/2014 09:57'!
start: startOrbeonFormDefinition end: endOrbeonFormDefinition

	^super new initialize
		startNodeWith: startOrbeonFormDefinition;
		endNodeWith: endOrbeonFormDefinition;
		yourself! !

!OrbeonFormTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 12/26/2014 10:01'!
acceptInvalidForm

   "Return the value of the instance variable 'acceptInvalidForm'."
   ^acceptInvalidForm! !

!OrbeonFormTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/26/2014 10:01'!
acceptInvalidForm: newValue

   "Modify the value of the instance variable 'acceptInvalidForm'."
   acceptInvalidForm := newValue! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/31/2014 15:44'!
addPreviousField: fieldName

	^previousFields add: fieldName trimBlanks! !

!OrbeonFormTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 12/26/2014 09:57'!
allowRollback

   "Return the value of the instance variable 'allowRollback'."
   ^allowRollback! !

!OrbeonFormTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/26/2014 09:57'!
allowRollback: newValue

   "Modify the value of the instance variable 'allowRollback'."
   allowRollback := newValue! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/26/2014 09:57'!
application


	^pathDefinition processDefinition orbeonApplication! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/26/2014 09:57'!
applicationDefinitions

	^pathDefinition applicationDefinitions! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/26/2014 09:57'!
applicationName

	^self application app! !

!OrbeonFormTransitionDefinition methodsFor: 'conditions' stamp: 'BrunoBB 12/26/2014 09:57'!
canModifyPathDefinition

	^pathDefinition canModifyPathDefinition! !

!OrbeonFormTransitionDefinition methodsFor: 'conditions' stamp: 'BrunoBB 06/15/2015 16:00'!
checkCreationRuleFor: anOrbeonFormTransition in: anOrbeonFormProcess
	| evaluation |

	startConditions ifNil: [^true]. "when no conditions --> return true to create the transition"

	self startNodeIsParallelGateway ifTrue: [^true]. "Parallel gateways does NOT perform evaluations"

	evaluation := (startConditions evaluateIn: anOrbeonFormProcess form: anOrbeonFormTransition orbeonFormInstance).

	evaluation hasException 
	ifTrue: [(OrbeonFailedEvaluation object: anOrbeonFormTransition exception: evaluation exception condition: startConditions) addToCache].

	^evaluation result! !

!OrbeonFormTransitionDefinition methodsFor: 'instance creation' stamp: 'BrunoBB 10/10/2015 12:41'!
createFormTransitionIn: anOrbeonFormProcess from: anOrbeonFormTransition
	"Creates a new instance of a transition with the receiver as it's definition.
	The parent of the new concrete transition is <anOrbeonFormTransition> and the executing process is <anOrbeonFormProcess>.
	If the form of the transition is -single instance- and was already executed at least one time --> the form of the new transition is the existing form of the old transition (is edited again). 
	If the form of the transition is -multi instance- --> a new form is always created."
	| newTransition |

	newTransition := (OrbeonFormTransition definition: self)
		process: anOrbeonFormProcess;
		parentTransition: anOrbeonFormTransition;
		yourself.

	"if the process is Recursive and a the form is NOT -MultiInstance- --> we have to use the already sent form"
	((anOrbeonFormProcess isMultiInstanceFormNamed: self endFormName) not and: [anOrbeonFormProcess hasAlreadyBeenExecuted: self])
	ifTrue:[anOrbeonFormProcess setTransitionWithExecutedForm: newTransition].

	^newTransition! !

!OrbeonFormTransitionDefinition methodsFor: 'instance creation' stamp: 'BrunoBB 05/14/2015 06:40'!
createGatewayTransitionIn: anOrbeonFormProcess from: anOrbeonFormTransition
	" Creates a new instance of a transition with the receiver as it's definition"

	^(OrbeonGatewayTransition definition: self)
		process: anOrbeonFormProcess;
		parentTransition: anOrbeonFormTransition;
		yourself! !

!OrbeonFormTransitionDefinition methodsFor: 'instance creation' stamp: 'BrunoBB 03/13/2015 15:16'!
createSubProcessTransition: anOrbeonFormProcess from: anOrbeonFormTransition
	" Creates a new instance of a transition with the receiver as it's definition"

	^(OrbeonSubProcessTransition definition: self)
		process: anOrbeonFormProcess;
		parentTransition: anOrbeonFormTransition;
		yourself! !

!OrbeonFormTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 12/26/2014 09:57'!
endConditions

   "Return the value of the instance variable 'endConditions'."
   ^endConditions! !

!OrbeonFormTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/26/2014 09:57'!
endConditions: anOFNodeEndCondition
   "Modify the value of the instance variable 'endConditions'."

	anOFNodeEndCondition ifNil:[^endConditions := nil].
	anOFNodeEndCondition conditionIsEmpty ifTrue: [^endConditions := nil].
	endConditions := anOFNodeEndCondition! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 10/22/2015 14:35'!
endFormName

	endNode ifNil: [^'nil'].

	endNode isGatewayNode ifTrue: [^'{', self endNode printType, ' gateway}'].

	endNode isEnd ifTrue: [^'(~)'].

	endNode isSubProcessNode ifTrue: [^'@[', endNode nodeName, ']'].

	^endNode form! !

!OrbeonFormTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 12/26/2014 09:57'!
endNode

   "Return the value of the instance variable 'endNode'."
   ^endNode! !

!OrbeonFormTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/26/2014 09:57'!
endNode: newValue

   "Modify the value of the instance variable 'endNode'."
   endNode := newValue! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/26/2014 09:57'!
endNodeFormDefinition

	^endNode formDefinition! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 06/12/2015 11:07'!
endNodeFormDefinitionNotNil

	^self endNodeFormDefinition notNil! !

!OrbeonFormTransitionDefinition methodsFor: 'node' stamp: 'BrunoBB 04/08/2015 16:59'!
endNodeIsGateway

	^endNode isGatewayNode! !

!OrbeonFormTransitionDefinition methodsFor: 'node' stamp: 'BrunoBB 04/28/2015 06:12'!
endNodeIsParallelGateway

	^endNode isGatewayNode and: [endNode isParallel]! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 01/27/2015 14:51'!
endNodeIsSubProcess
	"Answer whether or not the <endNode> of the receiver is a Sub Process Node "

	^endNode isSubProcessNode! !

!OrbeonFormTransitionDefinition methodsFor: 'node' stamp: 'BrunoBB 01/23/2015 14:32'!
endNodeWith: anOrbeonFormDefinition
   "Set the End node of the receiver with the form definition <anOrbeonFormDefinition>.
	1. Get the End node of the receiver.
	2. Add an IN transition <anOrbeonFormDefinition> to the End node"

	^self endNodeWith: anOrbeonFormDefinition node: OrbeonPathNode new! !

!OrbeonFormTransitionDefinition methodsFor: 'node' stamp: 'BrunoBB 04/07/2015 05:35'!
endNodeWith: anOrbeonFormDefinition node: anOrbeonPathNode
   "Set the End node of the receiver with the form definition <anOrbeonFormDefinition>.
	1. Get the End node of the receiver.
	2. Add an IN transition <anOrbeonFormDefinition> to the End node"

	self canModifyPathDefinition ifFalse: [^CanNotModifyPathDefinitionException signal].

	endNode := pathDefinition getEndNodeFor: anOrbeonFormDefinition in: self node: anOrbeonPathNode. "answer the End node of the receiver"
	endNode addInTransition: self. "the transitions is incomming in to the node"
	^endNode! !

!OrbeonFormTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 12/26/2014 09:57'!
expectedResult

   "Return the value of the instance variable 'expectedResult'."
   ^expectedResult! !

!OrbeonFormTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/26/2014 09:57'!
expectedResult: newValue

   "Modify the value of the instance variable 'expectedResult'."
   expectedResult := newValue! !

!OrbeonFormTransitionDefinition methodsFor: 'conditions' stamp: 'BrunoBB 12/26/2014 09:57'!
getRuntimeStringConditionFor: anOrbeonFormRole

	^(self runtimeConditionFor: anOrbeonFormRole) condition! !

!OrbeonFormTransitionDefinition methodsFor: 'conditions' stamp: 'BrunoBB 12/26/2014 09:57'!
getStartConditionsString

	startConditions ifNil: [^''].

	^startConditions condition! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/26/2014 09:57'!
grant: anOrbeonFormRole
	"Grant <anOrbeonFormRole> access to the receiver"

	anOrbeonFormRole grant: self.
	^grantedRols add: anOrbeonFormRole! !

!OrbeonFormTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 12/26/2014 09:57'!
grantedRols

   "Return the value of the instance variable 'grantedRols'."
   ^grantedRols! !

!OrbeonFormTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/26/2014 09:57'!
grantedRols: newValue

   "Modify the value of the instance variable 'grantedRols'."
   grantedRols := newValue! !

!OrbeonFormTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/26/2014 09:57'!
hasExpectedResult

	^expectedResult notNil! !

!OrbeonFormTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 12/26/2014 09:57'!
hasPreviousFields

	^self previousFields notEmpty! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/26/2014 09:57'!
hasReadAccess: anOrbeonFormUser
	"Grant <anOrbeonFormRole> access to the receiver"

	^self processDefinition hasReadAccess: anOrbeonFormUser! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/26/2014 09:57'!
hasRuntimeCondition: anOrbeonFormRole

	^rolsRuntimeConditions includesKey: anOrbeonFormRole name! !

!OrbeonFormTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/26/2014 09:57'!
hasRuntimeConditions

	^rolsRuntimeConditions notEmpty! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/26/2014 09:57'!
hasRuntimeConditions: anOrbeonFormRole

	^rolsRuntimeConditions includesKey: anOrbeonFormRole name! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/26/2014 09:57'!
hasStartConditions

	^startConditions notEmpty! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 01/28/2015 12:38'!
hasSubprocess

	^startNode isSubProcessNode or: [endNode isSubProcessNode]! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/28/2014 13:23'!
initialize

	super initialize.

	grantedRols := OrderedCollection new.
	allowRollback := false.
	rollbackRols := OrderedCollection new.
	rolsRuntimeConditions := Dictionary new.
	previousFields := OrderedCollection new.
	acceptInvalidForm := false.
	expectedResult := Dictionary new.! !

!OrbeonFormTransitionDefinition methodsFor: 'node' stamp: 'BrunoBB 12/26/2014 09:57'!
initializeStartAndEndNodes

	self startNodeWith: nil.
	self endNodeWith: nil.! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 04/16/2015 06:11'!
isEnd: anOrbeonFormTransitionNode
	"Whether or not the receiver is the FINAL node of the path "

	^pathDefinition endNode == anOrbeonFormTransitionNode! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 05/14/2015 16:36'!
isEndTransition
		"Whether or not the receiver is the END transition of the path"

	"endNode ifNil: [^true].

	endNode isSubProcessNode ifTrue: [^false]. 

	^endNode formDefinition isNil"

	^pathDefinition endNode == endNode! !

!OrbeonFormTransitionDefinition methodsFor: 'node' stamp: 'BrunoBB 04/27/2015 06:18'!
isGatewayBridge
	"Answher whether or not the receiver is a bridge between gateways.
	The start and end node is a GatewayNode"

	^self startNodeIsGateway and:[self endNodeIsGateway]! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 09/25/2015 12:05'!
isGrantedRole: anOrbeonFormUser
	"Grant <anOrbeonFormRole> access to the receiver"

	^anOrbeonFormUser roles anySatisfy: [:eachRole | grantedRols includes: eachRole]! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/26/2014 09:57'!
isGrantedUser: anOrbeonFormUser
	"Grant <anOrbeonFormRole> access to the receiver"

	^anOrbeonFormUser roles anySatisfy: [:eachRole | grantedRols includes: eachRole]! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 04/16/2015 06:10'!
isStart: anOrbeonFormTransitionNode
	"Whether or not the receiver is the START node of the path "

	^pathDefinition startNode == anOrbeonFormTransitionNode! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/26/2014 09:57'!
isStartTransition
		"Whether or not the receiver is the START transition of the path"

	startNode ifNil: [^true].

	^startNode formDefinition isNil! !

!OrbeonFormTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 12/26/2014 09:57'!
pathDefinition

   "Return the value of the instance variable 'pathDefinition'."
   ^pathDefinition! !

!OrbeonFormTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/26/2014 09:57'!
pathDefinition: newValue

   "Modify the value of the instance variable 'pathDefinition'."
   pathDefinition := newValue! !

!OrbeonFormTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 12/26/2014 09:57'!
previousFields

   "Return the value of the instance variable 'previousFields'."
	previousFields ifNil: [previousFields := OrderedCollection new].

   ^previousFields! !

!OrbeonFormTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/26/2014 09:57'!
previousFields: newValue

   "Modify the value of the instance variable 'previousFields'."
   previousFields := newValue! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 06/07/2015 14:04'!
printData
	| stream |

	stream := PrintStream on: String new.

	(startConditions notNil and: [startConditions notEmpty])
	ifTrue: [stream nextPutAll: '(c)', String lf;
					nextPutAll: startConditions condition, String lf.].

	stream nextPutAll: (self startFormName, '>>', self endFormName), String lf.

	(expectedResult notNil and: [expectedResult notEmpty])
	ifTrue: [stream nextPutAll: '(Expected Result)', String lf;
					nextPutAll: self printExpectedResult, String lf.].

	(previousFields notNil and: [previousFields notEmpty])
	ifTrue: [stream nextPutAll: '(Previous Fields)', String lf;
					nextPutAll: self printPreviousFields, String lf.].

	^stream contents! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/26/2014 09:57'!
printExpectedResult
	""
	| resultString |

	expectedResult ifNil: [^''].
	resultString := ''.

	expectedResult keysAndValuesDo: [:key :value |
		resultString := resultString, key, ',', value, String lf.].

	^resultString! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/28/2014 13:19'!
printPreviousFields
	| stream |

	previousFields isEmpty ifTrue: [^''].

	stream := PrintStream on: String new.

	previousFields do: [:each | stream nextPutAll: each, ','].

	^stream contents allButLast! !

!OrbeonFormTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/26/2014 09:57'!
printRoleNames
	| names |

	names := ''.
	grantedRols do: [:each | names := names, each name, '; ' ].

	^names! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 04/07/2015 18:19'!
printTransition
	| stream |

	stream := PrintStream on: String new.

	stream nextPutAll: String tab, '<Transition>', String lf;
		nextPutAll: String tab, (self startFormName, '>>', self endFormName), String lf.

	(startConditions notNil and: [startConditions notEmpty])
	ifTrue: [stream nextPutAll: String tab, '<Creation Conditions>', String lf;
					nextPutAll: String tab, startConditions condition, String lf.].

	(expectedResult notNil and: [expectedResult notEmpty])
	ifTrue: [stream nextPutAll: String tab, '<Expected Result>', String lf;
					nextPutAll: String tab, self printExpectedResult, String lf.].

	(previousFields notNil and: [previousFields notEmpty])
	ifTrue: [stream nextPutAll: String tab, '<Previous Fields>', String lf;
					nextPutAll: String tab, self printPreviousFields, String lf.].

	^stream contents! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/26/2014 09:57'!
processDefinition

	^pathDefinition processDefinition! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/26/2014 09:57'!
processDefinitionName

	^self processDefinition name! !

!OrbeonFormTransitionDefinition methodsFor: 'conditions' stamp: 'BrunoBB 12/26/2014 09:57'!
removeRuntimeRule: anOFRuntimeCondition for: anOrbeonFormRole

	^rolsRuntimeConditions removeKey: anOrbeonFormRole name ifAbsent: []! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/26/2014 09:57'!
resetPreviousFields

	previousFields := OrderedCollection new.! !

!OrbeonFormTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 12/26/2014 09:57'!
rollbackRols

   "Return the value of the instance variable 'rollbackRols'."
   ^rollbackRols! !

!OrbeonFormTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/26/2014 09:57'!
rollbackRols: newValue

   "Modify the value of the instance variable 'rollbackRols'."
   rollbackRols := newValue! !

!OrbeonFormTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 12/26/2014 09:57'!
rolsRuntimeConditions

   "Return the value of the instance variable 'rolsRuntimeConditions'."
   ^rolsRuntimeConditions! !

!OrbeonFormTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/26/2014 09:57'!
rolsRuntimeConditions: newValue

   "Modify the value of the instance variable 'rolsRuntimeConditions'."
   rolsRuntimeConditions := newValue! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/26/2014 09:57'!
runtimeConditionFor: anOrbeonFormRole

	^rolsRuntimeConditions at: anOrbeonFormRole name ifAbsent: [OFRuntimeCondition new]! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/28/2014 13:25'!
setExpectedResultFrom: aString
	"fieldName,value
	fieldName,value"
	aString ifNil: [^expectedResult := Dictionary new].
	expectedResult ifNil: [expectedResult := Dictionary new].

	(aString subStrings: String lf) do: [:touple | | array key value | 
		array := touple subStrings: ','.
		(array size = 2) 
		ifTrue: [value := (array second subStrings: Character cr) first.
			expectedResult at: array first "field name" put: value "field value".]].

	^expectedResult! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/26/2014 09:57'!
setRuntimeRule: anOFRuntimeCondition for: anOrbeonFormRole

	anOFRuntimeCondition conditionIsEmpty "if the condition has no definition -nil or empty- then we remove this invalid key"
	ifTrue: [^rolsRuntimeConditions removeKey: anOrbeonFormRole name ifAbsent: []].

	^rolsRuntimeConditions at: anOrbeonFormRole name put: anOFRuntimeCondition! !

!OrbeonFormTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 12/26/2014 09:57'!
startConditions

   "Return the value of the instance variable 'startConditions'."
   ^startConditions! !

!OrbeonFormTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/26/2014 09:57'!
startConditions: anOFNodeStartCondition
   "Modify the value of the instance variable 'startConditions'."

	anOFNodeStartCondition ifNil:[^startConditions := nil].
	anOFNodeStartCondition conditionIsEmpty ifTrue: [^startConditions := nil].
	startConditions := anOFNodeStartCondition! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 04/30/2015 06:18'!
startFormName

	startNode ifNil: [^'nil'].

	startNode isGatewayNode ifTrue: [^'{', self startNode printType, ' gateway}'].

	startNode isStart ifTrue: [^'(start)'].

	startNode isSubProcessNode ifTrue: [^'@[', startNode name, ']'].

	^startNode form! !

!OrbeonFormTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 12/26/2014 09:57'!
startNode

   "Return the value of the instance variable 'startNode'."
   ^startNode! !

!OrbeonFormTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 01/27/2015 04:15'!
startNode: newValue

   "Modify the value of the instance variable 'startNode'."

   startNode := newValue! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/26/2014 09:57'!
startNodeFormDefinition

	^startNode formDefinition! !

!OrbeonFormTransitionDefinition methodsFor: 'node' stamp: 'BrunoBB 04/10/2015 10:25'!
startNodeIsGateway

	^startNode isGatewayNode! !

!OrbeonFormTransitionDefinition methodsFor: 'node' stamp: 'BrunoBB 04/10/2015 10:30'!
startNodeIsParallelGateway

	^startNode isGatewayNode and: [startNode isParallel]! !

!OrbeonFormTransitionDefinition methodsFor: 'node' stamp: 'BrunoBB 01/23/2015 14:32'!
startNodeWith: anOrbeonFormDefinition
   "Set the Start node of the receiver with the form definition <anOrbeonFormDefinition>.
	1. Get the Start node of the receiver.
	2. Add an OUT transition <anOrbeonFormDefinition> to the Start node"

	^self startNodeWith: anOrbeonFormDefinition node: OrbeonPathNode new! !

!OrbeonFormTransitionDefinition methodsFor: 'node' stamp: 'BrunoBB 04/07/2015 11:39'!
startNodeWith: anOrbeonFormDefinition node: anOrbeonPathNode
   "Set the Start node of the receiver with the form definition <anOrbeonFormDefinition>.
	1. Get the Start node of the receiver.
	2. Add an OUT transition <anOrbeonFormDefinition> to the Start node"

	self canModifyPathDefinition ifFalse: [^CanNotModifyPathDefinitionException signal].

	startNode := pathDefinition getStartNodeFor: anOrbeonFormDefinition in: self node: anOrbeonPathNode. "answer the Start node of the receiver"

	startNode addOutTransition: self. "the transition is going out of the node"
	^startNode! !

!OrbeonFormTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/26/2014 09:57'!
ungrant: anOrbeonFormRole
	"Ungrant <anOrbeonFormRole> access to the receiver"

	anOrbeonFormRole ungrant: self.
	^grantedRols remove: anOrbeonFormRole! !

OrbeonObject subclass: #OrbeonFormUser
	instanceVariableNames: 'username password processAssignments roles assignmentsHistory cancelledAssignments userOptions'
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!OrbeonFormUser class methodsFor: 'other' stamp: 'BrunoBB 11/05/2014 03:50'!
cache

	Cache ifNil: [self initializeCache].

	^Cache! !

!OrbeonFormUser class methodsFor: 'other' stamp: 'BrunoBB 03/15/2015 13:32'!
cache: aCollection

	^Cache := aCollection! !

!OrbeonFormUser class methodsFor: 'other' stamp: 'BrunoBB 11/05/2014 03:50'!
getUserNamed: aString

	^self cache detect: [:each | each username = aString] ifNone: [nil]! !

!OrbeonFormUser class methodsFor: 'other' stamp: 'BrunoBB 03/15/2015 12:57'!
initializeCache

	Cache := Dictionary new! !

!OrbeonFormUser class methodsFor: 'other' stamp: 'BrunoBB 03/07/2015 05:55'!
newUsername: username password: password 

	^(self username: username password: password)
		addToCache;
		yourself! !

!OrbeonFormUser class methodsFor: 'other' stamp: 'BrunoBB 03/15/2015 12:58'!
transformCache
	| newCache |

	newCache := Dictionary new.

	self cache do: [:each | newCache at: each username put: each].

	^newCache! !

!OrbeonFormUser class methodsFor: 'other' stamp: 'BrunoBB 03/07/2015 05:55'!
username: username password: password 

	^super new initialize
		username: username;
		password: password;
		yourself! !

!OrbeonFormUser methodsFor: 'process assign' stamp: 'BrunoBB 11/05/2014 03:50'!
addRole: anOrbeonProcessRole

	^roles add: anOrbeonProcessRole! !

!OrbeonFormUser methodsFor: 'Accessing' stamp: 'BrunoBB 03/15/2015 13:02'!
addToCache

	^self class cache at: username put: self! !

!OrbeonFormUser methodsFor: 'Accessing' stamp: 'BrunoBB 11/05/2014 03:50'!
assignmentsHistory

   "Return the value of the instance variable 'assignmentsHistory'."
   ^assignmentsHistory! !

!OrbeonFormUser methodsFor: 'Updating' stamp: 'BrunoBB 11/05/2014 03:50'!
assignmentsHistory: newValue

   "Modify the value of the instance variable 'assignmentsHistory'."
   assignmentsHistory := newValue! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 11/05/2014 03:51'!
backofficeRoles

	^roles select: [:each | each isBackofficeRole]! !

!OrbeonFormUser methodsFor: 'Accessing' stamp: 'BrunoBB 11/05/2014 03:50'!
cancelledAssignments

   "Return the value of the instance variable 'cancelledAssignments'."
   ^cancelledAssignments! !

!OrbeonFormUser methodsFor: 'Updating' stamp: 'BrunoBB 11/05/2014 03:50'!
cancelledAssignments: newValue

   "Modify the value of the instance variable 'cancelledAssignments'."
   cancelledAssignments := newValue! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 12/01/2014 05:03'!
canDelete

	^roles isEmpty and:[processAssignments isEmpty]! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 06/26/2015 14:27'!
currentLanguage

	^userOptions languageName! !

!OrbeonFormUser methodsFor: 'query assignments' stamp: 'BrunoBB 10/20/2015 10:33'!
finishedAssignments
	"Answer a collection of (OrbeonProcessAssignment) the finished assigment of the receiver.
	It also SCAN for terminated assignments and move it to the history collection <assignmentsHistory>"
	| finishedAssginments |

	finishedAssginments := OrderedCollection new.

	processAssignments do: [:each | 
		each isInEndTransition "process is terminated ?"
		ifTrue: [finishedAssginments add: each.]
	].

	processAssignments removeAll: finishedAssginments.
	assignmentsHistory addAll: finishedAssginments.

	^assignmentsHistory! !

!OrbeonFormUser methodsFor: 'process assign' stamp: 'BrunoBB 06/12/2015 14:49'!
getAssignmentDefinitions
	"Answer a collection of OrbeonFormProcess that the receiver has been assigned"

	^processAssignments collection: [:each | each formProcessDefinition]! !

!OrbeonFormUser methodsFor: 'process assign' stamp: 'BrunoBB 11/05/2014 03:50'!
getAssignmentFor: anOrbeonFormProcessDefinition
	"Answer the assigment of the receiver over the Form Process Definition <anOrbeonFormProcessDefinition> if none answer nil "

	^processAssignments detect: [:each | each formProcessDefinition == anOrbeonFormProcessDefinition] ifNone: [nil]! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 11/14/2014 17:10'!
getCurrentProcess

	^processAssignments collect: [:each | each formProcess]! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 07/03/2015 11:24'!
getProcessDefinitionCategoriesFor: anOrbeonFormProcessDefinition

	^(ProcessDefinitionUserCategory getCategoriesFor: self) 
		select: [:each | each includes: anOrbeonFormProcessDefinition]! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 07/06/2015 13:34'!
getProcessDefinitionNamed: aString

	^self getVisibleProcessDefinitions detect: [:each | each name = aString] ifNone: [nil]! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 07/03/2015 13:57'!
getProcessInstanceCategoriesFor: anOrbeonFormProcessDefinition

	^(ProcessInstanceUserCategory getCategoriesFor: self) 
		select: [:each | each includes: anOrbeonFormProcessDefinition]! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 11/05/2014 03:51'!
getVisibleApplications
	| orbeonApplications |

	self isBackofficeUser ifFalse: [^OrderedCollection new].

	self isBackofficeUserAndAdmin ifTrue: [^OrbeonApplication cache].

	^self orbeonApplications! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 07/06/2015 13:18'!
getVisibleApplicationsOnBackoffice
	| orbeonApplications |

	self isBackofficeUser ifFalse: [^OrderedCollection new].

	self isBackofficeUserAndAdmin ifTrue: [^OrbeonApplication cache].

	^self orbeonApplications! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 07/06/2015 13:20'!
getVisibleProcessDefinitions
	| applicationsName definitions |

	definitions := OrderedCollection new.
	applicationsName := self orbeonApplications collect: [:each | each app].

	applicationsName do: [:each |
		definitions addAll: (OrbeonFormProcessDefinition getAllVersionsIn: each).
	].

	^definitions! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 07/06/2015 13:14'!
getVisibleProcessDefinitionsNames

	^(self getVisibleProcessDefinitions collect: [:each | each name]) asSet asSortedCollection! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 11/05/2014 03:51'!
getVisibleRoles
	| orbeonApplications |

	self isBackofficeUser ifFalse: [^OrderedCollection new].

	self isBackofficeUserAndAdmin ifTrue: [^OrbeonFormRole getAllRoles].

	orbeonApplications := self orbeonApplications.

	^OrbeonFormRole getAllRoles select: [:each | (orbeonApplications includes: each orbeonApplication) and: [each isBackofficeUserAndAdmin not]]! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 03/17/2015 16:48'!
getVisibleUsers
	| orbeonApplications |

	self isBackofficeUser ifFalse: [^OrderedCollection new].

	self isBackofficeUserAndAdmin ifTrue: [^OrbeonFormUser cache asOrderedCollection].

	orbeonApplications := self orbeonApplications.

	^OrbeonFormUser cache asOrderedCollection
		select: [:each | (each includesAnyApplicationOf: orbeonApplications) and: [each isBackofficeUserAndAdmin not]]! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 11/05/2014 03:50'!
grantedTransitionsDefinitions
	| grantedTransitions |

	grantedTransitions := Set new. "no repeated elements are permited"

	roles do: [:each | grantedTransitions addAll: each transitions]. "add all transitions for each Role of the receiver"

	^grantedTransitions asOrderedCollection! !

!OrbeonFormUser methodsFor: 'process assign' stamp: 'BrunoBB 11/05/2014 03:50'!
hasAssigmentTo: anOrbeonFormProcessDefinition
	"Answer whether or not the receiver has an assigment over the Form Process Definition <anOrbeonFormProcessDefinition>"

	^processAssignments anySatisfy: [:each | each formProcessDefinition == anOrbeonFormProcessDefinition]! !

!OrbeonFormUser methodsFor: 'process assign' stamp: 'BrunoBB 11/05/2014 03:50'!
hasRole: anOrbeonProcessRole

	^roles includes: anOrbeonProcessRole! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 11/05/2014 03:50'!
includesAnyApplicationOf: anOrderedCollection

	^anOrderedCollection anySatisfy: [:each | self includesApplication: each]! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 11/05/2014 03:50'!
includesAnyRoleOf: aCollection

	^roles anySatisfy: [:each | aCollection includesIdentical: each]! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 11/05/2014 03:50'!
includesApplication: anOrbeonApplication

	^self orbeonApplications includes: anOrbeonApplication! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 11/05/2014 03:58'!
initialize

	super initialize.

	username := ''.
	password := ''.
	processAssignments := OrderedCollection new.
	assignmentsHistory := OrderedCollection new.
	roles := OrderedCollection new.
	cancelledAssignments := OrderedCollection new.
	userOptions := OrbeonFormUserOptions new.! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 11/05/2014 03:50'!
isAdmin

	^roles anySatisfy: [:each | each isAdmin]! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 11/05/2014 03:50'!
isBackofficeUser

	^roles anySatisfy: [:each | each isBackofficeRole]! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 11/05/2014 03:51'!
isBackofficeUserAndAdmin

	^roles anySatisfy: [:each | each isBackofficeUserAndAdmin]! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 06/23/2015 12:23'!
languageName

	^userOptions languageName! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 11/24/2014 08:50'!
orbeonApplications
	| applications |

	self isBackofficeUserAndAdmin ifTrue: [^OrbeonApplication cache].

	applications := OrderedCollection new.

	roles do: [:each | applications add: each orbeonApplication]. "get the orbeon application of each role"

	^applications! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 11/08/2014 08:54'!
orbeonWebIsLinked

	^userOptions orbeonWebIsLinked! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 12/04/2014 04:11'!
orbeonWebIsLinked: aBoolean

	^userOptions orbeonWebIsLinked: aBoolean! !

!OrbeonFormUser methodsFor: 'Accessing' stamp: 'BrunoBB 11/05/2014 03:50'!
password

   "Return the value of the instance variable 'password'."
   ^password! !

!OrbeonFormUser methodsFor: 'Updating' stamp: 'BrunoBB 11/05/2014 03:50'!
password: newValue

   "Modify the value of the instance variable 'password'."
   password := newValue! !

!OrbeonFormUser methodsFor: 'query assignments' stamp: 'BrunoBB 10/20/2015 10:34'!
pendingAssignments
	"Answer a collection of (OrbeonProcessAssignment) the current pending assigment of the receiver.
	It also SCAN for terminated assignments and move it to the history collection <assignmentsHistory>"
	| currentAssigments finishedAssginments |

	currentAssigments := OrderedCollection new.
	finishedAssginments := OrderedCollection new.

	processAssignments do: [:each | 
		each isInEndTransition "process is terminated ?"
		ifFalse: [currentAssigments add: each]
		ifTrue: [finishedAssginments add: each]
	].

	processAssignments removeAll: finishedAssginments.
	assignmentsHistory addAll: finishedAssginments.

	^currentAssigments! !

!OrbeonFormUser methodsFor: 'reset pwd' stamp: 'BrunoBB 07/22/2015 12:04'!
printResetedPassword
	"Answer the reset password of the receiver if the case. If not answer 'N/A'.
	If hash(1) = 2 --> the password was resetd. See #resetPassword method"
	| pwdArray |

	((password subStrings: '-') size = 2) ifFalse: [^'N/A']. "password NOT reseted"

	pwdArray := password subStrings: '-'.

	(pwdArray at: 1) hash printString = (pwdArray at: 2) ifTrue: [^password]. "password has been reseted"

	^'N/A' "password NOT reseted"! !

!OrbeonFormUser methodsFor: 'query assignments' stamp: 'BrunoBB 11/05/2014 03:50'!
processAssignments

   "Return the value of the instance variable 'processAssignments'."
   ^processAssignments! !

!OrbeonFormUser methodsFor: 'Updating' stamp: 'BrunoBB 11/05/2014 03:50'!
processAssignments: newValue

   "Modify the value of the instance variable 'processAssignments'."
   processAssignments := newValue! !

!OrbeonFormUser methodsFor: 'Accessing' stamp: 'BrunoBB 03/15/2015 13:03'!
removeFromCache

	^self class cache removeKey: username ifAbsent: [nil]! !

!OrbeonFormUser methodsFor: 'process assign' stamp: 'BrunoBB 07/16/2015 14:54'!
removeProcessFromAllCategories: anOrbeonFormProcess

	(ProcessInstanceUserCategory getCategoriesFor: self) do: [:each | each remove: anOrbeonFormProcess]! !

!OrbeonFormUser methodsFor: 'process assign' stamp: 'BrunoBB 11/05/2014 03:50'!
removeRole: anOrbeonProcessRole

	^roles remove: anOrbeonProcessRole ifAbsent: []! !

!OrbeonFormUser methodsFor: 'reset pwd' stamp: 'BrunoBB 07/22/2015 11:58'!
resetPassword
	"Reset the password of the receiver
	(1) = hash(2) using subStrings: '-'  .
	This method is used with #printResetdPassword - in order to know if a password was reseted"

	password := TimeStamp current hash printString.

	password := password,'-', password hash printString! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 02/02/2015 04:17'!
roleName
	| roleName |

	roleName := ''.
	roles isEmpty ifTrue: [^'[]'].

	roles do: [:each | roleName := roleName, '[', each name, ']'].

	^roleName! !

!OrbeonFormUser methodsFor: 'Accessing' stamp: 'BrunoBB 11/05/2014 03:50'!
roles

   "Return the value of the instance variable 'roles'."
   ^roles! !

!OrbeonFormUser methodsFor: 'Updating' stamp: 'BrunoBB 11/05/2014 03:50'!
roles: newValue

   "Modify the value of the instance variable 'roles'."
   roles := newValue! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 06/26/2015 14:20'!
setLanguage: symbolLanguage

	userOptions languageName: symbolLanguage asSymbol! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 10/22/2015 18:45'!
setTransitionsDisplayMode: aBoolean

	^userOptions setTransitionsDisplayMode: aBoolean! !

!OrbeonFormUser methodsFor: 'query assignments' stamp: 'BrunoBB 11/05/2014 03:50'!
startAssignments
	"Answer a collection with <OrbeonProcessAssignment> where the receiver has a grant to create process"

	^processAssignments select: [:each | each canCreateProcess: self]! !

!OrbeonFormUser methodsFor: 'process assign' stamp: 'BrunoBB 11/05/2014 03:50'!
take: anOrbeonProcessAssignment
	"The receiver take the assigment <anOrbeonProcessAssignment> and add it to the collection of assignments.
	Also the receiver is added to the list of users of the assignment <anOrbeonProcessAssignment>"

	anOrbeonProcessAssignment assign: self.

	^processAssignments add: anOrbeonProcessAssignment.! !

!OrbeonFormUser methodsFor: 'other' stamp: 'BrunoBB 10/22/2015 17:22'!
transitionDisplayModeIsExpanded

	^userOptions transitionDisplayModeIsExpanded! !

!OrbeonFormUser methodsFor: 'process assign' stamp: 'BrunoBB 11/05/2014 03:50'!
untake: anOrbeonProcessAssignment
	"The receiver untake the assigment <anOrbeonProcessAssignment> and remove it from the collection of assignments.
	Also the receiver is removed from the list of users of the assignment <anOrbeonProcessAssignment>"

	anOrbeonProcessAssignment unassign: self.

	cancelledAssignments add: anOrbeonProcessAssignment. "to register the #untake action by the user"

	self removeProcessFromAllCategories: anOrbeonProcessAssignment formProcess.

	^processAssignments remove: anOrbeonProcessAssignment ifAbsent: [].! !

!OrbeonFormUser methodsFor: 'process assign' stamp: 'BrunoBB 10/20/2015 10:30'!
untakeAll

	processAssignments do:[:each | each unassign: self].

	processAssignments := OrderedCollection new.
	assignmentsHistory := OrderedCollection new.
	cancelledAssignments := OrderedCollection new.! !

!OrbeonFormUser methodsFor: 'Accessing' stamp: 'BrunoBB 11/05/2014 03:50'!
username

   "Return the value of the instance variable 'username'."
   ^username! !

!OrbeonFormUser methodsFor: 'Updating' stamp: 'BrunoBB 11/05/2014 03:50'!
username: newValue

   "Modify the value of the instance variable 'username'."
   username := newValue! !

!OrbeonFormUser methodsFor: 'Accessing' stamp: 'BrunoBB 11/05/2014 03:58'!
userOptions

   "Return the value of the instance variable 'userOptions'."
   ^userOptions! !

!OrbeonFormUser methodsFor: 'Updating' stamp: 'BrunoBB 11/05/2014 03:58'!
userOptions: newValue

   "Modify the value of the instance variable 'userOptions'."
   userOptions := newValue! !

OrbeonObject subclass: #OrbeonFormUserOptions
	instanceVariableNames: 'orbeonWebIsLinked languageName initialTransitionDisplayMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!OrbeonFormUserOptions methodsFor: 'other' stamp: 'BrunoBB 10/22/2015 18:46'!
initialize

	super initialize.

	"true - WALinkedAssignmentManager, false - WAEmbeddedAssignmentManager"
	orbeonWebIsLinked := true.
	languageName := #english.
	initialTransitionDisplayMode := #expanded.! !

!OrbeonFormUserOptions methodsFor: 'Accessing' stamp: 'BrunoBB 06/23/2015 12:23'!
languageName
	^languageName! !

!OrbeonFormUserOptions methodsFor: 'Updating' stamp: 'BrunoBB 06/23/2015 12:23'!
languageName: newValue
	languageName := newValue! !

!OrbeonFormUserOptions methodsFor: 'Accessing' stamp: 'BrunoBB 11/05/2014 03:48'!
orbeonWebIsLinked

   "Return the value of the instance variable 'orbeonWebIsLinked'."
   ^orbeonWebIsLinked! !

!OrbeonFormUserOptions methodsFor: 'Updating' stamp: 'BrunoBB 11/05/2014 03:48'!
orbeonWebIsLinked: newValue

   "Modify the value of the instance variable 'orbeonWebIsLinked'."
   orbeonWebIsLinked := newValue! !

!OrbeonFormUserOptions methodsFor: 'other' stamp: 'BrunoBB 10/22/2015 18:50'!
setTransitionsDisplayMode: aBoolean

	aBoolean ifTrue: [initialTransitionDisplayMode := #expanded].

	initialTransitionDisplayMode := #collapsed.! !

!OrbeonFormUserOptions methodsFor: 'other' stamp: 'BrunoBB 10/22/2015 18:46'!
switchTransitionDisplayMode

	initialTransitionDisplayMode := (initialTransitionDisplayMode = #expanded) ifTrue: [#collapsed] ifFalse: [#expanded].! !

!OrbeonFormUserOptions methodsFor: 'other' stamp: 'BrunoBB 10/22/2015 18:46'!
transitionDisplayModeIsExpanded

	^initialTransitionDisplayMode = #expanded! !

OrbeonObject subclass: #OrbeonPathNode
	instanceVariableNames: 'formDefinition startConditions endConditions inTransitions outTransitions nodeName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!OrbeonPathNode commentStamp: '' prior: 0!
This class represent the nodes of the transitions of a form process.
Each node represent a Form Definition where a transition starts and finish.

formDefinition 			- form definition associated to the receiver an OrbeonFormDefinition
transitionDefinition 	- 
startConditions		- conditions 
endConditions 		- conditions
inTransitions 			- transitions that ENDs in the receiver (incomming transitions)
outTransitions			- transitions that Starts from the receiver (outgoing transitions)!

!OrbeonPathNode class methodsFor: 'other' stamp: 'BrunoBB 07/29/2014 13:59'!
for: anOrbeonFormDefinition

	^super new initialize
		formDefinition: anOrbeonFormDefinition;
		yourself! !

!OrbeonPathNode methodsFor: 'other' stamp: 'BrunoBB 07/29/2014 13:59'!
addInTransition: anOrbeonFormTransitionDefinition
	"The receiver adds an incomming transition <anOrbeonFormTransitionDefinition> "

	^inTransitions add: anOrbeonFormTransitionDefinition! !

!OrbeonPathNode methodsFor: 'other' stamp: 'BrunoBB 07/29/2014 13:59'!
addOutTransition: anOrbeonFormTransitionDefinition
	"The receiver adds an outgoing transition <anOrbeonFormTransitionDefinition> "

	^outTransitions add: anOrbeonFormTransitionDefinition! !

!OrbeonPathNode methodsFor: 'other' stamp: 'BrunoBB 07/29/2014 13:59'!
app

	formDefinition ifNil: [^'-'].
	^formDefinition app! !

!OrbeonPathNode methodsFor: 'Accessing' stamp: 'BrunoBB 07/29/2014 13:59'!
endConditions

   "Return the value of the instance variable 'endConditions'."
   ^endConditions! !

!OrbeonPathNode methodsFor: 'Updating' stamp: 'BrunoBB 07/29/2014 13:59'!
endConditions: newValue

   "Modify the value of the instance variable 'endConditions'."
   endConditions := newValue! !

!OrbeonPathNode methodsFor: 'other' stamp: 'BrunoBB 07/29/2014 13:59'!
form

	formDefinition ifNil: [^'-'].
	^formDefinition form! !

!OrbeonPathNode methodsFor: 'Accessing' stamp: 'BrunoBB 07/29/2014 13:59'!
formDefinition

   "Return the value of the instance variable 'formDefinition'."
   ^formDefinition! !

!OrbeonPathNode methodsFor: 'Updating' stamp: 'BrunoBB 07/29/2014 13:59'!
formDefinition: newValue

   "Modify the value of the instance variable 'formDefinition'."
   formDefinition := newValue! !

!OrbeonPathNode methodsFor: 'other' stamp: 'BrunoBB 07/29/2014 13:59'!
initialize

	super initialize.

	startConditions := OrderedCollection new.
	endConditions := OrderedCollection new.
	inTransitions := OrderedCollection new.
	outTransitions := OrderedCollection new.! !

!OrbeonPathNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/25/2014 16:37'!
inTransitions

   "Return the value of the instance variable 'inTransitions'."
   ^inTransitions! !

!OrbeonPathNode methodsFor: 'Updating' stamp: 'BrunoBB 08/25/2014 16:37'!
inTransitions: newValue

   "Modify the value of the instance variable 'inTransitions'."
   inTransitions := newValue! !

!OrbeonPathNode methodsFor: 'other' stamp: 'BrunoBB 07/29/2014 13:59'!
isEnd
	"Answer whether or not the receiver is the end node of the path "

	^formDefinition isNil and: [inTransitions anySatisfy: [:each | each isEnd: self]]! !

!OrbeonPathNode methodsFor: 'other' stamp: 'BrunoBB 04/07/2015 17:35'!
isGatewayNode

	^false! !

!OrbeonPathNode methodsFor: 'other' stamp: 'BrunoBB 04/29/2015 05:58'!
isParallel

	^false! !

!OrbeonPathNode methodsFor: 'other' stamp: 'BrunoBB 01/29/2015 04:35'!
isStart
	"Answer whether or not the receiver is the start node of the path "

	^formDefinition isNil and:[outTransitions anySatisfy: [:each | each isStart: self]]! !

!OrbeonPathNode methodsFor: 'other' stamp: 'BrunoBB 01/24/2015 15:52'!
isSubProcessEnd
	"Answer whether or not the receiver is the end node of the path "

	^false! !

!OrbeonPathNode methodsFor: 'other' stamp: 'BrunoBB 01/23/2015 13:55'!
isSubProcessNode

	^false! !

!OrbeonPathNode methodsFor: 'other' stamp: 'BrunoBB 01/24/2015 15:52'!
isSubProcessStart
	"Answer whether or not the receiver is the end node of the path "

	^false! !

!OrbeonPathNode methodsFor: 'Accessing' stamp: 'BrunoBB 04/08/2015 05:56'!
nodeName
	^nodeName! !

!OrbeonPathNode methodsFor: 'Updating' stamp: 'BrunoBB 04/08/2015 05:56'!
nodeName: newValue
	nodeName := newValue! !

!OrbeonPathNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/25/2014 16:37'!
outTransitions

   "Return the value of the instance variable 'outTransitions'."
   ^outTransitions! !

!OrbeonPathNode methodsFor: 'Updating' stamp: 'BrunoBB 08/25/2014 16:37'!
outTransitions: newValue

   "Modify the value of the instance variable 'outTransitions'."
   outTransitions := newValue! !

!OrbeonPathNode methodsFor: 'other' stamp: 'BrunoBB 04/07/2015 13:52'!
printNode
	| stream |

	stream := PrintStream on: String new.
	stream nextPutAll: ('<', self printNodeType,'>[', self form); nextPutAll: ']', String lf.
	inTransitions notEmpty ifTrue: [
					stream nextPutAll: '<In Transitions>';
					nextPutAll: String lf.
		inTransitions do: [:each | 
			stream nextPutAll: each printTransition]].

	outTransitions notEmpty ifTrue: [
		stream nextPutAll: '<Out Transitions>';
					nextPutAll: String lf.
		outTransitions do: [:each | 
			stream nextPutAll: each printTransition]].
	stream nextPutAll: '<End Node>', String lf.
	^stream contents! !

!OrbeonPathNode methodsFor: 'other' stamp: 'BrunoBB 04/07/2015 13:52'!
printNodeType

	^'Path Node'! !

!OrbeonPathNode methodsFor: 'other' stamp: 'BrunoBB 02/01/2015 11:41'!
processDefinition

	^nil! !

!OrbeonPathNode methodsFor: 'other' stamp: 'BrunoBB 07/29/2014 13:59'!
removeInTransition: anOrbeonFormTransitionDefinition

	^inTransitions remove: anOrbeonFormTransitionDefinition! !

!OrbeonPathNode methodsFor: 'other' stamp: 'BrunoBB 07/29/2014 13:59'!
removeOutTransition: anOrbeonFormTransitionDefinition

	^outTransitions remove: anOrbeonFormTransitionDefinition! !

!OrbeonPathNode methodsFor: 'other' stamp: 'BrunoBB 02/01/2015 11:10'!
sameAs: anOrbeonPathNode
	"Answer whether or not the receiver is the same as <anOrbeonFormTransitionNode>.
	If two nodes has the same form definition attached they are the SAME node.
	One form definition is represented only and only by one NODE in a path of transitions"

	^formDefinition == anOrbeonPathNode formDefinition! !

!OrbeonPathNode methodsFor: 'Accessing' stamp: 'BrunoBB 07/29/2014 13:59'!
startConditions

   "Return the value of the instance variable 'startConditions'."
   ^startConditions! !

!OrbeonPathNode methodsFor: 'Updating' stamp: 'BrunoBB 07/29/2014 13:59'!
startConditions: newValue

   "Modify the value of the instance variable 'startConditions'."
   startConditions := newValue! !

OrbeonPathNode subclass: #OrbeonStartEndNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

OrbeonStartEndNode subclass: #OrbeonEndNode
	instanceVariableNames: 'isProcessEnd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!OrbeonEndNode commentStamp: '' prior: 0!
This class represent each node End node in a Process Definition.

There are 2 kind of situations:

1- End Node of a Transition.
2- End Node of the Process.!

!OrbeonEndNode methodsFor: 'other' stamp: 'BrunoBB 01/23/2015 05:12'!
initialize

	super initialize.

	isProcessEnd := true! !

!OrbeonEndNode methodsFor: 'other' stamp: 'BrunoBB 01/29/2015 04:35'!
isEnd
	"Answer whether or not the receiver is the end node of the path "

	^formDefinition isNil and: [inTransitions anySatisfy: [:each | each isEnd: self]]! !

!OrbeonEndNode methodsFor: 'Accessing' stamp: 'BrunoBB 01/23/2015 05:12'!
isProcessEnd

   "Return the value of the instance variable 'isProcessEnd'."
   ^isProcessEnd! !

!OrbeonEndNode methodsFor: 'Updating' stamp: 'BrunoBB 01/23/2015 05:12'!
isProcessEnd: newValue

   "Modify the value of the instance variable 'isProcessEnd'."
   isProcessEnd := newValue! !

!OrbeonEndNode methodsFor: 'other' stamp: 'BrunoBB 04/07/2015 13:53'!
printNodeType

	^'Path End Node'! !

!OrbeonEndNode methodsFor: 'other' stamp: 'BrunoBB 01/23/2015 05:12'!
setAsProcessEnd

	isProcessEnd := true! !

!OrbeonStartEndNode methodsFor: 'other' stamp: 'BrunoBB 01/24/2015 15:50'!
isEnd
	"Answer whether or not the receiver is the end node of the path "

	^false! !

!OrbeonStartEndNode methodsFor: 'other' stamp: 'BrunoBB 01/24/2015 15:50'!
isStart
	"Answer whether or not the receiver is the start node of the path "

	^false! !

OrbeonStartEndNode subclass: #OrbeonStartNode
	instanceVariableNames: 'isProcessStart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!OrbeonStartNode commentStamp: '' prior: 0!
This class represent each node End node in a Process Definition.

There are 2 kind of situations:

1- Start Node of a Transition.
2- Start Node of the Process.!

!OrbeonStartNode methodsFor: 'other' stamp: 'BrunoBB 01/23/2015 05:13'!
initialize

	super initialize.

	isProcessStart := false! !

!OrbeonStartNode methodsFor: 'Accessing' stamp: 'BrunoBB 01/23/2015 05:12'!
isProcessStart

   "Return the value of the instance variable 'isProcessStart'."
   ^isProcessStart! !

!OrbeonStartNode methodsFor: 'Updating' stamp: 'BrunoBB 01/23/2015 05:12'!
isProcessStart: newValue

   "Modify the value of the instance variable 'isProcessStart'."
   isProcessStart := newValue! !

!OrbeonStartNode methodsFor: 'other' stamp: 'BrunoBB 01/29/2015 04:38'!
isStart
	"Answer whether or not the receiver is the start node of the path "

	^formDefinition isNil and:[outTransitions anySatisfy: [:each | each isStart: self]]! !

!OrbeonStartNode methodsFor: 'other' stamp: 'BrunoBB 04/07/2015 13:53'!
printNodeType

	^'Path Start Node'! !

!OrbeonStartNode methodsFor: 'other' stamp: 'BrunoBB 01/23/2015 05:13'!
setAsProcessStart

	isProcessStart := true! !

OrbeonPathNode subclass: #OrbeonSubProcessNode
	instanceVariableNames: 'processDefinition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!OrbeonSubProcessNode commentStamp: 'BrunoBB 01/23/2015 13:59' prior: 0!
When a Process Definition hava subprocess then this class represent the connector node between the parent process and the child process.!

OrbeonSubProcessNode subclass: #OrbeonSubProcessEndNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!OrbeonSubProcessEndNode methodsFor: 'other' stamp: 'BrunoBB 01/24/2015 15:53'!
isSubProcessEnd
	"Answer whether or not the receiver is the end node of the path "

	^true! !

!OrbeonSubProcessEndNode methodsFor: 'other' stamp: 'BrunoBB 04/07/2015 13:53'!
printNodeType

	^'Subproc End Node'! !

!OrbeonSubProcessNode methodsFor: 'other' stamp: 'BrunoBB 01/24/2015 15:55'!
isEnd
	"Answer whether or not the receiver is the end node of the path "

	^false! !

!OrbeonSubProcessNode methodsFor: 'other' stamp: 'BrunoBB 01/24/2015 15:54'!
isStart
	"Answer whether or not the receiver is the start node of the path "

	^false! !

!OrbeonSubProcessNode methodsFor: 'other' stamp: 'BrunoBB 01/23/2015 13:59'!
isSubProcessNode

	^true! !

!OrbeonSubProcessNode methodsFor: 'Accessing' stamp: 'BrunoBB 01/23/2015 13:59'!
processDefinition

   "Return the value of the instance variable 'processDefinition'."
   ^processDefinition! !

!OrbeonSubProcessNode methodsFor: 'Updating' stamp: 'BrunoBB 01/23/2015 13:59'!
processDefinition: newValue

   "Modify the value of the instance variable 'processDefinition'."
   processDefinition := newValue! !

!OrbeonSubProcessNode methodsFor: 'other' stamp: 'BrunoBB 02/01/2015 11:40'!
sameAs: anOrbeonPathNode
	"Answer whether or not the receiver is the same as <anOrbeonFormTransitionNode>.
	If two nodes has the same form definition attached they are the SAME node.
	One form definition is represented only and only by one NODE in a path of transitions"

	^processDefinition == anOrbeonPathNode processDefinition! !

OrbeonSubProcessNode subclass: #OrbeonSubProcessStartNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!OrbeonSubProcessStartNode methodsFor: 'other' stamp: 'BrunoBB 01/24/2015 15:53'!
isSubProcessStart
	"Answer whether or not the receiver is the end node of the path "

	^true! !

!OrbeonSubProcessStartNode methodsFor: 'other' stamp: 'BrunoBB 04/07/2015 13:53'!
printNodeType

	^'Subproc Start Node'! !

OrbeonPathNode subclass: #ProcessGatewayNode
	instanceVariableNames: 'waitAllIncoming isDefault'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!ProcessGatewayNode commentStamp: 'BrunoBB 05/12/2015 06:03' prior: 0!
This class represent gateways definitions inside a process definition.


waitAllIncoming - whether or not wait until all incoming transitions are done. If <true> the receiver does NOT process any of the incoming transitions until the last transition is done. If <false> the receiver process all incoming transition as they come.!

ProcessGatewayNode subclass: #ComplexGatewayNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!ComplexGatewayNode commentStamp: 'BrunoBB 05/12/2015 06:03' prior: 0!
Splitting

It is similar to an Inclusive Gateway. The difference lies in that it uses a single outgoing assignment within the Gateway instead of a set of conditions over the outgoing paths. The result is the same in the sense that one or more outgoing paths will be activated.

In general, one assignment has two parts: a condition and an action. When an assignment is executed, its condition is evaluated and if it is true, the action is performed; this action can be the updating a property of the process or a Data Object. In the case of a Complex Gateway, the outgoing assignment may refer to process data or its Data Objects and the status of its incoming paths (e.g. if the flow will come from a certain path in a certain process instance). For example, an outgoing assignment may evaluate process data and then select different sets of outgoing paths depending on the results of the evaluation. However, the outgoing assignment should ensure that at least one path will be chosen.

Merging

In this case, an incoming assignment is used when the flow reaches the Gateway. The condition may refer to the same data as in the Splitting behavior of the Complex Gateway (process data, Data Objects, etc.). If the condition evaluates to false, nothing happens except for the fact that the flow is stopped in the Gateway. If it evaluates to true, the action could be to let the flow continue or stop it.

Since the use of the Complex Gateway to merge paths can vary depending on the purpose for which it is used, modelers are recommended to use text annotations to inform the diagram readers about the behavior being assigned to the Gateway.

An example of use would be the discriminator pattern. In this pattern, there are two or more parallel tasks which are merged in a Complex Gateway. When one of the activities is completed, the following tasks can be started. It doesnt matter which activity is completed first. The other tasks are completed normally but they wont affect the process flow, that is to say, new instances of the following tasks will not be generated.!

!ComplexGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/15/2015 06:14'!
initialize

	super initialize.

	waitAllIncoming := false. "whether or not wait for processing until all incoming transition are done"! !

!ComplexGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/09/2015 16:23'!
instanceClass

	^ComplexGateway! !

!ComplexGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/30/2015 06:15'!
printType

	^'Complex'! !

ProcessGatewayNode subclass: #EventBasedGatewayNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!EventBasedGatewayNode commentStamp: 'BrunoBB 05/12/2015 06:03' prior: 0!
Splitting

This type of Gateway requires the use of one or more catching Intermediate Events. The valid types of events are as follows:
    Message
    Timer
    Conditional
    Signal

Receive tasks can be used instead of Message events, but they can't be mixed. 
It should be pointed out that if none of the events specified occur, the process will be stuck. Therefore, a Timer event is recommended as an alternative.

Merging

It works in the same way as the Exclusive Gateway.
(It merges the flow without making any synchronizations)!

!EventBasedGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/09/2015 16:23'!
instanceClass

	^EventBasedGateway! !

!EventBasedGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/30/2015 06:16'!
printType

	^'EventBased'! !

ProcessGatewayNode subclass: #ExclusiveEventBasedGatewayNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!ExclusiveEventBasedGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/09/2015 16:24'!
instanceClass

	^ExclusiveEventBasedGateway! !

!ExclusiveEventBasedGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/30/2015 06:16'!
printType

	^'ExclusiveEventBased'! !

ProcessGatewayNode subclass: #ExclusiveGatewayNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!ExclusiveGatewayNode commentStamp: 'BrunoBB 05/12/2015 06:03' prior: 0!
Splitting

This type of Gateway divides the flow into two or more paths but the process flow will go down only one of these paths. Conditions are expressed as Gateway attributes and can be expressed in natural language or as formal expressions. The selection of the path to follow will be based on the evaluation of the conditions set for each path. They are evaluated one at a time, in the order in which they were defined in the Gateway (which doesn't mean that their corresponding paths are evaluated as displayed in the diagram) and the path corresponding to the first condition that evaluates to true will be selected. If none of the conditions is true, the process will be stuck in the Gateway. In this case, the use of default paths is suggested.


Merging

It merges the flow without making any synchronizations.!

!ExclusiveGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/15/2015 06:15'!
initialize

	super initialize.

	waitAllIncoming := false. "whether or not wait for processing until all incoming transition are done"! !

!ExclusiveGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/09/2015 16:23'!
instanceClass

	^ExclusiveGateway! !

!ExclusiveGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/30/2015 06:16'!
printType

	^'Exclusive'! !

ProcessGatewayNode subclass: #InclusiveGatewayNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!InclusiveGatewayNode commentStamp: 'BrunoBB 05/12/2015 06:03' prior: 0!
Splitting

Its behavior is similar to the Exclusive Gateway in the sense that it allows for the creation of multiple alternative paths based on conditions imposed on those paths. The difference lies in that more than one path can be chosen, that is, all those whose corresponding conditions evaluate to true. In this case, the use of default paths is recommended in order to prevent the process from getting stuck in any situation.

Merging

It works similarly to a Parallel Gateway merging in the sense that it synchronizes all incoming paths. Unlike the Parallel Gateway, it only synchronizes those paths that actually reach the Gateway, which are not necessarily all the incoming paths in the diagram; this could be specific to each process instance.!

!InclusiveGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/15/2015 06:15'!
initialize

	super initialize.

	waitAllIncoming := true. "whether or not wait for processing until all incoming transition are done"! !

!InclusiveGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/27/2015 16:45'!
instanceClass

	^InclusiveGateway! !

!InclusiveGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/30/2015 06:16'!
printType

	^'Inclusive'! !

ProcessGatewayNode subclass: #ParallelEventBasedGatewayNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!ParallelEventBasedGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/30/2015 05:56'!
initialize

	super initialize.

	waitAllIncoming := true. "whether or not wait for processing until all incoming transition are done"! !

!ParallelEventBasedGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/09/2015 16:24'!
instanceClass

	^ParallelEventBasedGateway! !

!ParallelEventBasedGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/27/2015 16:48'!
isParallel

	^true! !

!ParallelEventBasedGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/30/2015 06:16'!
printType

	^'ParallelEventBased'! !

ProcessGatewayNode subclass: #ParallelGatewayNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!ParallelGatewayNode commentStamp: 'BrunoBB 05/12/2015 06:03' prior: 0!
Splitting

It simply divides the flow in two or more parallel paths. No conditions are evaluated.

Merging 

It synchronizes all the paths that arrive to the Gateway!

!ParallelGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/15/2015 06:15'!
initialize

	super initialize.

	waitAllIncoming := true. "whether or not wait for processing until all incoming transition are done"! !

!ParallelGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/09/2015 16:24'!
instanceClass

	^ParallelGateway! !

!ParallelGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/27/2015 16:48'!
isParallel

	^true! !

!ParallelGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/30/2015 06:16'!
printType

	^'Parallel'! !

!ProcessGatewayNode methodsFor: 'other' stamp: 'BrunoBB 05/12/2015 06:07'!
initialize

	super initialize.

	isDefault := false.! !

!ProcessGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/09/2015 16:22'!
instanceClass

	^self subclassResponsibility! !

!ProcessGatewayNode methodsFor: 'Accessing' stamp: 'BrunoBB 05/12/2015 06:04'!
isDefault
	^isDefault! !

!ProcessGatewayNode methodsFor: 'Updating' stamp: 'BrunoBB 05/12/2015 06:04'!
isDefault: newValue
	isDefault := newValue! !

!ProcessGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/07/2015 17:35'!
isGatewayNode

	^true! !

!ProcessGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/07/2015 13:53'!
printNodeType

	^'Gateway Node'! !

!ProcessGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/30/2015 06:15'!
printType

	self subclassResponsibility! !

!ProcessGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/09/2015 10:59'!
processFinishedTransition: anOrbeonFormTransition! !

!ProcessGatewayNode methodsFor: 'other' stamp: 'BrunoBB 04/08/2015 06:31'!
sameAs: aProcessGatewayNode
	"Answer whether or not the receiver is the same as <aProcessGatewayNode>"

	^self == aProcessGatewayNode! !

!ProcessGatewayNode methodsFor: 'Accessing' stamp: 'BrunoBB 04/10/2015 15:50'!
waitAllIncoming
	^waitAllIncoming! !

!ProcessGatewayNode methodsFor: 'Updating' stamp: 'BrunoBB 04/10/2015 15:50'!
waitAllIncoming: newValue
	waitAllIncoming := newValue! !

OrbeonObject subclass: #OrbeonPostExecutionProcess
	instanceVariableNames: 'processInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

OrbeonPostExecutionProcess subclass: #OrbeonNonePostExecution
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!OrbeonPostExecutionProcess methodsFor: 'Accessing' stamp: 'BrunoBB 06/30/2015 13:25'!
processInstance
	^processInstance! !

!OrbeonPostExecutionProcess methodsFor: 'Updating' stamp: 'BrunoBB 06/30/2015 13:25'!
processInstance: newValue
	processInstance := newValue! !

OrbeonObject subclass: #OrbeonProcessAssignment
	instanceVariableNames: 'creator creationDate assignmentDate orbeonFormUsers formProcessDefinition formProcess canUnassign'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!OrbeonProcessAssignment commentStamp: 'BrunoBB 08/26/2014 17:20' prior: 0!
OrbeonProcessAssignment is used to assign Form Process Definition (OrbeonFormProcessDefinition) to differents users (OrbeonFormUser).

The assignments can be taken and untaken.

The assignment is about how started or how can start a form process. Once the form process is started the possible users can be obtained in each transition definition (OrbeonFormTransitionDefinition).

OrbeonProcessAssignment.[orbeonFormUsers] (N) <-----> (N) OrbeonFormUser.[processAssignments]

creator 						- creator of the receiver
creationDate 				- creation date
assignmentDate			- assignment date
orbeonFormUsers 		- users attached to the assignation
formProcessDefinition 	- form process definition to follow
formProcess 				- instnace form process 
canUnassign				- whether a user can untake (canUnassign) the assignment  
										{an admin could set an assignment and set canUnassign = false}!

!OrbeonProcessAssignment class methodsFor: 'other' stamp: 'BrunoBB 10/31/2014 10:51'!
associateWithProcess: anOrbeonFormProcess for: anOrbeonFormUser
	"This method is used to start OrbeonFormProcesses.
	1- Create the OrbeonProcessAssignment.	
	2- Associate the Assignment <assign> with the process definition of <anOrbeonFormProcess> and user <anOrbeonFormUser>.
	4- The user take the Assignment"	
	| assign |

	assign := self newWith: anOrbeonFormUser for: anOrbeonFormProcess definition. "creates the assignment"
	anOrbeonFormProcess addAssignment: assign. "associate the process with the assignment"
	anOrbeonFormUser take: assign. "the user take the assginment"

	^assign! !

!OrbeonProcessAssignment class methodsFor: 'other' stamp: 'BrunoBB 10/31/2014 10:51'!
associateWithProcess: anOrbeonFormProcess for: anOrbeonFormUser ifNone: aBlock
	"This method is used to start OrbeonFormProcesses.
	1- Create the OrbeonProcessAssignment.	
	2- Associate the Assignment <assign> with the process definition of <anOrbeonFormProcess> and user <anOrbeonFormUser>.
	4- The user take the Assignment"	

	(anOrbeonFormProcess checkIfStillAvailableFor: anOrbeonFormUser) ifFalse: [^aBlock value].

	^self associateWithProcess: anOrbeonFormProcess for: anOrbeonFormUser! !

!OrbeonProcessAssignment class methodsFor: 'other' stamp: 'BrunoBB 10/18/2015 15:13'!
createProcessFor: anOrbeonFormUser template: anOrbeonFormProcessDefinition
	"This method is used to start OrbeonFormProcesses.
	1- Create the OrbeonProcessAssignment.	
	2- Create anOrbeonFormProcessInstance.
	3- Associate the Assignment with the ProcesseRoleFormProcess.
	4- The user take the Assignment"	
	| assign newProcess |

	assign := self newWith: anOrbeonFormUser for: anOrbeonFormProcessDefinition. "creates the assignment"
	newProcess := assign createProcess: anOrbeonFormUser. "create a concrete process for the assignment"
	newProcess addAssignment: assign. "associate the process with the assignment"
	anOrbeonFormUser take: assign. "the user take the assginment"

	^assign! !

!OrbeonProcessAssignment class methodsFor: 'other' stamp: 'BrunoBB 10/14/2014 17:08'!
newWith: anOrbeonFormUser for: anOrbeonFormProcessDefinition
	"This is the #basicNew method for this class "

	^super new initialize
		creator: anOrbeonFormUser;
		formProcessDefinition: anOrbeonFormProcessDefinition;
		yourself! !

!OrbeonProcessAssignment methodsFor: 'other' stamp: 'BrunoBB 11/21/2014 03:34'!
applicationName

	^formProcess applicationName! !

!OrbeonProcessAssignment methodsFor: 'user assign' stamp: 'BrunoBB 10/15/2015 14:05'!
assign: anOrbeonFormUser

	assignmentDate := TimeStamp now.
	^orbeonFormUsers add: anOrbeonFormUser! !

!OrbeonProcessAssignment methodsFor: 'other' stamp: 'BrunoBB 10/14/2014 17:08'!
assignedUserNames
	| usernames |

	orbeonFormUsers isEmpty ifTrue: [^''].
	usernames := ''.
	orbeonFormUsers do: [:each | usernames := usernames, each username, '; '].

	^usernames! !

!OrbeonProcessAssignment methodsFor: 'Accessing' stamp: 'BrunoBB 10/14/2014 17:08'!
assignmentDate

   "Return the value of the instance variable 'assignmentDate'."
   ^assignmentDate! !

!OrbeonProcessAssignment methodsFor: 'Updating' stamp: 'BrunoBB 10/14/2014 17:08'!
assignmentDate: newValue

   "Modify the value of the instance variable 'assignmentDate'."
   assignmentDate := newValue! !

!OrbeonProcessAssignment methodsFor: 'other' stamp: 'BrunoBB 10/14/2014 17:08'!
canCreateProcess: anOrbeonFormUser

	^formProcessDefinition canCreateProcess: anOrbeonFormUser! !

!OrbeonProcessAssignment methodsFor: 'other' stamp: 'BrunoBB 10/14/2014 17:08'!
canEndProcess: anOrbeonFormUser

	^formProcessDefinition canEndProcess: anOrbeonFormUser! !

!OrbeonProcessAssignment methodsFor: 'Accessing' stamp: 'BrunoBB 10/14/2014 17:14'!
canUnassign

   "Return the value of the instance variable 'canUnassign'."
   ^canUnassign! !

!OrbeonProcessAssignment methodsFor: 'Updating' stamp: 'BrunoBB 10/14/2014 17:14'!
canUnassign: newValue

   "Modify the value of the instance variable 'canUnassign'."
   canUnassign := newValue! !

!OrbeonProcessAssignment methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 14:05'!
createProcess: anOrbeonFormUser
	"Create a new instance of the receiver. This new object (process) is a Smalltalk instance of SingleRoleFormProcess or MultipleRoleFormProcess"

	assignmentDate := TimeStamp now.
	formProcess := formProcessDefinition createProcess: anOrbeonFormUser.
	formProcess startProcessRoots.
	^formProcess "5430229761"! !

!OrbeonProcessAssignment methodsFor: 'Accessing' stamp: 'BrunoBB 10/14/2014 17:08'!
creationDate

   "Return the value of the instance variable 'creationDate'."
   ^creationDate! !

!OrbeonProcessAssignment methodsFor: 'Updating' stamp: 'BrunoBB 10/14/2014 17:08'!
creationDate: newValue

   "Modify the value of the instance variable 'creationDate'."
   creationDate := newValue! !

!OrbeonProcessAssignment methodsFor: 'Accessing' stamp: 'BrunoBB 10/14/2014 17:08'!
creator

   "Return the value of the instance variable 'creator'."
   ^creator! !

!OrbeonProcessAssignment methodsFor: 'Updating' stamp: 'BrunoBB 10/14/2014 17:08'!
creator: newValue

   "Modify the value of the instance variable 'creator'."
   creator := newValue! !

!OrbeonProcessAssignment methodsFor: 'other' stamp: 'BrunoBB 10/14/2014 17:08'!
creatorName
	
	creator ifNil: [^''].

	^creator username! !

!OrbeonProcessAssignment methodsFor: 'other' stamp: 'BrunoBB 10/14/2014 17:08'!
executedTransitions

	^formProcess executedTransitions! !

!OrbeonProcessAssignment methodsFor: 'Accessing' stamp: 'BrunoBB 10/14/2014 17:08'!
formProcess

   "Return the value of the instance variable 'formProcess'."
   ^formProcess! !

!OrbeonProcessAssignment methodsFor: 'Updating' stamp: 'BrunoBB 10/14/2014 17:08'!
formProcess: newValue

   "Modify the value of the instance variable 'formProcess'."
   formProcess := newValue! !

!OrbeonProcessAssignment methodsFor: 'Accessing' stamp: 'BrunoBB 10/14/2014 17:08'!
formProcessDefinition

   "Return the value of the instance variable 'formProcessDefinition'."
   ^formProcessDefinition! !

!OrbeonProcessAssignment methodsFor: 'Updating' stamp: 'BrunoBB 10/14/2014 17:08'!
formProcessDefinition: newValue

   "Modify the value of the instance variable 'formProcessDefinition'."
   formProcessDefinition := newValue! !

!OrbeonProcessAssignment methodsFor: 'Updating' stamp: 'BrunoBB 11/21/2014 05:13'!
getFormNames

	^self getTransitions collect: [:each | each endFormName]! !

!OrbeonProcessAssignment methodsFor: 'Updating' stamp: 'BrunoBB 11/21/2014 05:11'!
getTransitions
	| transitions |

	transitions := OrderedCollection new.
	orbeonFormUsers do: [:each | transitions addAll: (formProcess getTransitionsOfUserNamed: each username)].

	^transitions! !

!OrbeonProcessAssignment methodsFor: 'other' stamp: 'BrunoBB 10/14/2014 17:08'!
hasStarted

	^formProcess notNil! !

!OrbeonProcessAssignment methodsFor: 'other' stamp: 'BrunoBB 02/02/2015 05:37'!
hasSubprocesses

	^formProcess hasSubprocesses! !

!OrbeonProcessAssignment methodsFor: 'other' stamp: 'BrunoBB 11/21/2014 05:02'!
hasUserNamed: aString

	^orbeonFormUsers anySatisfy: [:each | each username = aString]! !

!OrbeonProcessAssignment methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 14:05'!
initialize

	super initialize.

	orbeonFormUsers := OrderedCollection new.
	creationDate := TimeStamp now.
	canUnassign := true.! !

!OrbeonProcessAssignment methodsFor: 'other' stamp: 'BrunoBB 10/17/2015 17:05'!
isFinished

	^formProcess finished! !

!OrbeonProcessAssignment methodsFor: 'other' stamp: 'BrunoBB 06/13/2015 17:56'!
isInCorruptedState

	^formProcess isInCorruptedState! !

!OrbeonProcessAssignment methodsFor: 'other' stamp: 'BrunoBB 07/21/2015 13:23'!
isInEndTransition

	^formProcess isInEndTransition! !

!OrbeonProcessAssignment methodsFor: 'Accessing' stamp: 'BrunoBB 10/14/2014 17:08'!
orbeonFormUsers

   "Return the value of the instance variable 'orbeonFormUsers'."
   ^orbeonFormUsers! !

!OrbeonProcessAssignment methodsFor: 'Updating' stamp: 'BrunoBB 10/14/2014 17:08'!
orbeonFormUsers: newValue

   "Modify the value of the instance variable 'orbeonFormUsers'."
   orbeonFormUsers := newValue! !

!OrbeonProcessAssignment methodsFor: 'other' stamp: 'BrunoBB 05/31/2015 15:00'!
printAssignmentDate

	^assignmentDate printString! !

!OrbeonProcessAssignment methodsFor: 'Updating' stamp: 'BrunoBB 06/10/2015 15:45'!
printFormNames
	| formsNames |

	formsNames := ''.
	self getFormNames do: [:each | formsNames := formsNames, each, ' | '].

	formsNames notEmpty ifTrue: [formsNames := formsNames allButLast: 3].

	^formsNames! !

!OrbeonProcessAssignment methodsFor: 'other' stamp: 'BrunoBB 05/31/2015 15:50'!
printProcessState

	^formProcess printProcessState! !

!OrbeonProcessAssignment methodsFor: 'other' stamp: 'BrunoBB 10/14/2014 17:08'!
printRunningTransitions

	^formProcess printRunningTransitions! !

!OrbeonProcessAssignment methodsFor: 'other' stamp: 'BrunoBB 10/14/2014 17:08'!
processId

	formProcess ifNotNil: [^formProcess processId].

	^formProcessDefinition processId! !

!OrbeonProcessAssignment methodsFor: 'other' stamp: 'BrunoBB 09/28/2015 13:26'!
processName

	^formProcessDefinition name! !

!OrbeonProcessAssignment methodsFor: 'user assign' stamp: 'BrunoBB 10/14/2014 17:08'!
removeUsers

	orbeonFormUsers do: [:each| each untake: self].! !

!OrbeonProcessAssignment methodsFor: 'other' stamp: 'BrunoBB 10/14/2014 17:08'!
runningTransitions

	^formProcess runningTransitions! !

!OrbeonProcessAssignment methodsFor: 'other' stamp: 'BrunoBB 02/02/2015 05:42'!
subProcesses

	^formProcess subProcesses! !

!OrbeonProcessAssignment methodsFor: 'user assign' stamp: 'BrunoBB 10/14/2014 17:08'!
unassign: anOrbeonFormUser

	assignmentDate := nil.
	formProcess removeAssignment: self.
 	^orbeonFormUsers remove: anOrbeonFormUser ifAbsent: []! !

!OrbeonProcessAssignment methodsFor: 'other' stamp: 'BrunoBB 06/12/2015 15:23'!
version

	^formProcess version! !

OrbeonObject subclass: #OrbeonProcessRole
	instanceVariableNames: 'name orbeonFormUsers formProcessDefintions transitions isAdmin orbeonApplication'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!OrbeonProcessRole commentStamp: 'BrunoBB 09/16/2014 06:50' prior: 0!
This class represent different roles in the form processes.

name 								- name of the rol
orbeonFormUsers 			- collection of users that have this role.
formProcessDefintions		- process definitions associated with this role.
transitions 						- transition definitions associated with this role.
isAdmin							- whether or not the receiver is admin (true - state worker, false - citizen).!

OrbeonProcessRole subclass: #OrbeonFormBackofficeRole
	instanceVariableNames: ''
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!OrbeonFormBackofficeRole class methodsFor: 'other' stamp: 'BrunoBB 09/17/2014 05:30'!
cache

	Cache ifNil: [Cache := Dictionary new].

	^Cache! !

!OrbeonFormBackofficeRole class methodsFor: 'other' stamp: 'BrunoBB 09/16/2014 11:48'!
cache: aDictionary

	Cache := aDictionary! !

!OrbeonFormBackofficeRole methodsFor: 'other' stamp: 'BrunoBB 09/17/2014 06:22'!
asBackofficeRole

	^self! !

!OrbeonFormBackofficeRole methodsFor: 'other' stamp: 'BrunoBB 09/17/2014 06:19'!
asNormalRole

	^OrbeonFormRole new
		name: name;
		isAdmin: isAdmin;
		orbeonApplication: orbeonApplication;
		yourself! !

!OrbeonFormBackofficeRole methodsFor: 'other' stamp: 'BrunoBB 09/16/2014 06:40'!
isBackofficeRole

	^true! !

!OrbeonFormBackofficeRole methodsFor: 'other' stamp: 'BrunoBB 10/13/2014 16:41'!
isBackofficeUserAndAdmin

	^isAdmin! !

OrbeonProcessRole subclass: #OrbeonFormRole
	instanceVariableNames: ''
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!OrbeonFormRole class methodsFor: 'other' stamp: 'BrunoBB 09/17/2014 05:30'!
cache

	Cache ifNil: [Cache := Dictionary new].

	^Cache! !

!OrbeonFormRole class methodsFor: 'other' stamp: 'BrunoBB 09/16/2014 11:49'!
cache: aDictionary

	Cache := aDictionary! !

!OrbeonFormRole class methodsFor: 'other' stamp: 'BrunoBB 09/25/2015 13:38'!
getNewRoleOrNamed: aString in: anOrbeonApplication

	^(self getRolsInApp: anOrbeonApplication) 
		detect: [:each | each name = aString] 
		ifNone: [(OrbeonFormRole new name: aString)
					orbeonApplication: anOrbeonApplication;
					addToCacheIn: anOrbeonApplication;
					yourself]! !

!OrbeonFormRole class methodsFor: 'other' stamp: 'BrunoBB 12/29/2014 05:28'!
hasRoleNamed: aString in: anOrbeonApplication

	^((self getRolsInApp: anOrbeonApplication) select: [:each | each name = aString]) notEmpty! !

!OrbeonFormRole methodsFor: 'other' stamp: 'BrunoBB 09/17/2014 06:18'!
asBackofficeRole

	^OrbeonFormBackofficeRole new
		name: name;
		isAdmin: isAdmin;
		orbeonApplication: orbeonApplication;
		yourself! !

!OrbeonFormRole methodsFor: 'other' stamp: 'BrunoBB 09/17/2014 06:22'!
asNormalRole

	^self! !

!OrbeonProcessRole class methodsFor: 'other' stamp: 'BrunoBB 03/07/2015 06:11'!
getAllRoles
	| allRols |

	allRols := OrderedCollection new.

	(OrbeonFormRole cache asOrderedCollection, OrbeonFormBackofficeRole cache asOrderedCollection) 
	do: [:each | allRols addAll: each].

	^allRols! !

!OrbeonProcessRole class methodsFor: 'other' stamp: 'BrunoBB 12/01/2014 16:26'!
getRoleNamed: aString

	^self getAllRoles detect: [:each | each name = aString] ifNone: [nil]! !

!OrbeonProcessRole class methodsFor: 'other' stamp: 'BrunoBB 12/01/2014 16:28'!
getRolsInApp: anOrbeonApplication

	^self getAllRoles select: [:each | each orbeonApplication == anOrbeonApplication]! !

!OrbeonProcessRole class methodsFor: 'other' stamp: 'BrunoBB 12/18/2014 08:13'!
getRolsInAppName: appName

	^self getAllRoles select: [:each | each orbeonApplication app = appName]! !

!OrbeonProcessRole class methodsFor: 'other' stamp: 'BrunoBB 09/17/2014 10:53'!
initializeAllRols

	self cache do: [:usrDict | usrDict do: [:each | each removeAllUsers]]! !

!OrbeonProcessRole class methodsFor: 'other' stamp: 'BrunoBB 09/16/2014 11:48'!
initializeCache

	self cache: Dictionary new! !

!OrbeonProcessRole class methodsFor: 'other' stamp: 'BrunoBB 09/16/2014 06:50'!
newNamed: aString

	^super new initialize
			name: aString;
			yourself! !

!OrbeonProcessRole methodsFor: 'other' stamp: 'BrunoBB 03/07/2015 06:15'!
addToCacheIn: anOrbeonApplication

	orbeonApplication := anOrbeonApplication.

	^self addToCacheInAppName: anOrbeonApplication app! !

!OrbeonProcessRole methodsFor: 'other' stamp: 'BrunoBB 03/07/2015 06:16'!
addToCacheInAppName: aString

	orbeonApplication := OrbeonApplication applicationNamed: aString.

	(self class cache includesKey: aString) ifFalse: [self class cache at: aString put: OrderedCollection new].

	^(self class cache at: aString) add: self! !

!OrbeonProcessRole methodsFor: 'other' stamp: 'BrunoBB 09/16/2014 06:50'!
addUser: anOrbeonFormUser

	anOrbeonFormUser addRole: self.

	^orbeonFormUsers at: anOrbeonFormUser username put: anOrbeonFormUser! !

!OrbeonProcessRole methodsFor: 'other' stamp: 'BrunoBB 12/01/2014 05:01'!
canDelete

	^transitions isEmpty! !

!OrbeonProcessRole methodsFor: 'Accessing' stamp: 'BrunoBB 09/16/2014 06:50'!
formProcessDefintions

   "Return the value of the instance variable 'formProcessDefintions'."
   ^formProcessDefintions! !

!OrbeonProcessRole methodsFor: 'Updating' stamp: 'BrunoBB 09/16/2014 06:50'!
formProcessDefintions: newValue

   "Modify the value of the instance variable 'formProcessDefintions'."
   formProcessDefintions := newValue! !

!OrbeonProcessRole methodsFor: 'other' stamp: 'BrunoBB 09/16/2014 06:50'!
grant: anOrbeonFormTransitionDefinition

	^transitions add: anOrbeonFormTransitionDefinition! !

!OrbeonProcessRole methodsFor: 'other' stamp: 'BrunoBB 09/16/2014 06:50'!
hasOrbeonApplication

	^orbeonApplication notNil! !

!OrbeonProcessRole methodsFor: 'other' stamp: 'BrunoBB 09/16/2014 06:50'!
includesUser: anOrbeonFormUser

	^orbeonFormUsers includesKey: anOrbeonFormUser username! !

!OrbeonProcessRole methodsFor: 'other' stamp: 'BrunoBB 09/16/2014 06:50'!
initialize

	super initialize.

	name := ''.
	orbeonFormUsers := Dictionary new.
	formProcessDefintions := Dictionary new.
	transitions := OrderedCollection new.
	isAdmin := false.! !

!OrbeonProcessRole methodsFor: 'Accessing' stamp: 'BrunoBB 09/16/2014 06:50'!
isAdmin

   "Return the value of the instance variable 'isAdmin'."
   ^isAdmin! !

!OrbeonProcessRole methodsFor: 'Updating' stamp: 'BrunoBB 09/16/2014 06:50'!
isAdmin: newValue

   "Modify the value of the instance variable 'isAdmin'."
   isAdmin := newValue! !

!OrbeonProcessRole methodsFor: 'other' stamp: 'BrunoBB 09/16/2014 06:50'!
isBackofficeRole

	^false! !

!OrbeonProcessRole methodsFor: 'other' stamp: 'BrunoBB 09/16/2014 07:18'!
isBackofficeRole: aBoolean! !

!OrbeonProcessRole methodsFor: 'other' stamp: 'BrunoBB 10/13/2014 16:41'!
isBackofficeUserAndAdmin

	^false! !

!OrbeonProcessRole methodsFor: 'Accessing' stamp: 'BrunoBB 09/16/2014 06:50'!
name

   "Return the value of the instance variable 'name'."
   ^name! !

!OrbeonProcessRole methodsFor: 'Updating' stamp: 'BrunoBB 09/16/2014 06:50'!
name: newValue

   "Modify the value of the instance variable 'name'."
   name := newValue! !

!OrbeonProcessRole methodsFor: 'Accessing' stamp: 'BrunoBB 09/16/2014 06:50'!
orbeonApplication

   "Return the value of the instance variable 'orbeonApplication'."
   ^orbeonApplication! !

!OrbeonProcessRole methodsFor: 'Updating' stamp: 'BrunoBB 09/16/2014 06:50'!
orbeonApplication: newValue

   "Modify the value of the instance variable 'orbeonApplication'."
   orbeonApplication := newValue! !

!OrbeonProcessRole methodsFor: 'Accessing' stamp: 'BrunoBB 09/16/2014 06:50'!
orbeonFormUsers

   "Return the value of the instance variable 'orbeonFormUsers'."
   ^orbeonFormUsers! !

!OrbeonProcessRole methodsFor: 'Updating' stamp: 'BrunoBB 09/16/2014 06:50'!
orbeonFormUsers: newValue

   "Modify the value of the instance variable 'orbeonFormUsers'."
   orbeonFormUsers := newValue! !

!OrbeonProcessRole methodsFor: 'other' stamp: 'BrunoBB 09/17/2014 06:07'!
printApplicationName

	orbeonApplication ifNil: [^'n/a'].

	^orbeonApplication app! !

!OrbeonProcessRole methodsFor: 'other' stamp: 'BrunoBB 09/16/2014 06:50'!
register: anOrbeonFormProcessDefinition

	^formProcessDefintions at: anOrbeonFormProcessDefinition processId put: anOrbeonFormProcessDefinition! !

!OrbeonProcessRole methodsFor: 'other' stamp: 'BrunoBB 09/16/2014 06:50'!
removeAllUsers

	orbeonFormUsers do: [:each | each removeRole: self].

	orbeonFormUsers := Dictionary new.! !

!OrbeonProcessRole methodsFor: 'other' stamp: 'BrunoBB 09/17/2014 05:33'!
removeFromCacheIn: anOrbeonApplication

	^self removeFromCacheInAppName: anOrbeonApplication app! !

!OrbeonProcessRole methodsFor: 'other' stamp: 'BrunoBB 10/26/2014 16:00'!
removeFromCacheInAppName: aString

	(self class cache includesKey: aString) ifFalse: [^NoSuchObjectInCacheException signal].

	^(self class cache at: aString) remove: self ifAbsent: [^NoSuchObjectInCacheException signal]! !

!OrbeonProcessRole methodsFor: 'other' stamp: 'BrunoBB 09/16/2014 06:50'!
removeUser: anOrbeonFormUser

	anOrbeonFormUser removeRole: self.

	^orbeonFormUsers removeKey: anOrbeonFormUser username ifAbsent: []! !

!OrbeonProcessRole methodsFor: 'Accessing' stamp: 'BrunoBB 09/16/2014 06:50'!
transitions

   "Return the value of the instance variable 'transitions'."
   ^transitions! !

!OrbeonProcessRole methodsFor: 'Updating' stamp: 'BrunoBB 09/16/2014 06:50'!
transitions: newValue

   "Modify the value of the instance variable 'transitions'."
   transitions := newValue! !

!OrbeonProcessRole methodsFor: 'other' stamp: 'BrunoBB 09/16/2014 06:50'!
ungrant: anOrbeonFormTransitionDefinition

	^transitions remove: anOrbeonFormTransitionDefinition! !

!OrbeonProcessRole methodsFor: 'other' stamp: 'BrunoBB 09/16/2014 06:50'!
unregister: anOrbeonFormProcessDefinition

	^formProcessDefintions removeKey: anOrbeonFormProcessDefinition processId ifAbsent: []! !

!OrbeonProcessRole methodsFor: 'other' stamp: 'BrunoBB 09/16/2014 06:50'!
unregisterAll

	formProcessDefintions := Dictionary new.
	transitions := OrderedCollection new.! !

OrbeonObject subclass: #OrbeonTransition
	instanceVariableNames: 'definition timeStamp state process description endTimeStamp parentTransition parentGateway triggeredGateway'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

OrbeonTransition subclass: #OrbeonFormTransition
	instanceVariableNames: 'orbeonFormInstance formId orbeonFormValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!OrbeonFormTransition methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 13:36'!
doesNotUnderstand: aMessageDescriptor
	"May be the message was sent to the Orbeon Form not the receiver.
	If the form instance has a field named equal to the message sent then answer it's value"

	self hasForm ifFalse: [^super doesNotUnderstand: aMessageDescriptor].
	^(orbeonFormInstance hasFieldNamed: aMessageDescriptor selector)
	ifTrue: [orbeonFormInstance valueAt: aMessageDescriptor selector asString]
	ifFalse: [super doesNotUnderstand: aMessageDescriptor]! !

!OrbeonFormTransition methodsFor: 'other' stamp: 'BrunoBB 04/23/2015 05:42'!
evaluateRuntimeCondition: anOFRuntimeCondition
	| evaluation |

	evaluation := anOFRuntimeCondition evaluateIn: process form: orbeonFormInstance.

	evaluation hasException 
	ifTrue: [(OrbeonFailedEvaluation object: self exception: evaluation exception condition: anOFRuntimeCondition conditionString) addToCache].
	
	^evaluation result! !

!OrbeonFormTransition methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 13:36'!
formDefinition
	"Answer the form of the receiver <anOrbeonFormDefinition> "

	^definition endNode formDefinition! !

!OrbeonFormTransition methodsFor: 'Accessing' stamp: 'BrunoBB 02/06/2015 13:36'!
formId

   "Return the value of the instance variable 'formId'."
   ^formId! !

!OrbeonFormTransition methodsFor: 'Updating' stamp: 'BrunoBB 02/06/2015 13:36'!
formId: newValue

   "Modify the value of the instance variable 'formId'."
   formId := newValue! !

!OrbeonFormTransition methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 13:36'!
formSummaryFields
	"Answer the form of the receiver <anOrbeonFormDefinition> "

	^self formDefinition summaryFields! !

!OrbeonFormTransition methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 13:36'!
generateFormId

	formId ifNotNil: [^formId].

	^formId := UUID new asString! !

!OrbeonFormTransition methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 13:36'!
getOrbeonFormId

	^orbeonFormInstance id! !

!OrbeonFormTransition methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 13:36'!
getSummaryFieldsValues
	"Answer a dictionary with the values of the summary fields.
	Key (field name) >> Value (valu of the field)"
	| values |

	values := Dictionary new.
	self hasForm ifFalse: [^values].
	self formSummaryFields do: [:each | values at: each put: (self getValueOfFormField: each)].

	^values! !

!OrbeonFormTransition methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 13:36'!
getUserName

	orbeonFormInstance ifNil: [^''].

	^orbeonFormInstance valueAt: 'username'! !

!OrbeonFormTransition methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 13:36'!
getValueOfFormField: fieldName
	"Answer the value of the field named <fieldName>"

	^orbeonFormInstance valueAt: fieldName! !

!OrbeonFormTransition methodsFor: 'previous fields' stamp: 'BrunoBB 03/06/2015 08:44'!
getValueOfProcessField: fieldName
	"Answer the first value of a field named <fieldName> in the receiver parent chain.
	If two different transitions has the same field then it will answer the field of the transition more close to the receiver"

	parentTransition ifNil: [^nil].

	^(parentTransition getValueOfFormField: fieldName) "try to get <fieldName> from parent transition"
		ifNil: [parentTransition getValueOfProcessField: fieldName] "if nil - repeat the process with parent transition"
		ifNotNil: [:fieldValue | fieldValue] "when found the field answer it's value"! !

!OrbeonFormTransition methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 13:36'!
hasExpectedResult

	^definition hasExpectedResult! !

!OrbeonFormTransition methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 13:36'!
hasForm

	^orbeonFormInstance notNil! !

!OrbeonFormTransition methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 13:36'!
hasFormId

	^formId notNil! !

!OrbeonFormTransition methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 13:36'!
hasValidForm

	orbeonFormInstance ifNil: [^false].

	^orbeonFormInstance isValid! !

!OrbeonFormTransition methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 14:05'!
initialize

	super initialize.

	formId := nil.
	timeStamp := TimeStamp now.
	state := #created.
	
"#created
#processing
#paused
#pending
#delayed
#done"! !

!OrbeonFormTransition methodsFor: 'other' stamp: 'BrunoBB 04/21/2015 05:06'!
isFormTransition

	^true! !

!OrbeonFormTransition methodsFor: 'Accessing' stamp: 'BrunoBB 02/06/2015 13:36'!
orbeonFormInstance

   "Return the value of the instance variable 'orbeonFormInstance'."
   ^orbeonFormInstance! !

!OrbeonFormTransition methodsFor: 'Updating' stamp: 'BrunoBB 07/21/2015 05:17'!
orbeonFormInstance: anOrbeonFormInstance
   "Modify the value of the instance variable 'orbeonFormInstance'."

	self processing. "the receiver is being edited because orbeon has sent an updated xml of the form associate with the receiver."
   orbeonFormInstance := anOrbeonFormInstance.

	"now the form can see the process transition and viceversa"
	anOrbeonFormInstance notNil ifTrue: [orbeonFormInstance externalOwner: self]! !

!OrbeonFormTransition methodsFor: 'Accessing' stamp: 'BrunoBB 02/06/2015 13:36'!
orbeonFormValues

   "Return the value of the instance variable 'orbeonFormValues'."
   ^orbeonFormValues! !

!OrbeonFormTransition methodsFor: 'Updating' stamp: 'BrunoBB 02/06/2015 13:36'!
orbeonFormValues: newValue

   "Modify the value of the instance variable 'orbeonFormValues'."
   orbeonFormValues := newValue! !

!OrbeonFormTransition methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 13:36'!
orbeonInstanceId

	^orbeonFormInstance id! !

!OrbeonFormTransition methodsFor: 'previous fields' stamp: 'BrunoBB 06/13/2015 17:46'!
previousFieldValues
	"Answer aDictionary where the keys are the names of the fields of the Previous(parent) Transition, and the values are the values of each field in the previous transition"
	| previousFieldValues |

	previousFieldValues := Dictionary new.
	definition previousFields do: [:each | 
		previousFieldValues at: each put: (self getValueOfProcessField: each)].

	^previousFieldValues! !

!OrbeonFormTransition methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 13:36'!
printExpectedResult

	^definition printExpectedResult! !

!OrbeonFormTransition methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 14:14'!
printExpectedResultSummary
	| formDifference comparision summaryString ok error |

	formDifference := FormInstanceComparator formOne: orbeonFormInstance.
	comparision := formDifference buildSummaryWith: definition expectedResult.
	ok := (((comparision select: [:each | each isEqual]) size) * 100) / comparision size.
	error := (((comparision select: [:each | each isNotEqual]) size) * 100) / comparision size.
	

	summaryString := 'OK - ', (ok asScaledDecimal: 2) printString, '%', String lf, 
		'Error - ', (error asScaledDecimal: 2) printString, '%', String lf.

	^summaryString, (formDifference showSummaryWith: definition expectedResult)! !

!OrbeonFormTransition methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 13:36'!
printFormNameForWebButton
	| webDetails |

	webDetails := self printFormLargeNameForWebButton.

	(webDetails size > 23) ifFalse: [^webDetails].

	^(webDetails first: 22), '_'! !

!OrbeonFormTransition methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 13:36'!
serviceIds

	^Dictionary new
		at: 'formid' put: formId;
		yourself! !

!OrbeonFormTransition methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 13:36'!
summaryTitle

	^'Form Summary'! !

OrbeonTransition subclass: #OrbeonGatewayTransition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!OrbeonGatewayTransition methodsFor: 'other' stamp: 'BrunoBB 06/03/2015 16:26'!
getSummaryFieldsValues
	"Answer a dictionary with the values of the summary fields.
	Key (field name) >> Value (valu of the field)"

	^Dictionary new! !

!OrbeonGatewayTransition methodsFor: 'other' stamp: 'BrunoBB 06/02/2015 07:20'!
getUserName

	^'Gateway'! !

!OrbeonGatewayTransition methodsFor: 'other' stamp: 'BrunoBB 05/14/2015 06:48'!
orbeonFormInstance
	"Used for evaluation purpose, always return an error --> the evaluation is made with the whole process"

	^nil! !

!OrbeonGatewayTransition methodsFor: 'other' stamp: 'BrunoBB 06/02/2015 07:21'!
startFormName

	^'Gateway'! !

!OrbeonGatewayTransition methodsFor: 'other' stamp: 'BrunoBB 06/02/2015 07:22'!
summaryTitle

	^'Gateway Summary'! !

OrbeonTransition subclass: #OrbeonSubProcessTransition
	instanceVariableNames: 'subProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!OrbeonSubProcessTransition methodsFor: 'other' stamp: 'BrunoBB 03/14/2015 08:17'!
getSummaryFieldsValues
	"Answer a dictionary with the values of the summary fields of the last executed transition of the receiver's subprocess.
	Key (field name) >> Value (valu of the field)"
	| values lastSubProcTranstion |

	values := Dictionary new.
	self subProcessHasExecutedTransitions ifFalse: [^values].

	lastSubProcTranstion := self subProcessGetLastExecutedTransition.

	lastSubProcTranstion hasForm ifFalse: [^values].

	lastSubProcTranstion formSummaryFields do: [:each | values at: each put: (lastSubProcTranstion getValueOfFormField: each)].

	^values! !

!OrbeonSubProcessTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 17:06'!
getUserName

	^'-'! !

!OrbeonSubProcessTransition methodsFor: 'other' stamp: 'BrunoBB 02/01/2015 13:19'!
hasExpectedResult

	^false! !

!OrbeonSubProcessTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 05:23'!
hasForm

	^false! !

!OrbeonSubProcessTransition methodsFor: 'other' stamp: 'BrunoBB 02/02/2015 04:32'!
isSubprocessTransition

	^true! !

!OrbeonSubProcessTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 17:05'!
printFormNameForWebButton
	| webDetails |

	webDetails := (process indexOfTransition: self) printString, '. ', '@ [', subProcess name, ']'.

	(webDetails size > 23) ifFalse: [^webDetails].

	^(webDetails first: 22), '_'! !

!OrbeonSubProcessTransition methodsFor: 'other' stamp: 'BrunoBB 02/01/2015 13:17'!
setFormExternalOwner

	^self! !

!OrbeonSubProcessTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 17:06'!
startFormName

	^'Sub Process'! !

!OrbeonSubProcessTransition methodsFor: 'Accessing' stamp: 'BrunoBB 01/30/2015 15:29'!
subProcess

   "Return the value of the instance variable 'subProcess'."
   ^subProcess! !

!OrbeonSubProcessTransition methodsFor: 'Updating' stamp: 'BrunoBB 01/30/2015 15:29'!
subProcess: newValue

   "Modify the value of the instance variable 'subProcess'."
   subProcess := newValue! !

!OrbeonSubProcessTransition methodsFor: 'other' stamp: 'BrunoBB 03/14/2015 07:39'!
subProcessGetLastExecutedTransition

	^subProcess getLastExecutedTransition! !

!OrbeonSubProcessTransition methodsFor: 'other' stamp: 'BrunoBB 03/14/2015 07:38'!
subProcessHasExecutedTransitions

	^subProcess hasExecutedTransitions! !

!OrbeonSubProcessTransition methodsFor: 'other' stamp: 'BrunoBB 02/02/2015 04:59'!
summaryTitle

	^'Subprocess Summary'! !

!OrbeonTransition class methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:22'!
definition: anOrbeonFormTransitionDefinition

	 ^super new initialize
		definition: anOrbeonFormTransitionDefinition;
		yourself! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:18'!
acceptInvalidForm

	^definition acceptInvalidForm! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:18'!
application

	^definition application! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:18'!
applicationName

	^self application app! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:18'!
canCloseAndSend

	self isDone ifTrue: [^false]. "a terminated Transition can NOT be terminated twice"
	self isEndTransition ifTrue: [^false]. "a final Transitin can NOT be terminated"
	self hasForm ifFalse: [^false]. "a Transition with NO form can NOT be terminated"

	self acceptInvalidForm ifFalse: [^self hasValidForm].

	^true! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 04/23/2015 05:42'!
checkRuleFor: anOrbeonFormRole
	| evaluation condition |
	"with no runtime conditions --> the check is possitive -true-"
	self hasRuntimeConditions ifFalse: [^true]. 

	"if there are runtime conditions and the role <anOrbeonFormRole> has no rule to check --> is NOT allowed -is not even a possible [true]-"
	(definition hasRuntimeCondition: anOrbeonFormRole) ifFalse: [^false].

	"if <parentTransition> is nil --> this is a Start Transition --> with NO filled form --> there are NO rules"
	parentTransition ifNil: [^false]. 
	condition := definition runtimeConditionFor: anOrbeonFormRole.
	evaluation := condition evaluateIn: parentTransition process form: parentTransition orbeonFormInstance.

	evaluation hasException 
	ifTrue: [(OrbeonFailedEvaluation object: self exception: evaluation exception condition: condition conditionString) addToCache].

	^evaluation result! !

!OrbeonTransition methodsFor: 'Accessing' stamp: 'BrunoBB 01/30/2015 15:18'!
definition

   "Return the value of the instance variable 'definition'."
   ^definition! !

!OrbeonTransition methodsFor: 'Updating' stamp: 'BrunoBB 01/30/2015 15:18'!
definition: newValue

   "Modify the value of the instance variable 'definition'."
   definition := newValue! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:18'!
delayed

^state := #delayed
"#created
#processing
#paused
#pending
#delayed
#done"! !

!OrbeonTransition methodsFor: 'Accessing' stamp: 'BrunoBB 01/30/2015 15:18'!
description

   "Return the value of the instance variable 'description'."
   ^description! !

!OrbeonTransition methodsFor: 'Updating' stamp: 'BrunoBB 01/30/2015 15:18'!
description: newValue

   "Modify the value of the instance variable 'description'."
   description := newValue! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:18'!
endFormName

	^definition endFormName! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 04/16/2015 06:31'!
endNode

	^definition endNode! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:18'!
endNodeFormDefinition

	^definition endNodeFormDefinition! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 05/03/2015 14:11'!
endNodeIsGateway

	^definition endNodeIsGateway! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:18'!
endNodeIsSubProcess
	"Answer whether or not the <endNode> of the receiver is a Sub Process Node "

	^definition endNodeIsSubProcess! !

!OrbeonTransition methodsFor: 'Accessing' stamp: 'BrunoBB 01/30/2015 15:18'!
endTimeStamp

   "Return the value of the instance variable 'endTimeStamp'."
   ^endTimeStamp! !

!OrbeonTransition methodsFor: 'Updating' stamp: 'BrunoBB 01/30/2015 15:18'!
endTimeStamp: newValue

   "Modify the value of the instance variable 'endTimeStamp'."
   endTimeStamp := newValue! !

!OrbeonTransition methodsFor: 'execution path' stamp: 'BrunoBB 10/15/2015 14:05'!
finalize

	endTimeStamp := TimeStamp now.
	state := #done.
	process finalizeTransition: self.
"#created
#processing
#paused
#pending
#delayed
#done"! !

!OrbeonTransition methodsFor: 'execution path' stamp: 'BrunoBB 05/04/2015 08:01'!
generateNextRunningTransitions
	"The receiver fetch the possibles next transitions to transition definition <anOrbeonFormTransitionDef>.
	1- Ask the path definition for next transitions.
	2- Create a concrete transtition for each definition in 1, and add it as running transitions."
	| newTransitions |

	newTransitions := process generateNextTransitionsFrom: self.

	^newTransitions! !

!OrbeonTransition methodsFor: 'execution path' stamp: 'BrunoBB 03/13/2015 15:15'!
generateNextTransitionsFrom: anOrbeonFormTransition
	"The receiver fetch the possibles next transitions to transition definition <anOrbeonFormTransitionDef>.
	1- Ask the path definition for next transitions.
	2- Create a concrete transtition for each definition in 1, and add it as running transitions."
	| newTransitions |

	newTransitions := process generateNextTransitionsFrom: self.

	^newTransitions! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 06/10/2015 16:18'!
getGrantedRolsNames
	| grantedNames grantedRols |

	grantedNames := ''.
	grantedRols := self grantedRols.
	grantedRols isEmpty ifTrue: [^''].

	 grantedRols do: [:each | grantedNames := grantedNames, each name, ' | '].
	^grantedNames allButLast: 3! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:18'!
getRuntimeStringConditionFor: anOrbeonFormRole

	^definition getRuntimeStringConditionFor: anOrbeonFormRole! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 10/22/2015 14:13'!
getStartConditionsString

	^definition getStartConditionsString! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:19'!
grantedRols

	^definition grantedRols! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 06/02/2015 14:38'!
hasForm

	^false! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:19'!
hasPreviousFields

	^definition hasPreviousFields! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:19'!
hasReadAccess: anOrbeonFormUser
	"Grant <anOrbeonFormRole> access to the receiver"

	^definition hasReadAccess: anOrbeonFormUser! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:19'!
hasRuntimeConditions

	^definition hasRuntimeConditions! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 14:05'!
initialize

	super initialize.

	timeStamp := TimeStamp now.
	state := #created.
	
"#created
#processing
#paused
#pending
#delayed
#done"! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:19'!
isCreated

^state = #created
"#created
#processing
#paused
#pending
#delayed
#done"! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:19'!
isDelayed

^state = #delayed
"#created
#processing
#paused
#pending
#delayed
#done"! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:19'!
isDone

^state = #done
"#created
#processing
#paused
#pending
#delayed
#done"! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:20'!
isEndTransition

	^definition isEndTransition! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 04/21/2015 05:06'!
isFormTransition

	^false! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 04/27/2015 06:19'!
isGatewayBridge
	"Answher whether or not the receiver is a bridge between gateways."

	^definition isGatewayBridge! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:20'!
isGrantedUser: anOrbeonFormUser
	"Answer whether or not the user <anOrbeonFormUser> is granted in the receiver's definition (OrbeonFormTransitionDefinition)"

	self hasRuntimeConditions ifFalse: [^definition isGrantedRole: anOrbeonFormUser].

	^anOrbeonFormUser roles anySatisfy: [:each | self checkRuleFor: each]! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:20'!
isPaused

^state = #paused
"#created
#processing
#paused
#pending
#delayed
#done"! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:20'!
isPending

^state = #pending
"#created
#processing
#paused
#pending
#delayed
#done"! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:20'!
isProcessing

^state = #processing
"#created
#processing
#paused
#pending
#delayed
#done"! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:20'!
isStartTransition

	^definition isStartTransition! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 02/02/2015 04:32'!
isSubprocessTransition

	^false! !

!OrbeonTransition methodsFor: 'Accessing' stamp: 'BrunoBB 05/03/2015 16:15'!
parentGateway
	^parentGateway! !

!OrbeonTransition methodsFor: 'Updating' stamp: 'BrunoBB 05/03/2015 16:15'!
parentGateway: newValue
	parentGateway := newValue! !

!OrbeonTransition methodsFor: 'Accessing' stamp: 'BrunoBB 01/30/2015 15:20'!
parentTransition

   "Return the value of the instance variable 'parentTransition'."
   ^parentTransition! !

!OrbeonTransition methodsFor: 'Updating' stamp: 'BrunoBB 01/30/2015 15:20'!
parentTransition: newValue

   "Modify the value of the instance variable 'parentTransition'."
   parentTransition := newValue! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:20'!
paused

^state := #paused
"#created
#processing
#paused
#pending
#delayed
#done"! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:20'!
pending

^state := #pending
"#created
#processing
#paused
#pending
#delayed
#done"! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:21'!
printFormLargeNameForWebButton

	^(process indexOfTransition: self) printString, '. ', self endFormName capitalized.! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:21'!
printState

	state ifNil: [^'-'].

	^state! !

!OrbeonTransition methodsFor: 'Accessing' stamp: 'BrunoBB 01/30/2015 15:21'!
process

   "Return the value of the instance variable 'process'."
   ^process! !

!OrbeonTransition methodsFor: 'Updating' stamp: 'BrunoBB 01/30/2015 15:21'!
process: newValue

   "Modify the value of the instance variable 'process'."
   process := newValue! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 07/13/2015 14:11'!
processDefinition

	^process definition! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:21'!
processId

	^process processId! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:21'!
processing

^state := #processing
"#created
#processing
#paused
#pending
#delayed
#done"! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 15:21'!
serviceSend: xmlString
	"Orbeon has sent a version of the form to a service that liked the form with the receiver"

	self processing. "the receiver is being edited because orbeon has sent an updated xml of the form associate with the receiver."! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 05/04/2015 15:25'!
setParentGateway: anOrbeonParentTransition

	anOrbeonParentTransition triggeredGateway ifNil: [^self].

	parentGateway := anOrbeonParentTransition triggeredGateway.! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 06/14/2015 14:46'!
startFormName

	^definition startFormName! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 05/03/2015 16:02'!
startNodeIsGateway

	^definition startNodeIsGateway! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 04/10/2015 10:29'!
startNodeIsParallelGateway

	^definition startNodeIsParallelGateway! !

!OrbeonTransition methodsFor: 'Accessing' stamp: 'BrunoBB 01/30/2015 15:22'!
state

   "Return the value of the instance variable 'state'."
   ^state! !

!OrbeonTransition methodsFor: 'Updating' stamp: 'BrunoBB 01/30/2015 15:21'!
state: newValue

   "Modify the value of the instance variable 'state'."
   state := newValue! !

!OrbeonTransition methodsFor: 'other' stamp: 'BrunoBB 02/02/2015 04:58'!
summaryTitle

	^self subclassResponsibility! !

!OrbeonTransition methodsFor: 'Accessing' stamp: 'BrunoBB 01/30/2015 15:22'!
timeStamp

   "Return the value of the instance variable 'timeStamp'."
   ^timeStamp! !

!OrbeonTransition methodsFor: 'Updating' stamp: 'BrunoBB 01/30/2015 15:22'!
timeStamp: newValue

   "Modify the value of the instance variable 'timeStamp'."
   timeStamp := newValue! !

!OrbeonTransition methodsFor: 'Accessing' stamp: 'BrunoBB 05/04/2015 15:23'!
triggeredGateway
	^triggeredGateway! !

!OrbeonTransition methodsFor: 'Updating' stamp: 'BrunoBB 05/04/2015 15:23'!
triggeredGateway: newValue
	triggeredGateway := newValue! !

OrbeonObject subclass: #ProcessAbstractCategory
	instanceVariableNames: 'name processes color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

ProcessAbstractCategory class
	instanceVariableNames: 'cache'!

!ProcessAbstractCategory class methodsFor: 'other' stamp: 'BrunoBB 04/05/2015 14:32'!
cache

	cache ifNil: [self initializeCache].

	^cache! !

!ProcessAbstractCategory class methodsFor: 'other' stamp: 'BrunoBB 07/02/2015 13:34'!
getCategoriesFor: anOrbeonFormUser

	^self getCategoriesForUserNamed: anOrbeonFormUser username! !

!ProcessAbstractCategory class methodsFor: 'other' stamp: 'BrunoBB 07/02/2015 13:34'!
getCategoriesForUserNamed: aString

	^(self cache at: aString ifAbsent: [^OrderedCollection new])
			asSortedCollection: [:a :b | a name <= b name]! !

!ProcessAbstractCategory class methodsFor: 'other' stamp: 'BrunoBB 09/28/2015 13:54'!
getCategory: categoryName forUserNamed: aString

	^(self getCategoriesForUserNamed: aString) detect: [:each | each name = categoryName] ifNone: [^nil]! !

!ProcessAbstractCategory class methodsFor: 'other' stamp: 'BrunoBB 10/03/2014 15:56'!
initializeCache

	cache := Dictionary new.

	^cache! !

!ProcessAbstractCategory methodsFor: 'other' stamp: 'BrunoBB 10/03/2014 15:56'!
add: anOrbeonFormProcess

	^processes add: anOrbeonFormProcess! !

!ProcessAbstractCategory methodsFor: 'Accessing' stamp: 'BrunoBB 10/03/2014 16:00'!
color

   "Return the value of the instance variable 'color'."
   ^color! !

!ProcessAbstractCategory methodsFor: 'Updating' stamp: 'BrunoBB 10/03/2014 16:00'!
color: newValue

   "Modify the value of the instance variable 'color'."
   color := newValue! !

!ProcessAbstractCategory methodsFor: 'other' stamp: 'BrunoBB 09/28/2015 13:50'!
currentProcesses

	^processes reject: [:each | each isInEndTransition]! !

!ProcessAbstractCategory methodsFor: 'other' stamp: 'BrunoBB 09/28/2015 13:50'!
finishedProcesses

	^processes select: [:each | each isInEndTransition]! !

!ProcessAbstractCategory methodsFor: 'other' stamp: 'BrunoBB 10/03/2014 15:56'!
includes: anOrbeonFormProcess

	^processes includes: anOrbeonFormProcess! !

!ProcessAbstractCategory methodsFor: 'other' stamp: 'BrunoBB 10/03/2014 15:56'!
initialize

	super initialize.

	processes := OrderedCollection new.! !

!ProcessAbstractCategory methodsFor: 'Accessing' stamp: 'BrunoBB 10/03/2014 15:56'!
name

   "Return the value of the instance variable 'name'."
   ^name! !

!ProcessAbstractCategory methodsFor: 'Updating' stamp: 'BrunoBB 10/03/2014 15:56'!
name: newValue

   "Modify the value of the instance variable 'name'."
   name := newValue! !

!ProcessAbstractCategory methodsFor: 'Accessing' stamp: 'BrunoBB 10/03/2014 15:56'!
processes

   "Return the value of the instance variable 'processes'."
   ^processes! !

!ProcessAbstractCategory methodsFor: 'Updating' stamp: 'BrunoBB 10/03/2014 15:56'!
processes: newValue

   "Modify the value of the instance variable 'processes'."
   processes := newValue! !

!ProcessAbstractCategory methodsFor: 'other' stamp: 'BrunoBB 10/03/2014 15:56'!
remove: anOrbeonFormProcess

	^processes remove: anOrbeonFormProcess ifAbsent: []! !

ProcessAbstractCategory subclass: #ProcessAllCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

ProcessAbstractCategory subclass: #ProcessDefinitionCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!ProcessDefinitionCategory class methodsFor: 'other' stamp: 'BrunoBB 10/02/2014 11:45'!
getCategoriesFor: appName

	^(self cache includesKey: appName)
		ifTrue: [(self cache at: appName) asOrderedCollection]
		ifFalse: [OrderedCollection new]! !

!ProcessDefinitionCategory class methodsFor: 'other' stamp: 'BrunoBB 09/08/2014 17:46'!
initializeCache

	cache := OrderedCollection new.! !

!ProcessDefinitionCategory methodsFor: 'other' stamp: 'BrunoBB 10/02/2014 16:26'!
addToCacheIn: appName
	| appCache |

	name ifNil: [^self].

	name isEmpty ifTrue: [^self].

	appCache := self class cache at: appName ifAbsentPut: [Dictionary new].

	^appCache at: name put: self! !

ProcessAbstractCategory subclass: #ProcessDynamicCategory
	instanceVariableNames: 'selectMethod selectorBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

ProcessDynamicCategory subclass: #ProcessDefinitionDynamicCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!ProcessDynamicCategory class methodsFor: 'other' stamp: 'BrunoBB 10/09/2014 16:48'!
getCategoriesFor: userName

	^(self cache includesKey: userName)
		ifTrue: [(self cache at: userName) asOrderedCollection]
		ifFalse: [OrderedCollection new]! !

!ProcessDynamicCategory methodsFor: 'other' stamp: 'BrunoBB 10/02/2014 17:24'!
addToCacheIn: username
	| userCache |

	name ifNil: [^self]. username ifNil: [^self].

	name isEmpty ifTrue: [^self].	username isEmpty ifTrue: [^self].

	userCache := self class cache at: username ifAbsentPut: [Dictionary new].

	^userCache at: name put: self! !

!ProcessDynamicCategory methodsFor: 'Accessing' stamp: 'BrunoBB 09/30/2014 16:37'!
selectMethod

   "Return the value of the instance variable 'selectMethod'."
   ^selectMethod! !

!ProcessDynamicCategory methodsFor: 'Updating' stamp: 'BrunoBB 09/30/2014 16:37'!
selectMethod: newValue

   "Modify the value of the instance variable 'selectMethod'."
   selectMethod := newValue! !

!ProcessDynamicCategory methodsFor: 'other' stamp: 'BrunoBB 09/30/2014 16:42'!
selectObjectsFrom: targetCollection

	^targetCollection select: selectorBlock! !

!ProcessDynamicCategory methodsFor: 'Accessing' stamp: 'BrunoBB 10/02/2014 17:25'!
selectorBlock

   "Return the value of the instance variable 'selectorBlock'."
   ^selectorBlock! !

!ProcessDynamicCategory methodsFor: 'Updating' stamp: 'BrunoBB 10/02/2014 17:25'!
selectorBlock: newValue

   "Modify the value of the instance variable 'selectorBlock'."
   selectorBlock := newValue! !

ProcessDynamicCategory subclass: #ProcessInstanceDynamicCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

ProcessAbstractCategory subclass: #ProcessUserCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

ProcessUserCategory subclass: #ProcessDefinitionUserCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

ProcessUserCategory subclass: #ProcessInstanceUserCategory
	instanceVariableNames: 'filterFinishedProcess filterPendingProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!ProcessUserCategory methodsFor: 'other' stamp: 'BrunoBB 10/26/2014 15:55'!
addToCacheIn: username
	| userCache |

	name ifNil: [^CategoryWithNoNameException signal]. 
	username ifNil: [^CategoryWithNoNameException signal].
	name isEmpty ifTrue: [^CategoryWithNoNameException signal].	
	username isEmpty ifTrue: [^CategoryWithNoNameException signal].

	userCache := self class cache at: username ifAbsentPut: [Dictionary new].

	^userCache at: name put: self! !

!ProcessUserCategory methodsFor: 'other' stamp: 'BrunoBB 10/26/2014 15:58'!
removeFromCacheIn: username
	| userCache |

	name ifNil: [^CategoryWithNoNameException signal]. 
	username ifNil: [^CategoryWithNoNameException signal].
	name isEmpty ifTrue: [^CategoryWithNoNameException signal].	
	username isEmpty ifTrue: [^CategoryWithNoNameException signal].

	userCache := self class cache at: username ifAbsent: [^NoSuchObjectInCacheException signal].

	^userCache removeKey: name ifAbsent: [^NoSuchObjectInCacheException signal]! !

OrbeonObject subclass: #ProcessGateway
	instanceVariableNames: 'definition timeStamp state process endTimeStamp incomingTransitions outgoingTransitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

ProcessGateway subclass: #ComplexGateway
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!ComplexGateway commentStamp: 'BrunoBB 04/08/2015 17:48' prior: 0!
(*)
As the name signifies, complex gateways are only used for the most complex flows in the business process. When possible, you should use a simpler gateway to do what needs to be done. If you need multiple gateways to describe the business flow, then that's an ideal case for the complex gateway. Complex gateways need more descriptive text because you're using words in place of symbols.

Splitting: the flow will go down one or more paths depending on the evaluation of a single condition specified for the Gateway. 

Merging: the Gateway synchronizes all incoming paths that meet a single condition specified for the Gateway.!

!ComplexGateway methodsFor: 'other' stamp: 'BrunoBB 05/06/2015 06:28'!
processIncomingTransition: anOrbeonTransition

	super processIncomingTransition: anOrbeonTransition.

	process incomingTransition: anOrbeonTransition onComplexGateway: self.! !

!ComplexGateway methodsFor: 'other' stamp: 'BrunoBB 05/06/2015 06:28'!
processOutgoingTransition: anOrbeonTransition

	process outgoingTransition: anOrbeonTransition onComplexGateway: self.! !

ProcessGateway subclass: #EventBasedGateway
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!EventBasedGateway commentStamp: 'BrunoBB 04/11/2015 16:18' prior: 0!
Splitting: the flow goes down only one of the paths that originate in the Gateway depending on the occurrence of a specified Event. 

Merging: it has the same behavior as the Exclusive Gateway.!

!EventBasedGateway methodsFor: 'other' stamp: 'BrunoBB 04/16/2015 06:16'!
processIncomingTransition: anOrbeonTransition

	super processIncomingTransition: anOrbeonTransition.! !

!EventBasedGateway methodsFor: 'other' stamp: 'BrunoBB 05/03/2015 13:17'!
processOutgoingTransition: anOrbeonTransition

	super processOutgoingTransition: anOrbeonTransition.! !

ProcessGateway subclass: #ExclusiveEventBasedGateway
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!ExclusiveEventBasedGateway commentStamp: 'BrunoBB 04/08/2015 17:48' prior: 0!
An event-based gateway is similar to a exclusive gateway because both involve one path in the flow. In the case of an event-based gateway, however, you are evaluating which event has occurred, not which condition is being met.!

!ExclusiveEventBasedGateway methodsFor: 'other' stamp: 'BrunoBB 04/16/2015 06:16'!
processIncomingTransition: anOrbeonTransition

	super processIncomingTransition: anOrbeonTransition.! !

!ExclusiveEventBasedGateway methodsFor: 'other' stamp: 'BrunoBB 05/03/2015 13:17'!
processOutgoingTransition: anOrbeonTransition

	super processOutgoingTransition: anOrbeonTransition.! !

ProcessGateway subclass: #ExclusiveGateway
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!ExclusiveGateway commentStamp: 'BrunoBB 04/08/2015 17:48' prior: 0!
(X)
An exclusive gateway evaluates the state of the business process andbased on the conditionbreaks the flow into one of the two or more mutually exclusive paths. Remember that the exclusive in "exclusive gateway" stands for mutually exclusive.

Splitting: the flow will go down only one of the paths that originate in the Gateway; the selection will be made after evaluating the conditions defined for the Gateway (there will be one per each path). 

Merging: when multiple paths reach the Gateway, it simply allows the flow to continue without evaluating any conditions or making any synchronization.!

!ExclusiveGateway methodsFor: 'other' stamp: 'BrunoBB 04/16/2015 06:16'!
processIncomingTransition: anOrbeonTransition

	super processIncomingTransition: anOrbeonTransition.

	process incomingTransition: anOrbeonTransition onExclusiveGateway: self.! !

!ExclusiveGateway methodsFor: 'other' stamp: 'BrunoBB 05/04/2015 08:00'!
processOutgoingTransition: anOrbeonTransition

	process outgoingTransition: anOrbeonTransition onExclusiveGateway: self.! !

ProcessGateway subclass: #InclusiveGateway
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!InclusiveGateway commentStamp: 'BrunoBB 04/08/2015 17:48' prior: 0!
(O)
An inclusive gateway breaks the process flow into one or more flows. An example of a inclusive gateway is business actions taken based on survey results.

Splitting: the flow will go down all the outgoing paths that meet the Gateways conditions (there will be one per each path). 

Merging: it synchronizes all the paths where the process flow effectively reaches the gateway.!

!InclusiveGateway methodsFor: 'other' stamp: 'BrunoBB 04/16/2015 06:16'!
processIncomingTransition: anOrbeonTransition

	super processIncomingTransition: anOrbeonTransition.

	process incomingTransition: anOrbeonTransition onInclusiveGateway: self.! !

!InclusiveGateway methodsFor: 'other' stamp: 'BrunoBB 05/04/2015 17:40'!
processOutgoingTransition: anOrbeonTransition

	self incomingTransitionsAreDone
	ifTrue: [outgoingTransitions add: anOrbeonTransition].

	process outgoingTransition: anOrbeonTransition onInclusiveGateway: self.! !

ProcessGateway subclass: #ParallelEventBasedGateway
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!ParallelEventBasedGateway commentStamp: 'BrunoBB 04/08/2015 17:48' prior: 0!
As the name suggest, this gateway is similar to a parallel gateway. It allows for multiple processes to happen at the same time, but unlike the parallel gateway, the processes are event dependent.!

!ParallelEventBasedGateway methodsFor: 'other' stamp: 'BrunoBB 04/16/2015 06:16'!
processIncomingTransition: anOrbeonTransition

	super processIncomingTransition: anOrbeonTransition.! !

!ParallelEventBasedGateway methodsFor: 'other' stamp: 'BrunoBB 05/03/2015 13:17'!
processOutgoingTransition: anOrbeonTransition

	super processOutgoingTransition: anOrbeonTransition.! !

ProcessGateway subclass: #ParallelGateway
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcess'!

!ParallelGateway commentStamp: 'BrunoBB 04/08/2015 17:48' prior: 0!
(+)
A parallel gateway is very different than the previous gateways because you aren't evaluating any condition or event. Instead, parallel gateways are used to represent two concurrent tasks in a business flow.

Splitting: the flow will go down all the paths originated in the Gateway. 

Merging: it synchronizes all the paths that arrive to the Gateway!

!ParallelGateway methodsFor: 'other' stamp: 'BrunoBB 04/10/2015 10:29'!
isParallel

	^true! !

!ParallelGateway methodsFor: 'processing' stamp: 'BrunoBB 04/16/2015 06:17'!
processIncomingTransition: anOrbeonTransition

	super processIncomingTransition: anOrbeonTransition.

	process incomingTransition: anOrbeonTransition onParallelGateway: self.! !

!ParallelGateway methodsFor: 'processing' stamp: 'BrunoBB 05/04/2015 17:04'!
processOutgoingTransition: anOrbeonTransition

	self incomingTransitionsAreDone
	ifTrue: [outgoingTransitions add: anOrbeonTransition].

	process outgoingTransition: anOrbeonTransition onParallelGateway: self.! !

!ProcessGateway class methodsFor: 'other' stamp: 'BrunoBB 04/11/2015 16:20'!
definition: anOrbeonFormTransitionDefinition

	 ^super new initialize
		definition: anOrbeonFormTransitionDefinition;
		yourself! !

!ProcessGateway methodsFor: 'other' stamp: 'BrunoBB 05/04/2015 07:59'!
addOutgoingTransition: anOrbeonTransition

	^outgoingTransitions add: anOrbeonTransition! !

!ProcessGateway methodsFor: 'Accessing' stamp: 'BrunoBB 04/11/2015 16:20'!
definition
	^definition! !

!ProcessGateway methodsFor: 'Updating' stamp: 'BrunoBB 04/11/2015 16:20'!
definition: newValue
	definition := newValue! !

!ProcessGateway methodsFor: 'Accessing' stamp: 'BrunoBB 04/11/2015 16:20'!
endTimeStamp
	^endTimeStamp! !

!ProcessGateway methodsFor: 'Updating' stamp: 'BrunoBB 04/11/2015 16:20'!
endTimeStamp: newValue
	endTimeStamp := newValue! !

!ProcessGateway methodsFor: 'processing' stamp: 'BrunoBB 04/14/2015 04:55'!
gatewayName

	^definition nodeName! !

!ProcessGateway methodsFor: 'processing' stamp: 'BrunoBB 04/30/2015 05:54'!
hasOutgoingTransitions
	"Answer whether or not the receiver has instanciated an outgoing transition"

	^outgoingTransitions notEmpty! !

!ProcessGateway methodsFor: 'Accessing' stamp: 'BrunoBB 04/10/2015 07:01'!
incomingTransitions
	^incomingTransitions! !

!ProcessGateway methodsFor: 'Updating' stamp: 'BrunoBB 04/10/2015 07:01'!
incomingTransitions: newValue
	incomingTransitions := newValue! !

!ProcessGateway methodsFor: 'processing' stamp: 'BrunoBB 04/14/2015 05:25'!
incomingTransitionsAreDone
	"Answer whether or not the receiver has ALL incoming transitions done. Which means that ALL incoming transitions in the definition has been instanciated"
	| inTransitionDefinitions |

	"collect the definitions of all concrete incoming transitions"
	inTransitionDefinitions := incomingTransitions collect: [:each | each definition]. 

	"all <inTransitions> in the definition of the receiver has been instanciated ?"
	^definition inTransitions allSatisfy: [:each | inTransitionDefinitions includes: each]! !

!ProcessGateway methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 14:05'!
initialize

	super initialize.

	timeStamp := TimeStamp now.
	state := #created.
	incomingTransitions := OrderedCollection new.
	outgoingTransitions := OrderedCollection new.! !

!ProcessGateway methodsFor: 'other' stamp: 'BrunoBB 04/21/2015 05:07'!
isFormTransition

	^false! !

!ProcessGateway methodsFor: 'other' stamp: 'BrunoBB 04/16/2015 06:28'!
isGateway

	^true! !

!ProcessGateway methodsFor: 'other' stamp: 'BrunoBB 04/10/2015 10:28'!
isParallel

	^false! !

!ProcessGateway methodsFor: 'Accessing' stamp: 'BrunoBB 04/10/2015 07:01'!
outgoingTransitions
	^outgoingTransitions! !

!ProcessGateway methodsFor: 'Updating' stamp: 'BrunoBB 04/10/2015 07:01'!
outgoingTransitions: newValue
	outgoingTransitions := newValue! !

!ProcessGateway methodsFor: 'Accessing' stamp: 'BrunoBB 04/11/2015 16:20'!
process
	^process! !

!ProcessGateway methodsFor: 'Updating' stamp: 'BrunoBB 04/11/2015 16:20'!
process: newValue
	process := newValue! !

!ProcessGateway methodsFor: 'processing' stamp: 'BrunoBB 05/04/2015 15:23'!
processIncomingTransition: anOrbeonTransition

	anOrbeonTransition triggeredGateway: self.
	incomingTransitions add: anOrbeonTransition.! !

!ProcessGateway methodsFor: 'processing' stamp: 'BrunoBB 05/03/2015 13:16'!
processOutgoingTransition: anOrbeonTransition

	outgoingTransitions add: anOrbeonTransition! !

!ProcessGateway methodsFor: 'Accessing' stamp: 'BrunoBB 04/11/2015 16:20'!
state
	^state! !

!ProcessGateway methodsFor: 'Updating' stamp: 'BrunoBB 04/11/2015 16:20'!
state: newValue
	state := newValue! !

!ProcessGateway methodsFor: 'Accessing' stamp: 'BrunoBB 04/11/2015 16:20'!
timeStamp
	^timeStamp! !

!ProcessGateway methodsFor: 'Updating' stamp: 'BrunoBB 04/11/2015 16:20'!
timeStamp: newValue
	timeStamp := newValue! !

!ProcessGateway methodsFor: 'other' stamp: 'BrunoBB 04/15/2015 06:18'!
waitAllIncomingTransitions
	"Answer whether or not the receiver is going to synchronize incoming transitions.
	The BMPN standart is:
	ParallelGateway, InclusiveGateway --> synchronize: true.
	ExclusiveGateway --> synchronize: false
	ComplexGateway --> synchronize: true/false.

	(but the metamodel it support any combination for any gateway)"

	^definition waitAllIncoming! !
